	subroutine bbfuse
 
c  Calculates beam-beam fusion reactions
C
c	Generalized to arbitrary grid and other than d-d reactions.
c		Greg Hammett, Jan. 14, 1984.
 
C
C   	...COMMON BLOCKS
C
	include 'FPPCOM'
 
	real fiso(0:maxen)
 
c--BBFUSE is not called every time step, figure out what the current
c	time is and add the fusion rate from the shell at the proper
c	time.
	data lastsh/0/
	if(nshe .ne. lastsh)then
	lastsh=nshe
	nbbtim=0
	else
	nbbtim=nbbtim+1
	endif
	bbftim(nbbtim)=timmy(niTime)
 
! calculate beam-beam reactions.  note: This will not work
! for real beam injection.  It is valid for arbitrary f(E), but
! assumes f is isotropic in direction.  It is an O.K. approximation
! if f is an isotropic bulk plus a small anisotropic tail, and will
! get the tail-bulk reaction rate correct, but the anisotropic
! tail-tail reaction rate will be all wrong.
 
! ignore the vanishingly few particles at E=0:
	do 250 i=1,maxen
	avfofe=0
	do 240 j=1,maxxsi
240	avfofe=avfofe+f1(i,j)*qjaca(j)
250	fiso(i)=sqrt(.5)*avfofe*qjace(i)/sqrt(enerev(i))
 
! ignore fusion with the (hopefully) vanishingly few particles at E=0:
	do 270 i=1,maxen
	do 270 k=1,maxen
 
!at very high energies f doesn't always drop to zero, but sometimes
! goes a little negative.  This apparently causes problem in this
! calculation, so we ignore cases where f<0, (equivalent to setting
! f= 0 for f<0).
	if(fiso(i) .le. 0.0 .or. fiso(k) .le. 0.0)go to 270
 
	ehigh=enerev(i)+enerev(k)+2*sqrt(enerev(i)*enerev(k))
	elow=enerev(i)+enerev(k)-2*sqrt(enerev(i)*enerev(k))
 
!interpolate to find bbhigh:
	j1=0
	if(ehigh .gt. 0.0) j1=1+(nbbe-1)
	1	*(alog(ehigh)-alog(bbenev(1)))
	1	/alog(bbenev(nbbe)/bbenev(1))
	if(j1 .gt. nbbe-1)j1=nbbe-1
	if(j1 .lt. 0)j1=0
	bbhigh=BBsVFus(j1)*(bbenev(j1+1)-ehigh)
	1	 +BBsVFus(j1+1)*(ehigh-bbenev(j1))
	bbhigh=bbhigh/(bbenev(j1+1)-bbenev(j1))
 
!interpolate to find bblow:
	j1=0
	if(elow .gt. 0.0) j1=1+(nbbe-1)
	1	*(alog(elow)-alog(bbenev(1)))
	1	/alog(bbenev(nbbe)/bbenev(1))
	if(j1 .gt. nbbe-1)j1=nbbe-1
	if(j1 .lt. 0)j1=0
	bblow=BBsVFus(j1)*(bbenev(j1+1)-elow)
	1	+BBsVFus(j1+1)*(elow-bbenev(j1))
	bblow=bblow/(bbenev(j1+1)-bbenev(j1))
 
!	if(i .eq. 0 .or. k .eq. 0)then
!	rbbint=sigvfu(i+k)
!	else
!	rbbint=(bbhigh-bblow)/sqrt(enerev(i)*enerev(k))
!	endif
! the sqrt(E1*E2) factor above has already been included in fiso.
	rbbint=bbhigh-bblow
 
	delfus=fiso(i)*fiso(k)*rbbint
	bbfrat(nbbtim)=bbfrat(nbbtim)+delfus*dVolfp(nshe)
270	continue
 
	return
	END
