c
c=======================================================================
c   .    1    .    2    .    3    .    4    .    5    .    6    .    7
c=======================================================================
c
      subroutine coefts(w,entor,nperp2)
      include 'SPRINC'
      real rmaj(nchi*npsi),zed(nchi*npsi),hpsi(nchi*npsi),
     %     hchi(nchi*npsi),psi(npsi),chi(nchi),pquad(npsi),pcoef(nchi)
      complex acoef(nchi*npsi),bcoef(nchi*npsi),
     %        ccoef(nchi*npsi),dcoef(nchi*npsi),
     %        ecoef(nchi*npsi),fcoef(nchi*npsi),gcoef(nchi*npsi),
     %        cwork1(nchi*npsi),cwork2(nchi*npsi),
     %        cwork3(nchi*npsi),cwork4(nchi*npsi),
     %        tprpwk,tcrswk,dwnwrk,nprp,nprp2,
     %        ctemp,dtemp,chitmp,psitmp,denom
c
      integer nions      ! number of ion species
      real npar          ! kpar/k0
      real omega         ! twopi* RF_frequency [s-1]
      real bmag          ! local magnetic field
      real dense         ! electron density [m-3]
      real teper         ! perpendicular electron temperature [keV]
      real tepar         ! parallel electron temperature [keV]
      real awi(ionmax)   ! ion atomic mass Ai
      real qi(ionmax)    ! ion charge      Zi
      real densi(ionmax) ! ion density [m-3]
      real tiper(ionmax) ! perpendicular ion temperature [keV]
      real tipar(ionmax) ! parallel ion temperature [keV]
c
      common /plasma_cmn/ npar,omega,bmag,dense,teper,tepar,awi,qi,
     %                    densi,tiper,tipar,nions
c
       integer model(0:ionmax)
       common /switches/model
c
      complex K0,K1,K2,K3,K4,K5,nperp2(nchi*npsi)
      complex K0s(0:ionmax),K1s(0:ionmax),K2s(0:ionmax),K3s(0:ionmax),
     %        K4s(0:ionmax),K5s(0:ionmax)
      common/tensor_cmn/K0s,K1s,K2s,K3s,K4s,K5s
c
c 1986 Fundamental Constants (R.Cohen, B.Taylor,Physics Today,Aug.1991)
c
      real e,me,mp,mu0,eps0,c
      common /kphysic/e,me,mp,c,mu0,eps0
c
      common /metric/ rmaj,zed,hpsi,hchi,psi,chi,pquad,pcoef
     %       /cwork/ cwork1,cwork2,cwork3,cwork4
     %       /coef/ acoef,bcoef,ccoef,dcoef,ako2
     %       /soef/ ecoef,fcoef,gcoef
c
c
c   jphe : 4-apr-1995 levrard true for debug output
c
      logical levrard
      data levrard /.false./
      real dwnzip
      real n2cold
c
c     COEFTS fills the /coef/ block, which contains the plasma dependent
c     coefficients for the differential wave equation, and the /soef/
c     block which contains extra coefficients for finding the electric
c     fields from the solution vector.
c
c dwnzip should be of order sqrt(eps), where eps is the machine
c precision (approx. 1.e-7 on 32-bit machines), because the relative
c roundoff error in (A-B) exceeds sqrt(eps) if the difference between
c A and B is less than sqrt(eps)*(A+B)/2.  I have verified that the results
c are insensitive to factor of 10 variations in the value of dwnzip.
c
c dwnzip based on machine accuracy reported by NAG routine x02aje:
      dwnzip=sqrt(x02aje(zdum))/4 !@ Vax (Single precision)
c@    dwnzip=sqrt(x02ajf(zdum))/4 ! cray (Double precision)
 
      ntot=nchi*npsi
      norigl=nchi
      nbodyf=nchi+1
c
      ako2=(w/c)**2
      omega=w
c
c    m.evrard 15-nov-1994  : model=1 : full tensor, model=0 : first order
c                            model=-1  : cold plasma (Stix)
c
c    We fix it to model=1, not leaving any choice to the average user.
c    When lambda=1/2 kperp rho is less than some 0.001, the code switches
c    itself to the Truncated Tensor to save CPU time. For debugging or
c    comparison purposes, you can change it here.
c
c
      do i=0,ionmax
c   jphe  5-apr-1995   : model(i)=0 for comparison
      model(i)=1
      enddo
c
      do 10 i=1,ntot
      akzt=entor/rmaj(i)
      anzt2=akzt**2/ako2
      npar=akzt*c/w
      jpsi=1+(i-1)/nchi
      ichi=i-(jpsi-1)*nchi
      call plasma(ichi,jpsi)
 
c estimate of nperp**2 for the Alfven wave in a cold plasma:
      n2cold=0.0
      do ii=1,nions
         n2cold=n2cold+densi(ii)*awi(ii)
      enddo
      n2cold=n2cold*1.e-6/7.28**2/(1.e4*bmag)**2
      n2cold=2*(n2cold+abs(npar**2))   ! include npar effects
      call FastWave(nperp2(i),K0,K1,K2,K3,K4,K5,n2cold)
 
c GWH: debug cutoff bugs by forcing exact cutoff at a grid-point:
c      if(i .eq. 2481) then
c         nperp2(i)=0.0
c         call tensor(nperp2(i),K0,K1,K2,K3,K4,K5)
c         write(6,*) 'at i=2481, K1-npar**2, K2 ='
c         write(6,'(3(e20.10,1x,e20.10,/))') K1-npar**2,K2
c         K2=(0.0,1.0)*(K1-npar**2)
c      endif
 
c*******************************************
c GWH: Patch to deal with ill-posed 0/0 near cutoff (nperp**2=0).
c
c Dave Smithe's formulation is somewhat ill-posed at a cutoff.
c In some sense the problem is a purely a numerical annoyance,
c since the solution should be very well-behaved and smooth near
c a cutoff.  He discusses this problem in more detail in:
c
c "Annual Performance Report for DoE Grant DE-FG05-91ER54129",
c MRC/WDC-R-277, written around Feb. 15, 1992, point # 14 on p.5 of
c Appendix C.
c
c There he points out an alternative way to solve for the
c fields at the cuttoff (nperp**2 = 0).  He seems to implement this
c in the fields.f subroutine.  Here in the coefts routine, Dave put
c in a patch in the calculation of dwnwrk to keep it from blowing up.
c I am not a complete expert on this, but this seems to me to be a
c bit arbitrary.  Here I use another option which seems to be
c physically realizable, and consistently applied to all terms:
c
c Cuttoff (nperp**2=0) occurs if Tprp**2+Tpar**2=0, or equivalently if
c
c     K1-npar**2 = -+i*K2
c
c In this case, add a small real part to K1 to avoid hitting the
c cutoff exactly.  This is a physically realizable modification,
c as it is equivalent to just a small (usually) change in npar**2.
c (To be completely consistent, should probably make this change in
c subroutines powers, which also calls tensor, or even inside of tensor
c itself, since that is called by the root finder... I tried this same
c patch in subroutine powers, and it made no observable difference).
c
c Michel Evrard has proposed that the most rigorous way to avoid this
c numerical problem is to go back to solving a vector wave equation
c instead of Smithe's reduced scalar wave equation.  This may be worth
c doing at some point, though the compute time might go up a factor of 8
c (as the banded matrix solve scales as N_psi*N_chi**2 = N**3, and the
c number of equations effectively doubles.)
c
 
      delK1=dwnzip*(cabs(K1)+cabs(K2))
c To turn off my method of adding a small amount to K1, and rely instead
c on Dave Smithe's earlier approach of limiting the denominator,
c uncomment the following line:
c     delK1=0.0
      dwnwrk=-(0.0,1.0)*K2+npar**2
      if(cabs(K1-dwnwrk) .lt. delK1)then
         if(real(K1) .ge. real(dwnwrk)) then
            K1=dwnwrk+delK1
         else
            K1=dwnwrk-delK1
         endif
      endif
 
      dwnwrk=+(0.0,1.0)*K2+npar**2
      if(cabs(K1-dwnwrk) .lt. delK1)then
         if(real(K1) .ge. real(dwnwrk)) then
            K1=dwnwrk+delK1
         else
            K1=dwnwrk-delK1
         endif
      endif
 
c Usually one needs to make only a tiny change to K1 which is
c small compared even to npar**2.  If it isn't, print a warning:
 
      if(delK1 .gt. 0.1*npar**2) then
         write(6,*) 'coefts warning: delK1, npar**2 =',
     &        delk1,npar**2
      endif
 
c GWH: End of cutoff patch.
c*******************************************
 
c
      K4=K4+npar
      denom=1.-K0-(K5**2+K4**2)/(K3-nperp2(i))
c
c  mpe  -- 5-apr-1995  : correct sign of tcrswk
c  jphe -- 4-apr-1995  : no ak02
c
      tprpwk=(K1-npar**2-nperp2(i)*K4**2/(K3-nperp2(i)))/denom
      tcrswk=(0.,-1.)*(K2-nperp2(i)*K4*K5/(K3-nperp2(i)))/denom
c
c to debug the dielectric tensor --- 10-feb-1995 jphe
c
      if (levrard) then
      iprt=i-(i/(20*nchi))*(20*nchi)
      if(iprt.eq.1) then
      open
     & (16,file='usr$usrroot:[transpdev.transp.txtr]totalcoefts.out',
     &  status='old',access='append')
      nprp=sqrt(nperp2(i))
      nprp2=nperp2(i)
      write(16,*)'***************************************************'
      write(16,*)'   psi = ',psi(jpsi)
      write(16,*)'     '
      write(16,*)'   nperp2 = ',nprp2   ,'   kpar = ',akzt
      write(16,*)'   bmag   = ',bmag    ,'  omega = ',w
      write(16,*)'   dense  = ',dense   ,'  tempe = ',teper,tepar
        do idbg=1,nions
      write(16,*)' densD= ',densi(idbg),
     &                           ' tempD= ',tiper(idbg),tipar(idbg)
        enddo
      write(16,*)'     '
	do ii=0,nions
      write(16,*) ' Kxx,Kxy,Kxz  for specie no ',ii
      write(16,*) ' Kyx,Kyy,Kyz '
      write(16,*) ' Kzx,Kzy,Kzz '
      write(16,101)  K1s(ii)      ,K2s(ii)              , K4s(ii)*nprp
      write(16,101) -K2s(ii)      ,K1s(ii)+K0s(ii)*nprp2,-K5s(ii)*nprp
      write(16,101)  K4s(ii)*nprp ,K5s(ii)*nprp         , K3s(ii)
      write(16,*) '  '
  101 format(/5x,1p,2e12.3,2x,1p,2e12.3,2x,1p,2e12.3)
	    enddo
      close (16)
      endif
      endif
 
      dwnwrk=tprpwk**2-tcrswk**2
c
c     ... check to see that denominator isn't exactly zero ...
c     that would mean a cutoff, and that needs special care!
c
      tval=1.+real(tprpwk)**2+aimag(tprpwk)**2+
     %        real(tcrswk)**2+aimag(tcrswk)**2
      dwnval=cabs(dwnwrk)
      if (dwnval.lt.dwnzip*tval) then
         write(6,*) 'coefts warning:'
         write(6,*) 'i,rmaj(i),zed(i), dwnwrk,tprpwk,tcrswk = ',
     %        i,rmaj(i),zed(i)
         write(6,'(3(e20.10,1x,e20.10,/))') dwnwrk,tprpwk,tcrswk
         if (dwnval.eq.0.) then
             dwnwrk=cmplx(dwnzip*tval,0.)
         else
             dwnwrk=dwnwrk*cmplx(dwnzip*tval/dwnval,0.)
         endif
      endif
c
c     ... temporary values for c and dcoef ...
c
      dwnwrk=(1.,0.)/dwnwrk
      ccoef(i)=tprpwk*cmplx(rmaj(i),0.)
      dcoef(i)=(0.,-1.)*tcrswk*cmplx(rmaj(i),0.)
c
c     ... actual values for a,b, and gcoef ...
c
      acoef(i)=tprpwk*dwnwrk
c
c   mpe   5-4-1995    test def of bcoef
c   jphe 31-3-1995    test def of bcoef
c
c    old definition is ok, only tcrswk had the wrong sign
c
       bcoef(i)=(0.,-1.)*tcrswk*dwnwrk
c
c    new definition : ok ? No, see above
c
c     bcoef(i)=(0.,1.)*tcrswk*dwnwrk
   10 gcoef(i)=dwnwrk
c
      call dpsi(ccoef,cwork1)
      call SPRFIL(cwork1,2)
      call dchi(ccoef,cwork2)
      call dpsi(dcoef,cwork3)
      call SPRFIL(cwork3,2)
      call dchi(dcoef,cwork4)
c
      do 20 i=1,ntot
      chitmp=cmplx(hchi(i),0.)
      psitmp=cmplx(hpsi(i),0.)
      ctemp=ccoef(i)
      dtemp=dcoef(i)
c     dwnwrk=(1.,0.)/(ctemp**2+dtemp**2)**2
c
c GWH 8-Jun-1995 patch:
c GWH: At a cutoff (nperp**2=0), dwnwrk goes to infinity.
c For consistency, reuse the patch for this calculated in the
c previous loop...  (I confirmed that this patch was needed in a
c talk with Dave Smith by phone on 13-Oct-1993.  Below is a much
c simpler but equivalent version of the patch I installed in TRANSP
c in 1993, and corrects a bug I accidentally made in the standalone
c version of TRANSP which thankfully never made it to the TRANSP version):
c
      dwnwrk = gcoef(i)**2/rmaj(i)**4
c GWH: End of cutoff patch.
 
      ccoef(i)=dwnwrk*(
     %      (dtemp**2-ctemp**2)*(chitmp*cwork1(i)+psitmp*cwork4(i))
     %     +(2.,0.)*ctemp*dtemp*(psitmp*cwork2(i)-chitmp*cwork3(i)))
      dcoef(i)=dwnwrk*(
     %      (dtemp**2-ctemp**2)*(psitmp*cwork2(i)-chitmp*cwork3(i))
     %     -(2.,0.)*ctemp*dtemp*(psitmp*cwork4(i)+chitmp*cwork1(i)))
      ecoef(i)=dwnwrk*(-ctemp*(chitmp*cwork1(i)+psitmp*cwork4(i))
     %                   +dtemp*(psitmp*cwork2(i)-chitmp*cwork3(i)))
   20 fcoef(i)=dwnwrk*( ctemp*(psitmp*cwork2(i)-chitmp*cwork3(i))
     %                   +dtemp*(psitmp*cwork4(i)+chitmp*cwork1(i)))
c
      do 30 i=1,ntot
   30 cwork1(i)=cmplx(hchi(i)/hpsi(i),0.)
      call dpsi(cwork1,cwork3)
      call SPRFIL(cwork3,2)
      do 31 i=1,ntot
   31 cwork3(i)=cwork3(i)*acoef(i)*cmplx(hpsi(i)/rmaj(i),0.)
c
      do 40 i=1,norigl
   40 cwork2(i)=pcoef(i)
      do 41 i=nbodyf,ntot
   41 cwork2(i)=cmplx(hpsi(i)/hchi(i),0.)
      call dchi(cwork2,cwork4)
      do 42 i=1,norigl
   42 cwork4(i)=cwork4(i)*acoef(i)*cmplx(hpsi(i)/(pcoef(i)*rmaj(i)),0.)
      do 43 i=nbodyf,ntot
   43 cwork4(i)=cwork4(i)*acoef(i)*cmplx(hchi(i)/rmaj(i),0.)
c
      do 50 i=1,ntot
      ccoef(i)=ccoef(i)+cwork3(i)
      dcoef(i)=dcoef(i)+cwork4(i)
      ecoef(i)=ecoef(i)+(cwork3(i)*acoef(i)
     %                  +cwork4(i)*bcoef(i))*cmplx(1./rmaj(i),0.)
   50 fcoef(i)=fcoef(i)+(cwork3(i)*bcoef(i)
     %                  -cwork4(i)*acoef(i))*cmplx(1./rmaj(i),0.)
      do 51 i=1,ntot
      ecoef(i)=ecoef(i)*cmplx(rmaj(i)**2,0.)/gcoef(i)
   51 fcoef(i)=fcoef(i)*cmplx(rmaj(i)**2,0.)/gcoef(i)
c
c     call output(1)
      return
      end
