C******************** START FILE ERF.FOR ; GROUP ERF ******************
C
C	THIS SUBFUNCTION CALCULATES THE ERROR FUNCTION USING
C	A POLYNOMIAL APPROXIMATION FROM ABRAMOWITZ AND STEGUN
C	P. 299
C
C	FOR ALL REAL ZX
C	ERROR IS  <= 1.5E-7
C	(EXCLUDING ROUND-OFF ERROR)
C
	FUNCTION ERF(ZX)
C
	logical first
	DATA ZP/0.32759 11/
	DATA ZA1/0.25482 9592/
	DATA ZA2/-0.28449 6736/
	DATA ZA3/1.42141 3741/
	DATA ZA4/-1.45315 2027/
	DATA ZA5/1.06140 5429/
	data first /.true./
	save first,epslg
 
c on the first call, calculate epslg=alog(epslon), where epslon
c is a number close to the smallest allowed on this computer.
 
	if (first) then
	epslg=alog(r1mach(1))
	first=.false.
	endif
C
	ZX2M=-ZX*ZX
	IF(ZX2M.LT.EPSLG) GOTO 100
	ZT=1.0/(1.0+ZP*ABS(ZX))
	ZFACT=(ZA1+ZT*(ZA2+ZT*(ZA3+ZT*(ZA4+ZA5*ZT))))*ZT
	ERF=SIGN(1.0-ZFACT*EXP(ZX2M),ZX)
	GOTO 200
100	ERF=SIGN(1.0,ZX)
200	RETURN
	END
C******************** END FILE ERF.FOR ; GROUP ERF ******************
