C
      SUBROUTINE FBTINI(IUOUT
     ;                 ,IUMAT ,NEWFM, LABELM, LENLM
     ;                 ,IUSOL ,NEWFS, LABELS, LENLS, DOC)
C
C     INITIALIZES FRONTAL BLOCK-TRIDIAGONAL SOLVER
C
C     1/10/92 Version
      include 'cpar.com'
      include 'comzzz.com'
      include 'ccomus.com'
C
      INTEGER FBT_IIMIN, FBT_IIMAX, FBT_ISUM, IERROR, CEILQ
     ;       ,IUOUT, IUMAT, IUSOL, NEWFM, NEWFS, DOC, LENLM, LENLS
      REAL LABELM(*), LABELS(*)
C-----------------------------------------------------------------------
C   IUOUT: output file number (messages, results)(input).
C   IUMAT: Fortran unit number for storage of global matrix
C          factorization (input).
C   IUSOL: Fortran unit number for storage of solutions (input).
C   NEWFM: nonzero: use a new file to store matrix factorizations.
C          zero:    use a file already containing at least one previous
C                   factorization (input).
C   LABELM: real array, at user disposal to label the file of
C           factorizations (input when NEWFM is nonzero, else output).
C   LENLM:  length of LABELM (input when NEWFM is nonzero, else output).
C   NEWFS: nonzero: use a new file to store solutions.
C          zero:    use a file already containing at least one previous
C                   solution (input).
C   LABELS: real array, at user disposal to label the file of
C           solutions (input when NEWFS is nonzero, else output).
C   LENLS:  length of LABELS (input when NEWFS is nonzero, else output).
C
C   DOC: (integer) when nonzero, documentation on execution will be
C        written to Fortran unit IUOUT (input).
C-----------------------------------------------------------------------
      NBPR = CEILQ(2*(MAXPRO+2),IOBLL)
C
C     Output file number:
      NOFILE=IUOUT
C     Fortran unit number for storage of global matrix factorization:
      UNIT(1)=IUMAT
C     Fortran unit number for storage of solutions:
      UNIT(2)=IUSOL
C
      NEWFIL(1) = NEWFM .NE. 0
      NEWFIL(2) = NEWFS .NE. 0
      SOLDOC = DOC .NE. 0
      IF(SOLDOC)WRITE(NOFILE,100)
      IF(UNIT(1) .EQ. UNIT(2))THEN
      WRITE(NOFILE,*)'Error in routine FBTINI: matrix and solution'
     ;,' may not be stored on the same FORTRAN unit'
      STOP
      END IF
 
      DO 1 I = 1, 2
C     Open I/O units for matrix and solutions:
      CALL FBT_ASOP(I)
      IWRI(I) = 0
      IREA(I) = 0
      NBLRD(I) = 0
      NBLWR(I) = 0
      DO 10 J = 1, LWK1
      WK1ZZZ(J,I) = 0.
  10  CONTINUE
      IF(NEWFIL(I))THEN
C     *****************
      NPROBL(I) = 0
      NBLK = 0
      IF(I.EQ.1 .AND. LENLM.GT.0)THEN
      IBLK(I) = 1 + NBPR
      WK1ZZZ(3,I) = LENLM
      CALL FBT_ASWR(I, LENLM, LABELM, 0, NBLK)
      CALL FBT_ASWA(I)
      END IF
      IF(I.EQ.2 .AND. LENLS.GT.0)THEN
      IBLK(I) = 1 + NBPR
      WK1ZZZ(3,I) = LENLS
      CALL FBT_ASWR(I, LENLS, LABELS, 0, NBLK)
      CALL FBT_ASWA(I)
      END IF
      IPRDEF(1,I) = 1 + NBPR + NBLK
C
      ELSE
C     ****
C     Fortran unit UNIT(I) already contains at least 1 factorization.
      IBLK(I) = 1
      CALL FBT_ASRD(I, IOBLL, WK1ZZZ(1,I), 0, NBLK)
      IBLK(I) = IBLK(I) + NBLK
      CALL FBT_ASWA(I)
      NPROBL(I) = WK1ZZZ(1,I)
      NBLK = WK1ZZZ(2,I)-1
          IF(NPROBL(I).GT.MAXPRO)THEN
          WRITE(NOFILE,*)'Warning: Fortran unit ',UNIT(I)
     ;,' contains ',NPROBL(I),' problems,'
     ;,' whereas this version of solver allows a maximum of ',MAXPRO
      WRITE(NOFILE,*)
     ;'Only the first ',MAXPRO,' problems will be considered'
      WRITE(NOFILE,*)
     ;'To cure this, recompile solver with parameter MAXPRO = ',MAXPRO
      NPROBL(I) = MAXPRO
      NBLK = NBPR
          END IF
      IF(NBLK.GT.0)THEN
      CALL FBT_ASRD(I, NBLK*IOBLL, WK1ZZZ(IOBLL+1,I), 0, NBLK)
      IBLK(I) = IBLK(I) + NBLK
      CALL FBT_ASWA(I)
      END IF
 
      DO 50 IPROB = 1, NPROBL(I)
      IPRDEF(IPROB,I) = WK1ZZZ(2*IPROB+2,I)
      IPRDAT(IPROB,I) = WK1ZZZ(2*IPROB+3,I)
  50  CONTINUE
      IPRDEF(NPROBL(I)+1,I) = WK1ZZZ(2*NPROBL(I)+4,I)
 
      IF(WK1ZZZ(3,I).GT.0)THEN
      IBLK(I) = 1 + NBPR
          IF(I.EQ.1)THEN
          LENLM = WK1ZZZ(3,I)
          CALL FBT_ASRD(I, LENLM, LABELM, 0, NBLK)
          ELSE
          LENLS = WK1ZZZ(3,I)
          CALL FBT_ASRD(I, LENLS, LABELS, 0, NBLK)
          END IF
      CALL FBT_ASWA(I)
      END IF
      END IF
C     ******
   1  CONTINUE
 
C
      RETURN
C
 100  FORMAT(1H1,'Frontal block-tridiagonal solver'/1H ,
     ;           '********************************'/)
      END
C
      SUBROUTINE proini(NBLO, LBLO, NRHSS, NEW, IPRO)
C
C     INITIALIZES ONE PROBLEM
C
C     1/10/92 Version
      include 'cpar.com'
      include 'comzzz.com'
      include 'ccomus.com'
C
      INTEGER NBLO, LBLO(NBLO), NRHSS, NEW, IPRO
C-----------------------------------------------------------------------
C   NBLO: row- or column-wise number of blocks in global matrix (input
C         when NEW nonzero).
C   LBLO: array of block sizes (input when NEW nonzero).
C   NRHSS: number of right-hand-sides (input).
C   NEW: nonzero: a new factorization has to be performed
C        zero:    a previously computed factorization has to be used
C        (input)
C   IPRO: index of old factorization to be used (input only for NEW=0)
C-----------------------------------------------------------------------
      INTEGER FBT_IIMIN, FBT_IIMAX, FBT_ISUM, IMIN, IMAX, IERROR, CEILQ
      EXTERNAL FBT_IIMIN, FBT_IIMAX
C
      IERROR = 0
      IF(NEW.EQ.0 .AND. NRHSS.EQ.0)THEN
      WRITE(NOFILE,*)'From proini: no r.h.s.; factorization already'
     ;//' exists: end of problem'
      RETURN
      END IF
      NEWMAT(1) = NEW .NE. 0
      NEWMAT(2) = NRHSS .GT. 0
      DO 1 I = 1, 2
      DO 80 J = 1, LWK2
      WK2ZZZ(J,I) = 0.
  80  CONTINUE
      IF(NEWMAT(I))THEN
C     *****************
C     New problem
      IPROBL(I) = NPROBL(I) + 1
      NTHOMA = NBLO
      WK2ZZZ(1,I) = NTHOMA
      WK2ZZZ(2,I) = CEILQ(NTHOMA+5,IOBLL)
      WK2ZZZ(3,I) = MODELE
      DO 60 ITHOMA = 1, NTHOMA
      LBLOCK(ITHOMA) = LBLO(ITHOMA)
      WK2ZZZ(ITHOMA+5,I) = LBLO(ITHOMA)
  60  CONTINUE
      ELSE
C     ****
C     I=1: Matrix factorization is already on unit UNIT(I).
C     I=2: No r.h.s. provided.
          IF(MODFAC.NE.1)THEN
      WRITE(NOFILE,*)'Error: to work with a previously stored matrix,'
      WRITE(NOFILE,*)'the value of parameter MODFAC must be set to 1'
      STOP
          END IF
          IF(I.EQ.1)THEN
      IF(IPRO.LE.0 .OR. IPRO.GT.NPROBL(I))THEN
      WRITE(NOFILE,*)'Error in proini: the old factorization # IPRO '
     ;,'must be between 1 and',NPROBL(I)
      WRITE(NOFILE,*)'but IPRO=',IPRO,' was given'
      IERROR = 1
      END IF
      IPROBL(I) = IPRO
      IBLK(I) = IPRDEF(IPROBL(I),I)
      CALL FBT_ASRD(I, IOBLL, WK2ZZZ(1,I), 0, NBLK)
      IBLK(I) = IBLK(I) + NBLK
      CALL FBT_ASWA(I)
          IF(INT(WK2ZZZ(3,I)).NE.MODELE)THEN
          WRITE(NOFILE,110)UNIT(I),INT(WK2ZZZ(3,I)),MODELE
          IERROR = 1
          END IF
      NTHOMA = WK2ZZZ(1,I)
      TSTORE = WK2ZZZ(4,I)
          IF(WK2ZZZ(2,I).GT.1)THEN
          NBLK = WK2ZZZ(2,I) - 1
          CALL FBT_ASRD(I, NBLK*IOBLL, WK2ZZZ(IOBLL+1,I), 0,
     ;              NBLK)
          IBLK(I) = IBLK(I) + NBLK
          CALL FBT_ASWA(I)
          END IF
      DO 50 ITHOMA = 1, NTHOMA
      LBLOCK(ITHOMA) = WK2ZZZ(ITHOMA+5,I)
  50  CONTINUE
          END IF
      END IF
C     ******
   1  CONTINUE
 
      NRHS = NRHSS
      IF(NTHOMA.LE.0)THEN
      WRITE(NOFILE,200)NTHOMA
      IERROR = 1
      ELSE IF(NTHOMA.GT.MAXNBL)THEN
      WRITE(NOFILE,300)NTHOMA,NTHOMA
      IERROR = 1
      END IF
      IF(NRHS.LT.0)THEN
      WRITE(NOFILE,400)NRHS
      IERROR = 1
      ELSE IF(NRHS.GT.MAXRHS)THEN
      WRITE(NOFILE,500)NRHS,NRHS
      IERROR = 1
      ELSE IF(NRHS.EQ.0 .AND. MODFAC.EQ.0)THEN
      WRITE(NOFILE,*)'NRHSS=0 is inconsistent with parameter MODFAC=0'
      IERROR = 1
      END IF
      IF(IERROR.NE.0)STOP
 
C     Maximal and minimal size block indices:
      IMAX = FBT_IIMAX(NTHOMA,LBLOCK,1)
      IMIN = FBT_IIMIN(NTHOMA,LBLOCK,1)
 
      IF(LBLOCK(IMIN).LE.0)THEN
      WRITE(NOFILE,*)'Block #',IMIN,' was given a negative size'
      IERROR = 1
      END IF
      IF(LBLOCK(IMAX).GT.MAXBLL)THEN
      WRITE(NOFILE,600)IMAX,LBLOCK(IMAX)
      IERROR = 1
      END IF
      IF(IERROR.NE.0)STOP
 
C     Number of unknowns:
      NGELIM = FBT_ISUM(NTHOMA,LBLOCK,1)
 
C     Number of stored matrix entries:
      STORED = MODFAC*LBLOCK(1)**2 + NGELIM * NRHS
C     Number of disk blocks needed to store matrix and pivots:
      TSTORE = MODFAC*CEILQ(LBLOCK(1)*(NWN*LBLOCK(1)+1),IOBLL)
C     Number of disk blocks needed to store r.h.s.:
      BLORHS = CEILQ(LBLOCK(1)*NRHS*NWN,IOBLL)
      DO 10 I = 2, NTHOMA
      STORED = STORED + LBLOCK(I)*(MODFAC*LBLOCK(I)
     ;                             +(MODFAC+1)*LBLOCK(I-1))
 
      TSTORE = TSTORE + MODFAC*(CEILQ(LBLOCK(I)*(NWN*LBLOCK(I)+1),IOBLL)
     ;                + CEILQ(LBLOCK(I-1)*LBLOCK(I)*NWN,IOBLL) )
     ;+ CEILQ( LBLOCK(I-1)*(LBLOCK(I)+(1-MODFAC)*NRHS)*NWN, IOBLL)
      BLORHS = BLORHS + CEILQ(LBLOCK(I)*NRHS*NWN,IOBLL)
  10  CONTINUE
      IF(MODFAC.EQ.0)TSTORE = TSTORE
     ;+ CEILQ(LBLOCK(NTHOMA)*NRHS*NWN, IOBLL)
 
      IF(SOLDOC)THEN
      WRITE(NOFILE,*)' '
          IF(NRHS.GT.0)THEN
      WRITE(NOFILE,*)'Factorization # ',IPROBL(1),'; solution group # '
     ;,IPROBL(2),':'
      WRITE(NOFILE,*)'*************************************'
          ELSE
      WRITE(NOFILE,*)'Factorization # ',IPROBL(1)
      WRITE(NOFILE,*)'*****************'
          END IF
      WRITE(NOFILE,*)' '
          IF(NEWMAT(1))THEN
      WRITE(NOFILE,*)'Number of diagonal blocks: ',NTHOMA
      WRITE(NOFILE,*)'Maximum block size: ',LBLOCK(IMAX)
      WRITE(NOFILE,*)'Index of maximum size block: ',IMAX
      WRITE(NOFILE,*)'Number of unknowns: ',NGELIM
      IF(NWN.EQ.2)THEN
      WRITE(NOFILE,*)
     ;'Matrix blocks contain a total of ',FLOAT(STORED)
     ;,' complex numbers'
      ELSE IF(NWN.EQ.1)THEN
      WRITE(NOFILE,*)
     ;'Matrix blocks contain a total of ',FLOAT(STORED)
     ;,' real numbers'
      END IF
      WRITE(NOFILE,*)'List of block sizes:'
      WRITE(NOFILE,*)'--------------------'
      NWR = CEILQ(NTHOMA, 6)
      DO 20 I = 1, NWR
      WRITE(NOFILE,800)(J+I-1,LBLOCK(J+I-1),J=1,NTHOMA+1-I,NWR)
  20  CONTINUE
      WRITE(NOFILE,*)'Global matrix and pivots storage requires ',
     ;TSTORE,' blocks of ',IOBLL,' words,'
      WRITE(NOFILE,*)'that is ',IOBLL*1.E-6*TSTORE,' Megawords, or ',
     ;IOBLL*WORDLZZ*1.E-9*TSTORE,' Gigabytes.'
          END IF
      IF(NRHS .GT. 0)WRITE(NOFILE,*)'Solution storage requires ',
     ;BLORHS,' blocks of ',IOBLL,' words,'
      WRITE(NOFILE,*)'that is ',IOBLL*1.E-6*BLORHS,' Megawords, or ',
     ;IOBLL*WORDLZZ*1.E-9*BLORHS,' Gigabytes.'
      END IF
 
C     Initialize common source_fppmod:ccomus.com to zero:
      DO 30 I = 1, LDCT1
      CTOM1(I) = 0.0E0
  30  CONTINUE
      DO 31 I = 1,LDBT1	
      BTOM1(I) = 0.0E0
  31  CONTINUE
      DO 32 I = 1,LDAT1
      ATOM1(I) = 0.0E0
  32  CONTINUE
      DO 33 I = 1,LDBE1
      BEL1(I) = 0.0E0
  33  CONTINUE
      DO 34 I = 1,LDAEL
         DO 34 J = 1,LCAEL
         AEL(I,J) = (0.E0,0.E0)
  34  CONTINUE
      DO 35 I = 1,MAXBLL
      WKCZZZ(I) = (0.E0,0.E0)
  35  CONTINUE
      NBLK = CEILQ(NTHOMA+5, IOBLL)
      IF(NEWMAT(1))IPRDAT(IPROBL(1),1) = IPRDEF(IPROBL(1),1) + NBLK
      IBLK(1) = IPRDAT(IPROBL(1),1)
      IF(NEWMAT(2))THEN
      IPRDAT(IPROBL(2),2) = IPRDEF(IPROBL(2),2) + NBLK
      IBLK(2) = IPRDAT(IPROBL(2),2)
      END IF
 
C     Information on problem size, will be written at successful
C     termination:
      WK2ZZZ(1,1) = NTHOMA
      WK2ZZZ(2,1) = NBLK
      WK2ZZZ(3,1) = MODELE
      WK2ZZZ(4,1) = TSTORE
      WK2ZZZ(1,2) = NTHOMA
      WK2ZZZ(2,2) = NBLK
      WK2ZZZ(3,2) = MODELE
      WK2ZZZ(4,2) = BLORHS
      WK2ZZZ(5,2) = NRHS
      DO 40 I = 1, 2
      DO 40 ITHOMA = 1, NTHOMA
      WK2ZZZ(ITHOMA+5,I) = LBLOCK(ITHOMA)
  40  CONTINUE
 
C     Initialize block counter:
      ITHOMA = 0
 
      RETURN
 
 110  FORMAT(1H ,'The old factorization on Fortran unit',I4,
     ;' was obtained with solver storage mode MODELE=',I4,'.'
     ;/1H ,'To use that factorization, recompile solver with parameter',
     ;' MODELE=',I4)
 200  FORMAT(1H ,'The number of blocks must be positive, but NTHOMA=',
     ;I4,' was given')
 300  FORMAT(1H ,'The number of blocks,',I4,
     ;', is larger than the allowed maximum.'/1H ,
     ;' Recompile solver setting MAXNBL=',I4)
 400  FORMAT(1H ,
     ;'The number of right hand sides must be positive, but NRHS=',
     ;I4,' was given')
 500  FORMAT(1H ,'The number of right hand sides,',I4,
     ;', is larger than the allowed maximum.'/1H ,
     ;' Recompile solver setting MAXRHS=',I4)
 600  FORMAT(1H ,'The size of block #',I4,
     ;' is larger than the allowed maximum.'/1H ,
     ;' Recompile solver setting MAXBLL=',I4)
 800  FORMAT(1H ,6(I4,', ',I4,' ; '))
 
      END
C
      SUBROUTINE FBSTEP(SCAIN, SC1, SC2)
C
      include 'cpar.com'
      include 'comzzz.com'
      include 'ccomus.com'
C
      INTEGER SCAIN
      REAL    SC1(MAXBLL), SC2(MAXBLL)
C
C     1/10/92 Version
C  -  When a new matrix is undergoing factorization,
C     this routine performs one step of the frontal block-tridiagonal
C     algorithm. At the end of the last step, it also performs back
C     substitution on the right hand sides provided by the user during
C     matrix assembly.
C     The solver performs scaled row pivoting:
C     SCAIN: integer (input).
C     SCAIN = 0: inverse scaling factors are the rows maximum norms
C     (output).
C     SCAIN = 1: row inverse scaling factors are input by the user
C                in SC1.
C     SCAIN not 0 or 1: row and column inverse scaling factors are
C     input by the user in SC1 and SC2, respectively.
C
C     SC1: real vector of length LBLOCK(ithoma) containing the rows
C     inverse scaling factors used in partial pivoting
C     (output when SCAIN=0, input otherwise).
C
C     SC2: real vector of length LBLOCK(ithoma) containing column
C          inverse scaling factors when SCAIN differs from 0 and 1.
C          dummy argument when SCAIN = 0 or 1.
C          SC2 influences the evaluation of the block condition number.
C
C  -  When a previous factorization is used, FBSTEP performs one step
C     of the forward substitution on the new right hand side block.
C     In this situation, the arguments of FBSTEP are all dummy.
C     At the end of the last step, back-substitution is performed and
C     the solution vectors are stored on disk.
C
      INTEGER INT, ICAMAX, CEILQ, ISING
      REAL    CABS1, RCOND(MAXNBL)
      COMPLEX CZERO, ZDUM
C
      INTRINSIC INT
C
      DATA CZERO/(0.0E0,0.0E0)/
      CABS1(ZDUM) = ABS(REAL(ZDUM))+ABS(AIMAG(ZDUM))
 
 
      ITHOMA = ITHOMA + 1
      LBL2 = LBLOCK(ITHOMA)
      IF(ITHOMA.LT.NTHOMA)THEN
      LBL3 = LBLOCK(ITHOMA+1)
      ELSE
      LBL3 = 0
      END IF
      LBL4 = LBL3 + NRHS
      IF(ITHOMA.GT.1)THEN
      LBL1 = LBLOCK(ITHOMA-1)
      ELSE
      LBL1 = 0
      END IF
      JSHI = MODELE*LBL1 + LBL2 + LBL3
 
              IF(NEWMAT(1))THEN
C             *****************
C     Factorize a new matrix
 
      IF(ITHOMA.GT.1)THEN
C
C     Wait for completion of previous write:
      CALL FBT_ASWA(1)
      IF(MODFAC.EQ.1 .AND. NRHS.GT.0)CALL FBT_ASWA(2)
 
C     Unpack previously written BTOM, CTOM:
      IF(MODFAC.EQ.1 .AND. MODELE.EQ.0)
     ;CALL PACKMA(LBL2, LBL1, BTOM, LDBT, BTOM, 2)
      CALL PACKMA(LBL1, LBL2+NRHS, CTOM, LDCT, CTOM, 2)
      END IF
 
      IF(SCAIN .EQ. 0)THEN
C     Compute row max.norms using contents of AEL and BTOM:
      DO 10 I = 1, LBL2
      SC1(I) = CABS1( AEL(I,ICAMAX(JSHI, AEL(I,1), LDAEL) ) )
  10  CONTINUE
          IF( MODELE.EQ.0 .AND. ITHOMA .GT. 1 )THEN
          DO 11 I = 1, LBL2
          SC1(I) = AMAX1( SC1(I), CABS1(BTOM(I,
     ;                    ICAMAX(LBL1, BTOM(I,1), LDBT) ) ) )
  11      CONTINUE
          END IF
      END IF
 
C     Check no row is zero:
      ISING = 0
      DO 12 I = 1, LBL2
      IF(SC1(I) .EQ. 0.0E0) THEN
      ISING = I
      END IF
  12  CONTINUE
      IF(ISING.NE.0)THEN
      WRITE(NOFILE,*)'ROW #',ISING,' IN BLOCK #',ITHOMA,
     ;' IS ZERO ; ROUTINE FBSTEP STOPPED'
      STOP
      END IF
C
C     One step of f.b.t.algorithm:
C
      IF( ITHOMA .GT. 1 )THEN
C
C     Compute new ALPHA:
C
          IF(MODELE .EQ. 0)THEN
      DO 13 J = 1, LBL2
      DO 13 K = 1, LBL1
      DO 13 I = 1, LBL2
      AEL(I,J) = AEL(I,J) - BTOM(I,K) * CTOM(K,J)
  13  CONTINUE
      DO 14 J = 1, NRHS
      DO 14 K = 1, LBL1
      DO 14 I = 1, LBL2
      BEL(I,J) = BEL(I,J) - BTOM(I,K) * CTOM(K,J+LBL2)
  14  CONTINUE
          ELSE
      DO 15 J = 1, LBL2
      DO 15 K = 1, LBL1
      DO 15 I = 1, LBL2
      AEL(I,J+LBL1) = AEL(I,J+LBL1) - AEL(I,K) * CTOM(K,J)
  15  CONTINUE
      DO 16 J = 1, NRHS
      DO 16 K = 1, LBL1
      DO 16 I = 1, LBL2
      BEL(I,J) = BEL(I,J) - AEL(I,K) * CTOM(K,J+LBL2)
  16  CONTINUE
          END IF
      END IF
 
C     Factorize alpha and store in atom:
 
      III=1
      IF(SCAIN.NE.0 .OR. SCAIN.NE.1)III=2
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      CALL CGECO2( AEL(1,1+MODELE*LBL1), LDAEL, LBL2,
     ;             IPVT, III, SC1, SC2, RCOND(ITHOMA), WKCZZZ )
C     Faster: to avoid condition number evaluation, replace two previous
C     lines by four following ones:
C     CALL CGEFA2( AEL(1,1+MODELE*LBL1), LDAEL, LBL2,
C    ;             IPVT, SC1, 1, INFO)
C     RCOND(ITHOMA) = 1.
C     IF(INFO .NE. 0)RCOND(ITHOMA) = 0.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
 
      IF( 1.+RCOND(ITHOMA) .EQ. 1. ) THEN
      WRITE(NOFILE,*)
     ;'BLOCK ALPHA #',ITHOMA,' IS SINGULAR; SOLVER STOPPED'
      STOP
      END IF
 
      IF(MODFAC .EQ. 1)THEN
C     Pack and write block ALPHA and pivoting sequence:
      CALL PACKMA(LBL2, LBL2,  AEL(1,1+MODELE*LBL1), LDAEL, ATOM, 1)
      NCW = LBL2**2
      J = NWN*NCW
      DO 17 I = 1, LBL2
      ATOM1(I+J) = IPVT(I)
  17  CONTINUE
      IQUEUE = 1
      IF(ITHOMA.GE.NTHOMA .AND. NRHS.EQ.0)IQUEUE = 0
      CALL FBT_ASWR(1, J+LBL2, ATOM1, IQUEUE, NBLK)
      IBLK(1) = IBLK(1) + NBLK
      END IF
C
C     Solve ATOM * GAMMA = CTOM, store in CTOM:
C
      IF(LBL3 .GT. 0)THEN
      DO 18 J = 1, LBL3
      J2 = J + LBL2 + MODELE*LBL1
      DO 18 I = 1, LBL2
      CTOM(I,J) = AEL(I,J2)
  18  CONTINUE
      END IF
      IF(NRHS .GT. 0)THEN
      DO 19 J = 1, NRHS
      J2 = J + LBL3
      DO 19 I = 1, LBL2
      CTOM(I,J2) = BEL(I,J)
  19  CONTINUE
      END IF
      IF(LBL4 .GT. 0)
     ;CALL CGESL2( AEL(1,1+MODELE*LBL1), LDAEL, LBL2, IPVT,
     ;             CTOM, LDCT, LBL4)
 
      IF( ITHOMA.LT.NTHOMA .OR. MODELE.EQ.1 )THEN
C
          IF(MODFAC.EQ.1)THEN
C         Pack B in btom:
          CALL PACKMA(LBL3*(1-MODELE)+LBL2*MODELE, LBL2*(1-MODELE)
     ;          +LBL1*MODELE, AEL(LBL2*(1-MODELE)+1,1), LDAEL, BTOM, 1)
          ELSE IF(MODELE.EQ.0)THEN
          DO 20 J = 1, LBL2
          DO 20 I = 1, LBL3
          BTOM(I,J) = AEL(LBL2+I,J)
  20      CONTINUE
          END IF
      END IF
C
C     Write block BTOM:
C
      IF(MODFAC .EQ. 1)THEN
          IF(MODELE.EQ.0)THEN
          NCW = LBL3 * LBL2
          ELSE
          NCW = LBL2 * LBL1
          END IF
          IF(NCW .GT. 0)THEN
          CALL FBT_ASWR(1, NWN*NCW, BTOM1, 1, NBLK)
          IBLK(1) = IBLK(1) + NBLK
          END IF
      END IF
C
C     Write block CTOM and start asynchronous I-O request:
C
      IF(LBL4 .GT. 0)THEN
      CALL PACKMA( LBL2,LBL4,CTOM,LDCT, CTOM, 1 )
          IF(MODFAC .EQ. 0)THEN
          NCW = LBL2 * LBL4
          CALL FBT_ASWR(1, NWN*NCW, CTOM1, 0, NBLK)
          IBLK(1) = IBLK(1) + NBLK
          ELSE
              IF(LBL3 .GT. 0)THEN
              NCW = LBL2 * LBL3
              CALL FBT_ASWR(1, NWN*NCW, CTOM1, 0, NBLK)
              IBLK(1) = IBLK(1) + NBLK
              END IF
              IF(NRHS .GT. 0)THEN
              NCW = LBL2 * NRHS
              CALL FBT_ASWR(2, NWN*NCW, CTOM1(NWN*LBL2*LBL3+1), 0, NBLK)
              IBLK(2) = IBLK(2) + NBLK
              END IF
          END IF
      END IF
C
C     Shift contributions for next blocks and clean up:
C
      IF(MODELE.EQ.0 .AND. ITHOMA.LT.NTHOMA)THEN
      DO 21 J = 1, LBL3
      J2 = J + LBL2
      DO 21 I = 1, LBL3
      AEL(I,J) = AEL(I+LBL2,J2)
  21  CONTINUE
      DO 22 J = 1, NRHS
      DO 23 I = 1, LBL3
      BEL(I,J) = BEL(I+LBL2,J)
  23  CONTINUE
      DO 22 I = LBL3+1, LBL3+LBL2
      BEL(I,J) = CZERO
  22  CONTINUE
      DO 24 J = 1, LBL3
      DO 24 I = LBL3+1, LBL3+LBL2
      AEL(I,J) = CZERO
  24  CONTINUE
c  changes of Ph. Lamalle of 20-7-1994  jphe
      DO 25 J = LBL3+1,LBL3+LBL2
      DO 25 I = 1, LBL3+LBL2
      AEL(I,J) = CZERO
  25  CONTINUE
C
      ELSE
      DO 26 J = 1, JSHI
      DO 26 I = 1, LDAEL
      AEL(I,J) = CZERO
  26  CONTINUE
      DO 27 J = 1, NRHS
      DO 27 I = 1, LDBEL
      BEL(I,J) = CZERO
  27  CONTINUE
c  end changes   jphe
C
      END IF
C
C
      IF(ITHOMA.LT.NTHOMA)RETURN
C
      IF(SOLDOC)THEN
      WRITE(NOFILE,*)'List of block condition numbers:'
      WRITE(NOFILE,*)'--------------------------------'
      NWR = CEILQ(NTHOMA, 4)
      DO 28 I = 1, NWR
      WRITE(NOFILE,200)(J+I-1,1./RCOND(J+I-1),J=1,NTHOMA+1-I,NWR)
  28  CONTINUE
 200  FORMAT(1H ,4(I4,', ',G10.2,' ; '))
      END IF
 
C     Wait for completion of last write:
      CALL FBT_ASWA(1)
 
      IF(MODFAC .EQ. 1)THEN
C
C     Successful factorization: update indices
C
      NPROBL(1) = NPROBL(1) + 1
      IBLK(1) = IPRDEF(NPROBL(1),1)
      CALL FBT_ASWR(1, NTHOMA+5, WK2ZZZ, 1, NBLK)
      WK1ZZZ(1,1) = NPROBL(1)
      WK1ZZZ(2,1) = CEILQ(2*NPROBL(1)+4,IOBLL)
      WK1ZZZ(2*NPROBL(1)+3,1) = IPRDAT(NPROBL(1),1)
      IPRDEF(NPROBL(1)+1,1) = IPRDAT(NPROBL(1),1) + TSTORE
      WK1ZZZ(2*NPROBL(1)+4,1) = IPRDEF(NPROBL(1)+1,1)
      IBLK(1) = 1
      CALL FBT_ASWR(1, 2*NPROBL(1)+4, WK1ZZZ, 0, NBLK)
      CALL FBT_ASWA(1)
      IF(NRHS.GT.0)CALL FBT_ASWA(2)
      END IF
      IF(NRHS.LE.0)RETURN
C
              ELSE
C             ****
C     Use a previously computed factorization
C
      IF( ITHOMA .GT. 1 )THEN
C
C     Read block B:
C
      NCW = LBL2 * LBL1
      CALL FBT_ASRD(1, NWN*NCW, BTOM1, 0, NBLK)
      CALL FBT_ASWA(1)
      CALL PACKMA( LBL2, LBL1, BTOM, LDBT, BTOM, 2 )
      IF(MODELE .EQ. 0)IBLK(1) = IBLK(1) + NBLK
C
C     Modify r.h.s.:
C
      CALL FBT_ASWA(2)
      CALL PACKMA(LBL1, NRHS, CTOM, LDCT, CTOM, 2)
      DO 29 J = 1, NRHS
      DO 29 K = 1, LBL1
      DO 29 I = 1, LBL2
      BEL(I,J) = BEL(I,J) - BTOM(I,K) * CTOM(K,J)
  29  CONTINUE
 
          IF(MODELE .EQ. 0)THEN
C
C         Skip block C:
C
          NCW = LBL1 * LBL2
          NBLK = CEILQ(NWN*NCW,IOBLL)
          IBLK(1) = IBLK(1) + NBLK
          ELSE
C
C         Skip backward on A:
C
          IBLK(1) = IBLK(1) - CEILQ((NWN*LBL2+1)*LBL2,IOBLL)
          END IF
      END IF
C
C     Read block ALPHA and pivoting sequence:
C
      NCW = LBL2**2
      J = NWN * NCW
      CALL FBT_ASRD(1, J+LBL2, ATOM1, 0, NBLK)
      CALL FBT_ASWA(1)
      DO 30 I = 1, LBL2
      IPVT(I) = INT( ATOM1(I+J) )
  30  CONTINUE
      CALL PACKMA(LBL2, LBL2, ATOM, LDAT, ATOM, 2)
      IBLK(1) = IBLK(1) + NBLK
 
      IF(MODELE .EQ. 1)THEN
C
C     Skip B, Gamma, Alpha:
C
      IF(ITHOMA.GT.1)IBLK(1) = IBLK(1) + CEILQ(NWN*LBL2*LBL1,IOBLL)
      IBLK(1) = IBLK(1) + CEILQ(NWN*LBL2*LBL3,IOBLL)
      IF(ITHOMA.LT.NTHOMA)IBLK(1) = IBLK(1)
     ;+ CEILQ((NWN*LBL3+1)*LBL3,IOBLL)
      END IF
C
C     Solve lower triangular system, store its solution:
C
      CALL CGESL2(ATOM, LDAT, LBL2, IPVT, BEL, LDBEL, NRHS)
      CALL PACKMA(LBL2, NRHS, BEL, LDBEL, CTOM, 1)
      CALL FBT_ASWR(2, NWN*LBL2*NRHS, CTOM1, 0, NBLK)
      IBLK(2) = IBLK(2) + NBLK
C
C     Initialize r.h.s. for next user block assembly:
C
      IF(MODELE.EQ.0 .AND. ITHOMA.LT.NTHOMA)THEN
      DO 31 J = 1, NRHS
      DO 32 I = 1, LBL3
      BEL(I,J) = BEL(I+LBL2,J)
  32  CONTINUE
      DO 31 I = LBL3+1, LBL3+LBL2
      BEL(I,J) = CZERO
  31  CONTINUE
      ELSE
c changes of Ph. Lamalle of 20/7/94  jphe
      DO 33 J = 1, NRHS	
      DO 33 I = 1, LDBEL
      BEL(I,J) = CZERO
  33  CONTINUE
c  end changes  jphe
      END IF
      IF(ITHOMA .LT. NTHOMA)RETURN
      CALL FBT_ASWA(2)
C
              END IF
C             ******
C
C     Now solve upper triangular system, if any:
C
      IBLK(1) = IPRDAT(IPROBL(1),1) + TSTORE
      IBLK(2) = IPRDAT(IPROBL(2),2) + BLORHS
     ;- CEILQ(NWN*NRHS*LBL2,IOBLL)
      CALL PACKMA( LBL2, NRHS, BEL, LDBEL, CTOM, 2 )
C
      NCW = LBL2*NRHS
      CALL FBT_ASWR(2, NWN*NCW, CTOM1, 0, NBLK)
      CALL FBT_ASWA(2)
      IF(MODFAC.EQ.0)THEN
C     Set disk block number on start of Yn:
      IBLK(1) = IBLK(1) - NBLK
      END IF
      IBLK(2) = IBLK(2) - CEILQ(NWN*LBL1*NRHS,IOBLL)
C
      IF(MODFAC .EQ. 1)THEN
C     Set index on last block ALPHA:
      NCW = LBL2**2
      NBLK = CEILQ(NWN*NCW+LBL2,IOBLL)
      IBLK(1) = IBLK(1) - NBLK
          IF(MODELE .EQ. 1)THEN
C         Also skip block B:
          NCW = LBL2*LBL1
          NBLK = CEILQ(NWN*NCW,IOBLL)
          IBLK(1) = IBLK(1) - NBLK
          END IF
      END IF
C
C     Backward substitution loop:
C
      DO 35 ITHOMA = NTHOMA-1, 1, -1
      LBL1 = 0
      IF(ITHOMA .GT. 1)LBL1 = LBLOCK(ITHOMA-1)
      LBL2 = LBLOCK(ITHOMA)
      LBL3 = LBLOCK(ITHOMA+1)
      LBL4 = LBL3 + NRHS
C
C     Set index at start of block gamma:
C
      IF(MODFAC .EQ. 0)THEN
      NCW = LBL2*LBL4
      ELSE
      NCW = LBL2*LBL3
      END IF
      NBLK = CEILQ(NWN*NCW,IOBLL)
      IBLK(1) = IBLK(1) - NBLK
C
C     Read and unpack block GAMMA:
C
      IF(ITHOMA.LT.NTHOMA-1) CALL FBT_ASWA(2)
      CALL FBT_ASRD(1, NWN*NCW, CTOM1, 0, NBLK)
      CALL FBT_ASWA(1)
          IF(MODFAC.EQ.1)THEN
          CALL FBT_ASRD(2, NWN*LBL2*NRHS, CTOM1(NWN*LBL2*LBL3+1),
     ;              0, NBLK)
          CALL FBT_ASWA(2)
          END IF
      CALL PACKMA( LBL2, LBL4, CTOM, LDCT, CTOM, 2 )
 
      IF(MODFAC .EQ. 1)THEN
C
C     Skip blocks B and ALPHA:
C
          IF(MODELE .EQ. 0)THEN
          NCW = LBL2 * LBL3
          ELSE
          NCW = LBL1 * LBL2
          END IF
      IBLK(1) = IBLK(1) - CEILQ(NWN*NCW,IOBLL)
     ;                  - CEILQ((NWN*LBL2+1)*LBL2,IOBLL)
      END IF
C
C     Modify r.h.s.:
C
      DO 36 K = 1, LBL3
      DO 36 J = 1, NRHS
      DO 36 I = 1, LBL2
      CTOM(I,J+LBL3) = CTOM(I,J+LBL3) - CTOM(I,K) * BEL(K,J)
  36  CONTINUE
 
      DO 37 J = 1, NRHS
      DO 37 I = 1, LBL2
      BEL(I,J) = CTOM(I,J+LBL3)
  37  CONTINUE
C
      NCW = LBL2*NRHS
      CALL PACKMA(LBL2, NRHS, CTOM(1,LBL3+1), LDCT, CTOM, 1)
      IF(ITHOMA.EQ.1)THEN
      IQUEUE = 1
      ELSE
      IQUEUE = 0
      END IF
      CALL FBT_ASWR(2, NWN*NCW, CTOM1, IQUEUE, NBLK)
      IBLK(2) = IBLK(2) - CEILQ(NWN*LBL1*NRHS,IOBLL)
C
  35  CONTINUE
C
C     Successful solution: update indices
C
      NPROBL(2) = NPROBL(2) + 1
      IBLK(2) = IPRDEF(NPROBL(2),2)
      CALL FBT_ASWR(2, NTHOMA+5, WK2ZZZ(1,2), 1, NBLK)
      WK1ZZZ(1,2) = NPROBL(2)
      WK1ZZZ(2,2) = CEILQ(2*(NPROBL(2)+2),IOBLL)
      WK1ZZZ(2*NPROBL(2)+3,2) = IPRDAT(NPROBL(2),2)
      IPRDEF(NPROBL(2)+1,2) = IPRDAT(NPROBL(2),2) + BLORHS
      WK1ZZZ(2*NPROBL(2)+4,2) = IPRDEF(NPROBL(2)+1,2)
      IBLK(2) = 1
      CALL FBT_ASWR(2, 2*NPROBL(2)+4, WK1ZZZ(1,2), 0, NBLK)
      CALL FBT_ASWA(2)
C
C
            IF(SOLDOC)THEN
            END IF
 
      ITHOMA = 0
      IBLK(1) = IPRDAT(IPROBL(1),1)
      IBLK(2) = IPRDAT(IPROBL(2),2)
 
      RETURN
      END
C
      SUBROUTINE FBTCLO(CHAR)
C
C     Closes f.b.t. solver:
C-----------------------------------------------------------------------
C   CHAR: character*3 (input)
C   When CHAR='MAT', only closes the global matrix I/O unit.
C   Otherwise, closes both matrix and solutions I/O units.
C-----------------------------------------------------------------------
      include 'cpar.com'
      include 'comzzz.com'
      include 'ccomus.com'
C
      CHARACTER*3 CHAR
C
C     Closes global matrix I/O unit:
      CALL FBT_ASCL(1)
C
C     When required, also closes solution I/O unit:
      IF(CHAR .NE. 'MAT')THEN
      CALL FBT_ASCL(2)
          IF(SOLDOC)THEN
      WRITE(NOFILE,*)' '
      WRITE(NOFILE,*)'*****************************************'
              IF(MODFAC.EQ.1)THEN
                  IF(NPROBL(1).EQ.1)THEN
                  WRITE(NOFILE,*)'Fortran unit ',UNIT(1),
     ;            ' contains one factorization'
                  ELSE
                  WRITE(NOFILE,*)'Fortran unit ',UNIT(1),
     ;            ' contains ',NPROBL(1),' factorizations'
                  END IF
              END IF
                  IF(NPROBL(2).EQ.1)THEN
                  WRITE(NOFILE,*)'Fortran unit ',UNIT(2),
     ;            ' contains one group of solution vectors'
                  ELSE
                  WRITE(NOFILE,*)'Fortran unit ',UNIT(2),
     ;            ' contains ',NPROBL(2),' groups of solution vectors'
                  END IF
      WRITE(NOFILE,*)'Total number of writes: ',IWRI(1)+IWRI(2)
      WRITE(NOFILE,*)'Total number of reads:  ',IREA(1)+IREA(2)
      WRITE(NOFILE,*)'Total number of words written: ',
     ;IOBLL*(NBLWR(1)+NBLWR(2))
      WRITE(NOFILE,*)'Total number of words read:    ',
     ;IOBLL*(NBLRD(1)+NBLRD(2))
      WRITE(NOFILE,*)'Exit frontal block-tridiagonal solver'
      WRITE(NOFILE,*)'*************************************'
          END IF
      END IF
 
      RETURN
      END
C
      SUBROUTINE RDSOL(IPRO,IBLO,X,LDX,LBL,NRHSS)
C
C     Reads block # IBLO of solution to problem # IPRO on unit UNIT(2)
C     Stores it into complex matrix X
C     LDX is the leading dimension of X, as declared in calling program
C     LBL is the number of rows output in X
C     NRHSS is the number of columns output in X
C
      include 'cpar.com'
      include 'comzzz.com'
C
      INTEGER CEILQ, IPRO, IBLO, LDX, LBL, NRHSS
      COMPLEX X(LDX,*)
C
      IF(IPRO.LE.0 .OR. IPRO.GT.NPROBL(2))THEN
      WRITE(NOFILE,*)'Error in RDSOL: argument 1 should be between 1'
     ;,' and ',NPROBL(2)
      STOP
      END IF
C
      IBLK(2) = IPRDEF(IPRO,2)
      CALL FBT_ASRD(2, IOBLL, WK2ZZZ(1,2), 0, NBLK)
      IBLK(2) = IBLK(2) + NBLK
      CALL FBT_ASWA(2)
      NTHOMA = WK2ZZZ(1,2)
C
      IF(IBLO.LE.0 .OR. IBLO.GT.NTHOMA)THEN
      WRITE(NOFILE,*)'Error in RDSOL: argument 2 should be between 1'
     ;,' and ',NTHOMA
      STOP
      END IF
C
          IF(WK2ZZZ(2,2).GT.1)THEN
          NBLK = WK2ZZZ(2,2) - 1
          CALL FBT_ASRD(2, NBLK*IOBLL, WK2ZZZ(IOBLL+1,2), 0,
     ;              NBLK)
          IBLK(2) = IBLK(2) + NBLK
          CALL FBT_ASWA(2)
          END IF
      NRHS = WK2ZZZ(5,2)
      DO 50 ITHOMA = 1, NTHOMA
      LBLOCK(ITHOMA) = WK2ZZZ(ITHOMA+5,2)
  50  CONTINUE
C
      IBLK(2) = IPRDAT(IPRO,2)
      IF(IBLO .GT. 1)THEN
      DO 1 I = 1, IBLO-1
      IBLK(2) = IBLK(2) + CEILQ(NWN*NRHS*LBLOCK(I),IOBLL)
  1   CONTINUE
      END IF
      LBL2 = LBLOCK(IBLO)
      NCW = LBL2*NRHS
      CALL FBT_ASRD(2, NWN*NCW, X, 0, NBLK)
      CALL FBT_ASWA(2)
      CALL PACKMA(LBL2,NRHS,X,LDX,X,2)
      LBL = LBL2
      NRHSS = NRHS
      RETURN
      END
C
      SUBROUTINE CGECO2(A,LDA,N,IPVT,SCIN,SC1,SC2,RCOND,Z)
 
      INTEGER LDA, N, IPVT(*), SCIN
      COMPLEX A(LDA,*), Z(*)
      REAL RCOND, SC1(*), SC2(*)
C
C     CGECO2 FACTORS A COMPLEX MATRIX BY GAUSSIAN ELIMINATION
C     AND ESTIMATES THE CONDITION OF THE MATRIX.
C     SCALED ROW PIVOTING IS PERFORMED.
C
C     IF  RCOND  IS NOT NEEDED, CGEFA2 IS SLIGHTLY FASTER.
C     TO SOLVE  A*X = B , FOLLOW CGECO2 BY CGESL2.
C
C     ON ENTRY
C
C        A       COMPLEX(LDA, N)
C                THE MATRIX TO BE FACTORED.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  A .
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX  A .
C
C        SCIN    INTEGER
C                A SWITCH FOR THE INVERSE SCALING FACTORS SC1, SC2:
C                SCIN=0: SC1 IS WORKSPACE, SC2 IS A DUMMY ARGUMENT.
C                        CGECO2 COMPUTES THE MAXIMUM NORMS OF THE ROWS
C                        OF A AND STORES THEM IN SC1.
C                SCIN=1: SC1 IS INPUT, SC2 IS A DUMMY ARGUMENT.
C                OTHERWISE: SC1 AND SC2 ARE INPUT .
C
C        SC1     REAL(N)
C                WORKSPACE WHEN SCIN=0.
C                INPUT WHEN SCIN IS NONZERO. SC1 MUST THEN
C                CONTAIN INVERSE SCALING FACTORS FOR THE ROWS OF A.
C                THESE FACTORS WILL BE USED IN THE
C                SELECTION OF PIVOTS AND THE CONDITION NUMBER ESTIMATION
C
C        SC2     REAL(N)
C                DUMMY ARGUMENT WHEN SCIN=0 OR SCIN=1.
C                INPUT OTHERWISE. SC2 MUST THEN CONTAIN INVERSE SCALING
C                FACTORS FOR THE COLUMNS OF A.
C                THESE FACTORS WILL BE USED IN THE CONDITION NUMBER
C                ESTIMATION.
C
C     ON RETURN
C
C        A       AN UPPER TRIANGULAR MATRIX AND THE MULTIPLIERS
C                WHICH WERE USED TO OBTAIN IT.
C                THE FACTORIZATION CAN BE WRITTEN  A = L*U  WHERE
C                L  IS A PRODUCT OF PERMUTATION AND UNIT LOWER
C                TRIANGULAR MATRICES AND  U  IS UPPER TRIANGULAR.
C
C        IPVT    INTEGER(N)
C                AN INTEGER VECTOR OF PIVOT INDICES.
C
C        RCOND   REAL
C                AN ESTIMATE OF THE RECIPROCAL CONDITION OF  A .
C                FOR THE SYSTEM  A*X = B , RELATIVE PERTURBATIONS
C                IN  A  AND  B  OF SIZE  EPSILON  MAY CAUSE
C                RELATIVE PERTURBATIONS IN  X  OF SIZE  EPSILON/RCOND .
C                IF  RCOND  IS SO SMALL THAT THE LOGICAL EXPRESSION
C                           1.0 + RCOND .EQ. 1.0
C                IS TRUE, THEN  A  MAY BE SINGULAR TO WORKING
C                PRECISION.  IN PARTICULAR,  RCOND  IS ZERO  IF
C                EXACT SINGULARITY IS DETECTED OR THE ESTIMATE
C                UNDERFLOWS.
C
C        Z       COMPLEX(N)
C                A WORK VECTOR WHOSE CONTENTS ARE USUALLY UNIMPORTANT.
C                IF  A  IS CLOSE TO A SINGULAR MATRIX, THEN  Z  IS
C                AN APPROXIMATE NULL VECTOR IN THE SENSE THAT
C                NORM(A*Z) = RCOND*NORM(A)*NORM(Z) .
C
C     MODIFIED VERSION OF LINPACK CGECO. THIS VERSION DATED 1/10/92 .
C     PURPOSE: SCALED ROW PIVOTING. THE SCALING FACTORS MAY BE INPUT
C              OR OUTPUT.
C
C     SUBROUTINES AND FUNCTIONS
C
C     CGEFA2
C     BLAS CAXPY,CDOTC,CSSCAL,SCASUM
C     FORTRAN ABS,AIMAG,AMAX1,CMPLX,CONJG,REAL
C
C     INTERNAL VARIABLES
C
      COMPLEX CDOTC,EK,T,WK,WKM,AKKCI,ZERO,ONE
      REAL ANORM,S,SCASUM,SM,YNORM,RW1,RW2
      INTEGER INFO,J,K,KB,KP1,L
C
      COMPLEX ZDUM,ZDUM1,ZDUM2,CSIGN1
      REAL CABS1
      CABS1(ZDUM) = ABS(REAL(ZDUM)) + ABS(AIMAG(ZDUM))
      CSIGN1(ZDUM1,ZDUM2) = CABS1(ZDUM1)*(ZDUM2/CABS1(ZDUM2))
C     For real version, replace preceding line by following:
C     CSIGN1(ZDUM1,ZDUM2) = SIGN(ZDUM1,ZDUM2)
      DATA ZERO/(0.0E0,0.0E0)/,ONE/(1.0E0,0.0E0)/
C
C     COMPUTE ROW MAXIMUM NORMS WHEN SCIN=0:
C
      IF(SCIN.EQ.0)THEN
      DO 1 I = 1, N
      J = ICAMAX(N, A(I,1), LDA)
      SC1(I) = CABS1( A(I,J) )
  1   CONTINUE
      END IF
C
C     COMPUTE 1-NORM OF A
C
      ANORM = 0.0E0
      DO 31 I = 1, N
      Z(I) = CMPLX(1./SC1(I),0.0E0)
  31  CONTINUE
      DO 30 J = 1, N
      SCA = 0.
      DO 200 I = 1, N
      SCA = SCA + CABS1(A(I,J))*REAL(Z(I))
  200 CONTINUE
         IF(SCIN.EQ.0 .OR. SCIN.EQ.1)THEN
         ANORM = AMAX1(ANORM,SCA)
         ELSE
         ANORM = AMAX1(ANORM,SCA/SC2(J))
         END IF
   30 CONTINUE
C
C     FIRST, FACTOR A WITH CGEFA2 :
C
      CALL CGEFA2(A,LDA,N,IPVT,SC1,1,INFO)
C
C     RCOND = 1/(NORM(A)*(ESTIMATE OF NORM(INVERSE(A)))) .
C     ESTIMATE = NORM(Z)/NORM(Y) WHERE  A*Z = Y  AND  CTRANS(A)*Y = E .
C     CTRANS(A)  IS THE CONJUGATE TRANSPOSE OF A .
C     THE COMPONENTS OF  E  ARE CHOSEN TO CAUSE MAXIMUM LOCAL
C     GROWTH IN THE ELEMENTS OF W  WHERE  CTRANS(U)*W = E .
C     THE VECTORS ARE FREQUENTLY RESCALED TO AVOID OVERFLOW.
C
C     SOLVE CTRANS(U)*W = E
C
      EK = ONE
      DO 20 I = 1, N
      Z(I) = ZERO
  20  CONTINUE
 
      DO 100 K = 1, N
         RW1 = CABS1(A(K,K))
         IF (CABS1(Z(K)) .NE. 0.0E0)THEN
      IF(SCIN.EQ.0 .OR. SCIN.EQ.1)THEN
         EK = CSIGN1(EK,-Z(K))
      ELSE
         EK = CSIGN1(EK,-Z(K)) * SC2(K)
      END IF
         END IF
         RW2 = CABS1(EK-Z(K))
         IF (RW2 .GT. RW1)THEN
            S = RW1/RW2
            CALL CSSCAL(N,S,Z,1)
            EK = CMPLX(S,0.0E0)*EK
         END IF
         WK = EK - Z(K)
         WKM = -EK - Z(K)
         S = CABS1(WK)
         SM = CABS1(WKM)
         IF (CABS1(A(K,K)) .EQ. 0.0E0) THEN
            WK = ONE
            WKM = ONE
         ELSE
            AKKCI = ONE/CONJG(A(K,K))
            WK = WK*AKKCI
            WKM = WKM*AKKCI
         END IF
         KP1 = K + 1
         IF (KP1 .LE. N) THEN
            DO 60 J = KP1, N
               SM = SM + CABS1(Z(J)+WKM*CONJG(A(K,J)))
               Z(J) = Z(J) + WK*CONJG(A(K,J))
               S = S + CABS1(Z(J))
   60       CONTINUE
            IF (S .LT. SM) THEN
               T = WKM - WK
               WK = WKM
               DO 70 J = KP1, N
                  Z(J) = Z(J) + T*CONJG(A(K,J))
   70          CONTINUE
            END IF
         END IF
         Z(K) = WK
  100 CONTINUE
      S = 1.0E0/SCASUM(N,Z,1)
      CALL CSSCAL(N,S,Z,1)
C
C     SOLVE CTRANS(L)*Y = W
C
      DO 120 KB = 1, N
         K = N + 1 - KB
         IF (K .LT. N) Z(K) = Z(K) + CDOTC(N-K,A(K+1,K),1,Z(K+1),1)
         IF (CABS1(Z(K)) .GT. 1.0E0) THEN
            S = 1.0E0/CABS1(Z(K))
            CALL CSSCAL(N,S,Z,1)
         END IF
         L = IPVT(K)
         T = Z(L)
         Z(L) = Z(K)
         Z(K) = T
  120 CONTINUE
C     SCALING CONSISTENT WITH SCALED PIVOTING:
      DO 210 I = 1, N
      Z(I) = Z(I)*SC1(I)**2
  210 CONTINUE
      S = 1.0E0/SCASUM(N,Z,1)
      CALL CSSCAL(N,S,Z,1)
C
      YNORM = 1.0E0
C
C     SOLVE L*V = Y
C
      DO 140 K = 1, N
         L = IPVT(K)
         T = Z(L)
         Z(L) = Z(K)
         Z(K) = T
         IF (K .LT. N) CALL CAXPY(N-K,T,A(K+1,K),1,Z(K+1),1)
         IF (CABS1(Z(K)) .GT. 1.0E0) THEN
            S = 1.0E0/CABS1(Z(K))
            CALL CSSCAL(N,S,Z,1)
            YNORM = S*YNORM
         END IF
  140 CONTINUE
      S = 1.0E0/SCASUM(N,Z,1)
      CALL CSSCAL(N,S,Z,1)
      YNORM = S*YNORM
C
C     SOLVE  U*Z = V
C
      DO 160 KB = 1, N
         K = N + 1 - KB
         RW1 = CABS1(Z(K))
         RW2 = CABS1(A(K,K))
         IF (RW1 .GT. RW2) THEN
            S = RW2/RW1
            CALL CSSCAL(N,S,Z,1)
            YNORM = S*YNORM
         END IF
         IF (RW2 .EQ. 0.0E0) THEN
         Z(K) = ONE
         ELSE
         Z(K) = Z(K)/A(K,K)
         END IF
         T = -Z(K)
         CALL CAXPY(K-1,T,A(1,K),1,Z(1),1)
  160 CONTINUE
      IF(SCIN.NE.0 .AND. SCIN.NE.1)THEN
      DO 170 I = 1, N
      Z(I) = SC2(I) * Z(I)
  170 CONTINUE
      END IF
C     MAKE ZNORM = 1.0
      S = 1.0E0/SCASUM(N,Z,1)
      CALL CSSCAL(N,S,Z,1)
      YNORM = S*YNORM
C
      IF (ANORM .EQ. 0.0E0) THEN
      RCOND = 0.0E0
      ELSE
      RCOND = YNORM/ANORM
      END IF
      RETURN
      END
C
      SUBROUTINE CGEFA2(A,LDA,N,IPVT,SCALE,SCIN,INFO)
      INTEGER LDA,N,IPVT(*),INFO ,SCIN
      REAL    SCALE(*)
      COMPLEX A(LDA,*)
C
C     CGEFA2 FACTORS A COMPLEX MATRIX BY GAUSSIAN ELIMINATION.
C
C     CGEFA2 IS USUALLY CALLED BY CGECO2, BUT IT CAN BE CALLED
C     DIRECTLY WITH A SAVING IN TIME IF  RCOND  IS NOT NEEDED.
C
C     ON ENTRY
C
C        A       COMPLEX(LDA, N)
C                THE MATRIX TO BE FACTORED.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  A .
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX  A .
C
C        SCIN    INTEGER
C                A SWITCH FOR THE ROW INVERSE SCALING FACTOR SCALE:
C                SCIN=0: SCALE IS OUTPUT
C                SCIN NONZERO: SCALE IS AN INPUT .
C
C        SCALE   REAL(N)
C                INPUT WHEN SCIN IS NONZERO. SCALE MUST THEN CONTAIN
C                THE INVERSE SCALING FACTOR OF EACH EQUATION TO BE USED
C                IN SEARCH OF PIVOTS.
C
C
C     ON RETURN
C
C        A       AN UPPER TRIANGULAR MATRIX AND THE MULTIPLIERS
C                WHICH WERE USED TO OBTAIN IT.
C                THE FACTORIZATION CAN BE WRITTEN  A = L*U  WHERE
C                L  IS A PRODUCT OF PERMUTATION AND UNIT LOWER
C                TRIANGULAR MATRICES AND  U  IS UPPER TRIANGULAR.
C
C        IPVT    INTEGER(N)
C                AN INTEGER VECTOR OF PIVOT INDICES.
C
C        SCALE   REAL(N)
C                WHEN SCIN=0, THE MAXIMUM NORM OF EACH ROW OF A
C                USING THE CABS1 FUNCTION FOR ABSOLUTE VALUES .
C
C        INFO    INTEGER
C                = 0  NORMAL VALUE.
C                = K  IF  U(K,K) .EQ. 0.0 .  THIS IS NOT AN ERROR
C                     CONDITION FOR THIS SUBROUTINE, BUT IT DOES
C                     INDICATE THAT CGESL OR CGEDI WILL DIVIDE BY ZERO
C                     IF CALLED.  USE  RCOND  IN CGECO2 FOR A RELIABLE
C                     INDICATION OF SINGULARITY.
C
C     MODIFIED VERSION OF LINPACK CGEFA. THIS VERSION DATED 1/10/92 .
C     PURPOSE: SCALED ROW PIVOTING. THE SCALING FACTORS MAY BE INPUT
C              OR OUTPUT.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS CAXPY,CSCAL,ICAMAX
C     FORTRAN ABS,AIMAG,REAL
C
C     INTERNAL VARIABLES
C
      COMPLEX T,ONE
      INTEGER ICAMAX,J,K,KP1,L,NM1
C
      COMPLEX ZDUM
      REAL CABS1
      DATA ONE/(1.0E0,0.0E0)/
      CABS1(ZDUM) = ABS(REAL(ZDUM)) + ABS(AIMAG(ZDUM))
C
C     ROW MAXIMUM NORMS ARE COMPUTED WHEN SCIN=0:
C
      IF(SCIN.EQ.0)THEN
      DO 1 I = 1, N
      J = ICAMAX(N, A(I,1), LDA)
      SCALE(I) = CABS1( A(I,J) )
  1   CONTINUE
      END IF
C
C     GAUSSIAN ELIMINATION WITH SCALED PARTIAL PIVOTING
C
      INFO = 0
      NM1 = N - 1
      IF (NM1 .LT. 1) GO TO 70
      DO 60 K = 1, NM1
         KP1 = K + 1
C
C        FIND L = PIVOT INDEX
C
      L = K
      THR = CABS1(A(K,K))
      DO 2 I = KP1, N
      THR2 = CABS1(A(I,K))
      IF(THR2*SCALE(L).GT.THR*SCALE(I))THEN
      L = I
      THR = THR2
      END IF
  2   CONTINUE
      IPVT(K) = L
C
C        ZERO PIVOT IMPLIES THIS COLUMN ALREADY TRIANGULARIZED
C
         IF (THR .EQ. 0.0E0) GO TO 40
C
C           INTERCHANGE IF NECESSARY
C
            IF (L .NE. K) THEN
               T = A(L,K)
               A(L,K) = A(K,K)
               A(K,K) = T
            END IF
C
C           COMPUTE MULTIPLIERS
C
            T = -ONE/A(K,K)
            CALL CSCAL(N-K,T,A(K+1,K),1)
C
C           ROW ELIMINATION WITH COLUMN INDEXING
C
            DO 30 J = KP1, N
               T = A(L,J)
               IF (L .NE. K) THEN
                  A(L,J) = A(K,J)
                  A(K,J) = T
               END IF
               CALL CAXPY(N-K,T,A(K+1,K),1,A(K+1,J),1)
   30       CONTINUE
         GO TO 50
   40    CONTINUE
            INFO = K
   50    CONTINUE
   60 CONTINUE
   70 CONTINUE
      IPVT(N) = N
      IF (CABS1(A(N,N)) .EQ. 0.0E0) INFO = N
      RETURN
      END
C
      SUBROUTINE CGESL2(A,LDA,N,IPVT,B,LDB,NRHS)
C
      INTEGER LDA, LDB, N, NRHS, IPVT(*)
      COMPLEX A(LDA,*), B(LDB,*)
C
C     CGESL2 SOLVES THE COMPLEX SYSTEM
C     A * X = B
C     WHERE X AND B ARE N * NRHS MATRICES,
C     USING THE FACTORIZATION OF A PREVIOUSLY STORED IN A BY CGECO2
C     OR CGEFA2.
C
C     ON ENTRY
C
C        A       COMPLEX(LDA, N)
C                THE OUTPUT FROM CGECO2 OR CGEFA2.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  A .
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX  A .
C
C        IPVT    INTEGER(N)
C                THE PIVOT VECTOR FROM CGECO2 OR CGEFA2.
C
C        B       COMPLEX(N,NRHS)
C                THE RIGHT HAND SIDE MATRIX
C
C        LDB     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY B .
C
C        NRHS    INTEGER
C                THE NUMBER OF RIGHT HAND SIDE VECTORS IN B .
C                THE RIGHT HAND SIDES ARE STORED IN COLUMNS OF B.
C
C     ON RETURN
C
C        B       THE NRHS SOLUTION VECTORS X, REPLACING THE
C                CORRESPONDING INPUT RIGHT HAND SIDES.
C
C     ERROR CONDITION
C
C        A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS A
C        ZERO ON THE DIAGONAL.  TECHNICALLY THIS INDICATES SINGULARITY
C        BUT IT IS OFTEN CAUSED BY IMPROPER ARGUMENTS OR IMPROPER
C        SETTING OF LDA .  IT WILL NOT OCCUR IF THE SUBROUTINES ARE
C        CALLED CORRECTLY AND IF CGECO2 HAS SET RCOND .GT. 0.0
C        OR CGEFA2 HAS SET INFO .EQ. 0 .
C
C
C     MODIFIED VERSION OF LINPACK CGESL. THIS VERSION DATED 1/10/92 .
C     PURPOSE: VECTORIZATION OVER LARGE NUMBER OF RIGHT HAND SIDE
C              VECTORS (NRHS).
C
C     INTERNAL VARIABLES
C
      INTEGER K, L, NM1
      COMPLEX ZERO, ONE, TEMP
      DATA ZERO/(0.0E0,0.0E0)/, ONE/(1.0E0,0.0E0)/
C
      NM1 = N - 1
C
C        FIRST SOLVE  L*Y = B
C
         IF (NM1 .GT. 0) THEN
         DO 10 K = 1, NM1
            L = IPVT(K)
            IF(L .NE. K)THEN
            DO 20 J = 1, NRHS
            TEMP = B(K,J)
            B(K,J) = B(L,J)
            B(L,J) = TEMP
   20       CONTINUE
            END IF
            DO 10 I = K+1, N
            TEMP = A(I,K)
            IF(TEMP.NE.ZERO)THEN
            DO 30 J = 1, NRHS
            B(I,J) = B(I,J) + TEMP * B(K,J)
   30       CONTINUE
            END IF
   10    CONTINUE
         END IF
C
C        NOW SOLVE  U*X = Y
C
         DO 40 K = N, 1, -1
            TEMP  = ONE/A(K,K)
            DO 50 J = 1, NRHS
            B(K,J) = TEMP * B(K,J)
   50       CONTINUE
         DO 40 I = 1, K-1
         TEMP = A(I,K)
         IF(TEMP.NE.ZERO)THEN
         DO 60 J = 1, NRHS
         B(I,J) = B(I,J) - TEMP * B(K,J)
   60    CONTINUE
         END IF
   40    CONTINUE
C
          RETURN
          END
C
 
      SUBROUTINE PACKMA(NRO, NCOL, A, LDA, VEC, IPATH)
 
C     PACKS COMPLEX MATRIX A INTO COMPLEX VECTOR VEC  (IPATH=1)
C  OR UNPACKS COMPLEX VECTOR VEC INTO COMPLEX MATRIX A (IPATH=2)
C     A AND VEC CAN SHARE THE SAME STORAGE LOCATION WITH A(1,1)=VEC(1)
      COMPLEX A(LDA,*),VEC(*)
      INTEGER NRO,NCOL,LDA
 
      IF(IPATH .EQ. 1)THEN
      IVEC = 0
      DO 1 J = 1, NCOL
      DO 1 I = 1, NRO
      IVEC = IVEC + 1
      VEC(IVEC) = A(I,J)
   1  CONTINUE
 
      ELSE IF(IPATH.EQ.2)THEN
      IVEC = NRO*NCOL
      DO 2 J = NCOL, 1, -1
      DO 2 I = NRO, 1, -1
      A(I,J) = VEC(IVEC)
      IVEC = IVEC - 1
   2  CONTINUE
      END IF
 
      RETURN
      END
C
      INTEGER FUNCTION CEILQ(I,J)
      INTEGER I, J, MOD
      CEILQ = I / J
      IF(MOD(I,J).NE.0)CEILQ = CEILQ + 1
      RETURN
      END
C
C
C     Calls to input-output routines; case of Cray asynchronous queued
C     I/O:
C
      SUBROUTINE FBT_ASOP(IUNI)
C
C     Opens unit UNIT(IUNI), IUNI= 1 or 2.
C
      include 'cpar.com'
      include 'comzzz.com'
C
      INTEGER IUNI, ISTATU
C
      IF(IUNI.GE.1 .AND. IUNI.LE.2)THEN
C     Cray AQIO routine: commented out for use on alpha jphe 27/7/94
c$      CALL AQOPEN(AQP(1,IUNI),NAQP,UNIT(IUNI),ISTATU)
C     In case of anomalous exit:
c
c   jphe 25/4/94
c
      OPEN(UNIT=IUNI,ACCESS='DIRECT',STATUS='UNKNOWN',RECL=1024
     ; ,IOSTAT=ISTATU)
C     In case of anomalous exit:
      IF(ISTATU.NE.0)
     ;WRITE(NOFILE,*)'AQOPEN: UNIT #',UNIT(IUNI),' ISTATU=',ISTATU
      END IF
C
      RETURN
      END
C
C***********************************************************************
C
      SUBROUTINE FBT_ASCL(IUNI)
C
C     Closes unit UNIT(IUNI), IUNI = 1 or 2
C
      include 'cpar.com'
      include 'comzzz.com'
C
      INTEGER IUNI, ISTATU
C
      IF(IUNI.GE.1 .AND. IUNI.LE.2)THEN
C     Cray AQIO routine: commented out for alpha jphe 27/7/94
c$      CALL AQCLOSE(AQP(1,IUNI),ISTATU)
c$      ELSE
c$      WRITE(NOFILE,*)'No such unit id.', IUNI
c$      END IF
c
c  jphe 25/4/94
C
      CLOSE(UNIT=IUNI)
      ELSE
      WRITE(NOFILE,*) 'No such unit id.',IUNI
      ENDIF	
      RETURN
      END
C
C***********************************************************************
C
      SUBROUTINE FBT_ASRD(IUNI, NWORD, VEC, IQUEUE, NBLK)
C
C     Reads NWORD words on unit UNIT(IUNI), starting at current record
C     IBLK(IUNI), and stores them into real vector VEC.
C
C     IQUEUE=0: asks to process asynchronous request on UNIT(IUNI)
C     IQUEUE=1: queues the request without initiating input.
C
C     Subroutine output: NBLK, the number of blocks of length IOBLL read
C
C     N.B.: as blocked input is used, VEC must be large enough to
C     accomodate NBLK blocks of IOBLL words, that is the smallest number
C     of I/O blocks containing NWORD words.
C
      include 'cpar.com'
      include 'comzzz.com'
C
      INTEGER IUNI, NWORD, IQUEUE, CEILQ, NBLK, ISTATU
      REAL VEC(*)
C
      IF(IUNI.GE.1 .AND. IUNI.LE.2)THEN
      NBLK = CEILQ(NWORD,IOBLL)
      IREA(IUNI) = IREA(IUNI) + 1
C     Cray AQIO routine: COMMENTED OUT FOR USE ON ALPHA - JPHE 27/7/94
C$      CALL AQREAD(AQP(1,IUNI), VEC, IBLK(IUNI), NBLK, IREA(IUNI)
C$     ;           ,IQUEUE, ISTATU)
C$      IF(ISTATU.NE.0)
C$     ;WRITE(NOFILE,*)'AQREAD: UNIT #',UNIT(IUNI),' ISTATU=',ISTATU
C$      NBLRD(IUNI) = NBLRD(IUNI) + NBLK
C$      ELSE
C$      WRITE(NOFILE,*)'No such unit id.', IUNI
C$      END IF
C
c
C JPHE 25/4/94
c
      IREC=IBLK(IUNI)
      DO 2 I=1,NBLK
	READ(UNIT=IUNI,REC=IREC,IOSTAT=ISTATU)
     ;     (VEC(J),J=1+IOBLL*(I-1),I*IOBLL)
	IREC=IREC+1
 2    CONTINUE
        IF(ISTATU.GT.0)
     ;  WRITE(NOFILE,*)'AQREAD: UNIT #',UNIT(IUNI),' ISTATU=',ISTATU
        NBLRD(IUNI) = NBLRD(IUNI) + NBLK
        ELSE
        WRITE(NOFILE,*)'No such unit id.', IUNI
        END IF
c
c  jphe 25/4/94
C
C
      RETURN
      END
C
C***********************************************************************
C
      SUBROUTINE FBT_ASWR(IUNI, NWORD, VEC, IQUEUE, NBLK)
C
C     Writes NWORD words from real vector VEC on unit IUNI,
C     starting at current record IBLK(IUNI).
C
C     IQUEUE=0: asks to process asynchronous request on IUNI
C     IQUEUE=1: queues the request without initiating output.
C
C     Subroutine output: NBLK, the number of blocks of length
C     IOBLL written.
C
C     N.B.: as blocked output is used, VEC must be large enough to
C     accomodate NBLK blocks of IOBLL words, that is the smallest number
C     of I/O blocks containing NWORD words.
C
C
      include 'cpar.com'
      include 'comzzz.com'
C
      INTEGER IUNI, NWORD, IQUEUE, CEILQ, NBLK, ISTATU
      REAL VEC(*)
 
      IF(IUNI.GE.1 .AND. IUNI.LE.2)THEN
      NBLK = CEILQ(NWORD,IOBLL)
      IWRI(IUNI) = IWRI(IUNI) + 1
C     Cray AQIO routine: COMMENTED OUT FOR USE ON ALPHA --- JPHE 27/7/94
C$      CALL AQWRITE(AQP(1,IUNI), VEC, IBLK(IUNI), NBLK, IWRI(IUNI)
C$     ;            ,IQUEUE, ISTATU)
C$      IF(ISTATU.NE.0)
C$     ;WRITE(NOFILE,*)'AQWRITE: UNIT #',UNIT(IUNI),' ISTATU=',ISTATU
C$      NBLWR(IUNI) = NBLWR(IUNI) + NBLK
C$      ELSE
C$     WRITE(NOFILE,*)'No such unit id.', IUNI
C$      END IF
c
C JPHE 25/4/94
c
      IREC=IBLK(IUNI)
      DO 2 I=1,NBLK
	WRITE(UNIT=IUNI,REC=IREC,IOSTAT=ISTATU)
     ;     (VEC(J),J=1+IOBLL*(I-1),I*IOBLL)
	IREC=IREC+1
2     CONTINUE
        IF(ISTATU.GT.0)
     ;  WRITE(NOFILE,*)'AQWRITE: UNIT #',UNIT(IUNI),' ISTATU=',ISTATU
        NBLWR(IUNI) = NBLWR(IUNI) + NBLK
        ELSE
        WRITE(NOFILE,*)'No such unit id.', IUNI
        END IF
c
c  jphe 25/4/94
C
      RETURN
      END
C
C***********************************************************************
C
      SUBROUTINE FBT_ASWA(IUNI)
C
c  completely commented out for use on alpha -- jphe 27/7/94
C     Waits for completion of asynchronous I/O on unit UNIT(IUNI)
C     IUNI = 1 or 2
C
c$      include 'source_fppmod:cpar.com'
c$      include 'source_fppmod:comzzz.com'
C
c$      INTEGER IUNI, ISTATU
C
c$      IF(IUNI.GE.1 .AND. IUNI.LE.2)THEN
C     Cray AQIO routine:
c$      CALL AQWAIT(AQP(1,IUNI),ISTATU)
c$      IF(ISTATU.NE.0)
c$     ;WRITE(NOFILE,*)'AQWAIT: UNIT #',UNIT(IUNI),' ISTATU=',ISTATU
c$      ELSE
c$      WRITE(NOFILE,*)'No such unit id.', IUNI
c$      END IF
C
      RETURN
      END
C
C***********************************************************************
C
      INTEGER FUNCTION FBT_IIMAX(N, IX)
C
C     Returns the index of the largest component in integer vector IX(N)
C
      INTEGER N, IX(*)
      IF(N.LE.0)THEN
      FBT_IIMAX = 0
      ELSE IF(N.EQ.1)THEN
      FBT_IIMAX = 1
      ELSE
      FBT_IIMAX = 1
      DO 1 I = 2, N
      IF(IX(I).GT.IX(FBT_IIMAX))FBT_IIMAX=I
  1   CONTINUE
      END IF
      RETURN
      END
C
      INTEGER FUNCTION FBT_IIMIN(N, IX)
C
C     Returns the index of the smallest component in integer vector
C     IX(N)
C
      INTEGER N, IX(*)
      IF(N.LE.0)THEN
      FBT_IIMIN = 0
      ELSE IF(N.EQ.1)THEN
      FBT_IIMIN = 1
      ELSE
      FBT_IIMIN = 1
      DO 1 I = 2, N
      IF(IX(I).LT.IX(FBT_IIMIN))FBT_IIMIN=I
  1   CONTINUE
      END IF
      RETURN
      END
C***********************************************************************
C     The following function can be removed on Cray (an equivalent
C     function appears in the Cray scientific library).
      INTEGER FUNCTION FBT_ISUM(N, IVEC, INCV)
      INTEGER N, IVEC(*), INCV, I, J
      FBT_ISUM = 0
      IF(N.LE.0)RETURN
      J = 1
      IF(INCV.LT.0)J = (-N+1)*INCV + 1
      DO 1 I = 1, N
      FBT_ISUM = FBT_ISUM + IVEC(J)
      J = J + INCV
    1 CONTINUE
      RETURN
      END
