c
c=======================================================================
c   .    1    .    2    .    3    .    4    .    5    .    6    .    7
c=======================================================================
c
      subroutine fields(hvec)
c
      include 'SPRINC'
c
      complex acoef(nchi*npsi),bcoef(nchi*npsi),bchi(nchi*npsi),
     %        ccoef(nchi*npsi),dcoef(nchi*npsi),bpsi(nchi*npsi),
     %        ecoef(nchi*npsi),fcoef(nchi*npsi),gcoef(nchi*npsi),
     %        hphi(nchi*npsi),echi(nchi*npsi),epsi(nchi*npsi),
     %        cwork1(nchi*npsi),cwork2(nchi*npsi),divep(nchi*npsi),
     %        cwork3(nchi*npsi),cwork4(nchi*npsi),ephi(nchi*npsi),
     %        hvec(nchi*npsi),eye,ctest,chitmp,psitmp,swave,spolar
      real rmaj(nchi*npsi),zed(nchi*npsi),hpsi(nchi*npsi),
     %     hchi(nchi*npsi),psi(npsi),chi(nchi),pquad(npsi),pcoef(nchi)
      common /metric/ rmaj,zed,hpsi,hchi,psi,chi,pquad,pcoef
     %       /cwork/ cwork1,cwork2,cwork3,cwork4
     %       /spfldcom/ hphi,echi,epsi
     %       /spfl2com/ ephi,bchi,bpsi,divep
     %       /coef/ acoef,bcoef,ccoef,dcoef,ako2
     %       /soef/ ecoef,fcoef,gcoef
c
c     FIELDS calculates the electric and magnetic fields from the
c     solution vector of the wave equation. Hphi is a simple
c     renormalisation of hvec, Epsi and Echi are combinations of
c     the first derivatives of Hphi, and Divperp(Eperp) is the only
c     second derivative of Hphi, since Rotperp(Eperp) is Hphi itself.
c     The other components are simple combinations of these main
c     field components and will be calculated in subroutine powers
c     where the necessary dielectric tensor elements will be
c     available.
c
      data cutoff /.1/
c
      hnorm=2.65442e-3*sqrt(ako2)
      ntot=nchi*npsi
      norigl=nchi
      nbodyf=nchi+1
c
      call dpsi(hvec,cwork1)
      call SPRFIL(cwork1,2)
      call dpsi(cwork1,cwork3)
      call SPRFIL(cwork3,2)
      do 10 i=1,norigl
   10 cwork4(i)=cwork1(i)
      do 11 i=nbodyf,ntot
   11 cwork4(i)=hvec(i)
      call dchi(cwork4,cwork2)
      call dchi(cwork2,cwork4)
      do 12 i=1,ntot
      cwork1(i)=cwork1(i)*cmplx(1./hpsi(i),0.)
   12 cwork3(i)=cwork3(i)*acoef(i)*cmplx(hchi(i)/(hpsi(i)*rmaj(i)),0.)
      do 13 i=1,norigl
      cwork2(i)=cwork2(i)*cmplx(pcoef(i)/hpsi(i),0.)
   13 cwork4(i)=cwork4(i)*acoef(i)*cmplx(pcoef(i)/rmaj(i),0.)
      do 14 i=nbodyf,ntot
      cwork2(i)=cwork2(i)*cmplx(1./hchi(i),0.)
   14 cwork4(i)=cwork4(i)*acoef(i)*cmplx(hpsi(i)/(hchi(i)*rmaj(i)),0.)
c
c     Toroidal component of magnetic field
c
      do 20 i=1,ntot
   20 hphi(i)=cmplx(0.,-hnorm/rmaj(i))*hvec(i)
c
c     Poloidal-plane components of the electric field
c     (These formulas degenerate near cutoff, where a,b -> infinity)
c
      do 30 i=1,ntot
      echi(i)=(cwork1(i)*acoef(i)+cwork2(i)*bcoef(i))*
     %                                           cmplx(-1./rmaj(i),0.)
   30 epsi(i)=(cwork1(i)*bcoef(i)-cwork2(i)*acoef(i))*
     %                                           cmplx(-1./rmaj(i),0.)
c
c     Recalculate electric fields near cutoffs by using
c     wave equation and the nondegenerate polarization
c
      do 40 i=1,ntot
      ctest=bcoef(i)/acoef(i)
      Ztemp = cabs((1.,0.)+ctest**2)
      if (Ztemp.lt.cutoff) then
      eye=cmplx(0.,sign(1.,-aimag(ctest)))
      ctest=(acoef(i)+eye*bcoef(i))*(fcoef(i)+eye*ecoef(i))
      if (cabs(ctest).ne.0.) then
      swave=cwork3(i)+cwork4(i)+
     %                  hvec(i)*cmplx(ako2*hchi(i)*hpsi(i)/rmaj(i),0.)
      spolar=(cwork1(i)+eye*cwork2(i))*gcoef(i)*cmplx(-1./rmaj(i),0.)
      chitmp=((-bcoef(i)+eye*acoef(i))*swave+fcoef(i)*spolar)/ctest
      psitmp=((acoef(i)+eye*bcoef(i))*swave-ecoef(i)*spolar)/ctest
      if (real(chitmp*conjg(chitmp)+psitmp*conjg(psitmp)).lt.
     %    real(echi(i)*conjg(echi(i))+epsi(i)*conjg(epsi(i)))) then
      echi(i)=chitmp
      epsi(i)=psitmp
      endif
      endif
      endif
   40 continue
c
c     Recalculate electric fields near origin by using
c     wave equation and the angle derivative.
c
      do 50 i=1,ntot
      jpsi=1+(i-1)/nchi
      if (psi(jpsi).lt.cutoff**2) then
      ctest=acoef(i)*ecoef(i)+bcoef(i)*fcoef(i)
      if (cabs(ctest).ne.0.) then
      swave=cwork3(i)+cwork4(i)+
     %                  hvec(i)*cmplx(ako2*hchi(i)*hpsi(i)/rmaj(i),0.)
      spolar=cwork2(i)*gcoef(i)*cmplx(1./rmaj(i),0.)
      chitmp=(acoef(i)*swave-fcoef(i)*spolar)/ctest
      psitmp=(bcoef(i)*swave+ecoef(i)*spolar)/ctest
      if (real(chitmp*conjg(chitmp)+psitmp*conjg(psitmp)).lt.
     %    real(echi(i)*conjg(echi(i))+epsi(i)*conjg(epsi(i)))) then
      echi(i)=chitmp
      epsi(i)=psitmp
      endif
      endif
      endif
   50 continue
c
c     Divergence of the poloidal components of the E-field
c
      do 60 i=1,ntot
      cwork1(i)=epsi(i)*rmaj(i)*hchi(i)
   60 cwork2(i)=echi(i)*rmaj(i)*hpsi(i)
c
      call dpsi(cwork1,cwork3)
      call dchi(cwork2,cwork4)
      do 61 i=1,ntot
   61 cwork1(i)=cwork3(i)+cwork4(i)
      call dpsi(cwork1,cwork2)
      do 62 i=1,norigl
   62 divep(i)=cwork2(i)*pcoef(i)/(rmaj(i)*hpsi(i)**2)
      do 63 i=nbodyf,ntot
   63 divep(i)=cwork1(i)/(rmaj(i)*hpsi(i)*hchi(i))
c
      call SPRFIL(hphi,0)
      call SPRFIL(echi,0)
      call SPRFIL(epsi,0)
      call SPRFIL(divep,0)
c
      return
      end
