	subroutine fpdepo(f1rad,fnbsours)
c
c calculates the particle source fnbsours(energy,angle,radius) due to
c neutral beam injection.  This subroutines calls DEPO for each
c different beam injector.  fnbsours is in units of particles/sec.
c
	include 'FPPCOM'
	include 'F1COM'
 
	do 310 ish=1,nshell
	do 310 ixi=1,maxxsi
	do 310 ien=0,maxen
310	fnbsours(ien,ixi,ish)=0.0
 
c find deposition by each neutral beam injector:
	do 350 i=1,numnbi
 
	rtan=rbeams(i)
	VBeamInj=vbeams(i)
	PBeamInj=pbeams(i)
	PtFrbeam(1)=BmixFull(i)
	PtFrbeam(2)=BmixHalf(i)
	PtFrbeam(3)=1.0-Ptfrbeam(1)-Ptfrbeam(2)
	NBemNum=i
 
	do 320 ien=1,3
	do 320 k=1,maxxsi
	do 320 j=1,nshell
320	dep(j,k,ien)=0.0
 
	bukw=0.0
	blkw=0.0
 
	if(PBeamInj .gt. 0.0 .and. toff .gt. tstart)CALL DEPO
 
c--find full, half, and third energies of beam on general grid:
c loop over full, half, and third energy components:
	do 330 k=1,3
	zen=vbeams(i)/k
c remember that enerev(0:maxen) is the dimension:
	ien=lkupr(zen,enerev,maxen+1)-1
	NInj123(k,i)=ien
	if((zen-enerev(ien)) .gt. (enerev(ien+1)-zen))
	1   NInj123(k,i)=ien+1
330	continue
 
	do 340 ish=1,nshell
	do 340 ixi=1,maxxsi
	do 340 ien=1,3
	iii=NInj123(ien,i)
340	fnbsours(iii,ixi,ish)=fnbsours(iii,ixi,ish)+dep(ish,ixi,ien)
 
	BPshthru(i)=bukw*1000.
	BPprompt(i)=blkw*1000.
350	continue
 
	return
	end
