	subroutine FPdflt
 
c set up FPP default values, or values (such as the Energy grid maximum)
c that must be set only once.
c Note:  Any value set by FPdflt needs to be in TRCOM to ensure that it
c is saved if the transp run is stopped and restarted!
 
c TRANSP common block:
	include 'TRCOM'
 
c All FPP common blocks:
	include 'FPPCOM'
	include 'SPRINC'    !SPRUCE (ICRF wave code) parameters
 
c lsysout is set again by TRTOFP to ensure restartability, but
C we set it here for use in this routine:
	lsysout=nonlin	 !transp/olympus file for "terminal" output
 
c First type out some informational messages about the value of various
c fortran PARAMETERS:
c--type out size of grids:
	idum1=maxen
	idum2=maxxsi
	idum3=maxtim
	idum4=maxshe
	write(lsysout,*) 'Initializing the FPP Fokker-Planck package'
	write(lsysout,*)
	1   '# of energy grid points      MAXEN =',idum1,' +1'
	write(lsysout,*)'# of pitch angle grid points MAXXSI=',idum2
	write(lsysout,*)'Max # of time points         MAXTIM=',idum3
	write(lsysout,*)'Max # of radial shells       MAXSHE=',idum4
 
	idum1=npsi
	idum2=nchi
	write(lsysout,*)'SPRUCE ICRF wave code being run with'
	write(lsysout,*)
	1   '     ',idum1,' radial and ',idum2,' poloidal grid points'
 
 
	if(npltf .ne. 0 .and. (MfPrecX .ne. 40 .or
	1	. MfPrecY .ne. 25 .or. MfPrecZ .ne. 100))then
	write(lsysout,*)
	1   '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	write(lsysout,*)
	1 ' the dimensions of the fprec array in FPP''s common block'
	write(lsysout,*)
	1   ' were reduced to save space.  They must be enlarged'
	write(lsysout,*)
	1   ' and the program must be recompiled before you can '
	write(lsysout,*)
	1   ' calculate f(v-precession) for fishbone stability'
	write(lsysout,*) ' caculations.'
	call abortr(lsysout)
	endif
 
c check various parameters for consistency between TRANSP and FPP:
	if(mifpen .ne. maxen+1)then
	    write(lsysout,*) 'mifpen .ne. maxen+1.  Recompile FPP.'
	    call abortr(lsysout)
	endif
	if(mifpxi .ne. maxxsi)then
	    write(lsysout,*) 'mifpxi .ne. maxxsi.  Recompile FPP.'
	    call abortr(lsysout)
	endif
	if(mifpsh .ne. maxshe)then
	    write(lsysout,*) 'mifpsh .ne. maxshe.  Recompile FPP.'
	    call abortr(lsysout)
	endif
 
c choose the maximum energy on the energy grid.
c This is not the best algorithm in the world, but for now it will do:
 
	fpEmax=1.5*Ebdmax
 
	return
	END
