	subroutine fpgeogrd(ztheta,zdbpsi,zdbtheta,zdlqpsi)
c
c Fokker-Planck geometry gradients:
c
c input: ztheta	  poloidal angle:
c output:
c   zdbpsi    dB/dPsi
c   zdbtheta  dB/dTheta
c   zdlqpsi   (dq/dPsi)/q
c
	include 'FPPCOM'
	real zJac(2,2)
 
C low-beta, concentric, circular flux surface approximations:
c
c	zRlocal=Rmaj+rminpro(nshe)*cos(ztheta)
c	zdbpsi=-cos(ztheta)*qpro(nshe)/zRlocal/rminpro(nshe)
c	zdbtheta=sin(ztheta)*rminpro(nshe)*Btor*Rmaj/zRlocal**2
c	zdlqpsi=dqdrpro(nshe)/rminpro(nshe)/(Btor*Rmaj/zRlocal)
c
 
c Use general geometry formulas, but still assuming B=Btor*Rmaj/zRlocal:
 
	zx=rminpro(nshe)/rmin
	call momry(zx,ztheta,1,zR,zY,zJac)
 
	zB=Btor*Rmaj/zR
	zdbpsi=-zB/zR*pifpp*qpro(nshe)/zx/tflxtot*zJac(1,1)
	zdbtheta=-zB/zR*zJac(1,2)
	zdlqpsi=dqdrpro(nshe)*rmin*pifpp/(zx*tflxtot)
 
	return
	end
