	subroutine FPichSIM
c
c A simple ICH model to study the sensitivity of TRANSP to the
c results of the ICH model.
c
 
	include 'TRCOM'
	include 'FPPCOM'
 
	real zPichpro(mj)   ! ICH P(r) (Watts/cc)
 
c main inputs are:
	data zichfri /0.5/ ! fraction of ICH power to ions
c nicrf=3:
	data zichsig /10./ ! ICH P(r) gaussian width (cm)
c nicrf=4:
	data zichlam /42./ ! ICH P(r) exponential width (cm)
 
c find total ICH power:
	zprftot=0.0
	do 50 iant=1,nicha
	if(tb .ge. tonicha(iant) .and. tb .le. tofficha(iant))
	1	zprftot=zprftot+prficha(iant)
50	continue
 
c find ICH power profile:
	zsum=0.0
	do 60 j=lcentr,ledge
	if(nicrf .eq. 3)then
	zPichpro(j)=zprftot*exp(-rzon(j)**2/2./zichsig**2)
	else if(nicrf .eq. 4)then
	zPichpro(j)=zprftot*exp(-rzon(j)/zichlam)/rzon(j)
	else
	call aborter(lsysout,
	1   'FPICHSIM called with NICRF .ne. 3 or 4')
	endif
60	zsum=zsum+zPichpro(j)*dVol(j,2)
 
	if(zprftot .gt. 0.0)then
	do 65 j=lcentr,ledge
65	zPichpro(j)=zPichpro(j)*zprftot/zsum
	endif
 
c ion and electron heating powers:
	do 100 j=lcentr,ledge
	jshell=j-lcentr+1
	Pminthi(j)=zichfri*zPichpro(j)
	Pmine(j)=0.0
	Pmincx(j)=0.0
	Pminloss(j)=0.0
	Pminstor(j)=0.0
 
	eminpar(j)=0.5*ti(j,2)	!minority parallel energy
	eminper(j)=ti(j,2)	!minority perpendicular energy
 
c Direct ICRF Heating profiles:
	Piche(j)=(1.0-zichfri)*zPichpro(j)
	Pichmc(j)=0.0
	Pichmin(j)=zichfri*zPichpro(j)
	Pichthi(j)=0.0
 
c	do 50 ion=1,nions-1
c50	Pichthi(j)=Pichthi(j)+Pichspec(jshell,ion)
 
	Pichall(j)=Pichthi(j)+Piche(j)+Pichmc(j)+Pichmin(j)
 
c total heating of electrons by direct ICH and minority drag:
	Peicrf(j)=Pmine(j)+Piche(j)+Pichmc(j)
c total heating of thermal ions by direct ICH and minority drag:
	Piicrf(j)=Pminthi(j)+Pichthi(j)
 
100	continue
 
	richcres(1)=Rantich	!antenna loading resistance
 
c  advance tlicrf to the beginning of the current ICRF time step:
	if(tlicrf .lt. tcrfon)then
	  tlicrf=tcrfon
	else
	  tlicrf=tlicrf+dticrf
	endif
 
	return
	end
