	subroutine FPtoTRic
c
c converts FPP ICH calculations to TRANSP format
c
c TRANSP doesn't know as much about the RF minority ions as
c it does about the beam species, so FPtoTRic is much shorter
c and simpler than FPtoTR.
c
C Mod RCG August,1994 Minor changes for minority ion sawtooth model (see 'rcg').
C
	include 'TRCOM'
	include 'FPPCOM'
 
 
c renormalize minority-to-plasma powers so that we account for all
c of the rf power:
	zpichmin=0.0
	zmindot=0.0
	zminloss=0.0
	zabssum=0.0
	do 25 j=lcentr,ledge
	jshell=j-lcentr+1
	zpichmin=zpichmin + pichspec(jshell,nions)*dvol(j,2)
	zmindot=zmindot + rpbdw(jshell)*dvol(j,2)
	zminloss=zminloss + (rpbi(jshell)+rpbe(jshell)+rpbc(jshell)
	1   +rpbl(jshell))*dvol(j,2)
	zabssum=zabssum + (abs(rpbi(jshell))+abs(rpbe(jshell))
	1   +abs(rpbc(jshell)) +abs(rpbl(jshell)))*dvol(j,2)
 
25	continue
	zabssum=zabssum+abs(zmindot)+abs(zpichmin)
 
	zerr=zpichmin-zmindot-zminloss
	zrelerr=zerr/zabssum
	if(zminloss .ge. 0.05*zabssum .and. zrelerr .gt. .03) then
	  zcorr=(zerr+zminloss)/zminloss
	else
	  zcorr=1.0
	endif
 
c don't bother trying to add correction to the first step,
c where we know the errors may be very large because rkpcorr hasn't
c been initialized properly yet.
 
c rcg	Also, don't test if minority ion sawtooth model rearranged
c	the df on this fpp call.
 	if(tlicrf .eq. tcrfon .or.
	1 (ta .eq. tsaw .and. nlsawic)) then
c rcg end modification
 
	    zcorr=1.0
	else
	if(zrelerr .gt. .05) write(lsysout,*)
	1 'fptotric warning, fpp relative error = ',zrelerr
 
c bomb out if errors are to large, unless this is after the
c RF has shut off, in which case ignore any corrections:
 
	if( (zcorr .lt. .1 .or. zcorr .gt. 10.0) .and.
	1 zrelerr .gt. 0.2) call
	1   aborter(lsysout,'errors in FPP too large!')
	endif
 
	do 30 jshell=1,nshell
	rpbi(jshell)=rpbi(jshell)*zcorr
	rpbe(jshell)=rpbe(jshell)*zcorr
	rpbc(jshell)=rpbc(jshell)*zcorr
	rpbl(jshell)=rpbl(jshell)*zcorr
30	continue
 
c ion and electron heating powers:
	do 100 j=lcentr,ledge
	jshell=j-lcentr+1
	Pminthi(j)=rpbi(jshell)
	Pmine(j)=rpbe(jshell)
	Pmincx(j)=rpbc(jshell)
	Pminloss(j)=rpbl(jshell)
	Pminstor(j)=rpbdw(jshell)
 
	eminpar(j)=0.5*rbtpar1(jshell)*1.e3
	eminper(j)=1.5*rbtemp1(jshell)*1.e3-eminpar(j)
	tmini(j,2)=2./3.*(eminpar(j)+eminper(j))
 
c Direct ICRF Heating profiles:
	Piche(j)=Pichspec(jshell,nions+1)
	Pichmc(j)=Pichspec(jshell,nions+2)
	Pichmin(j)=Pichspec(jshell,nions)
	Pichthi(j)=0.0
	do 50 ion=1,nions-1
50	Pichthi(j)=Pichthi(j)+Pichspec(jshell,ion)
	Pichall(j)=Pichthi(j)+Piche(j)+Pichmc(j)+Pichmin(j)
 
c total heating of electrons by direct ICH and minority drag:
	Peicrf(j)=Pmine(j)+Piche(j)+Pichmc(j)
c total heating of thermal ions by direct ICH and minority drag:
	Piicrf(j)=Pminthi(j)+Pichthi(j)
 
100	continue
 
	richcres(1)=Rantich	!antenna loading resistance
 
c  advance tlicrf to the END of the current ICRF time step:
	tlicrf=tlicrf+tcalc
 
c use last few elements of richcres to save some stuff for restarting:
c?:
	if(Nicha .ge. miicha)then
	  write(lsysout,*)'Fatal error in fptotric.'
	  write(lsysout,*)'Nicha must be < miicha until this kluge'
	  write(lsysout,*)'gets fixed.'
	  call aborter(lsysout,' ')
	endif
 
	richcres(miicha)=zerr
 
ctmp: temporarily save rkpcpro in fpfrad for restarting, until we
c get a new PORT.FOR variable array defined.
 
	do 150 j=lcentr,ledge
	jshell=j-lcentr+1
	fpfrad(mifpen,mifpxi,jshell,mibsp1-1)=rkpcpro(jshell)
	richdcor(j)=qldamp(jshell)
150	continue
	richkrho=rkpcorr	! avg kperp*rho correction
 
c rcg	Ensure restartibility for the minority ion sawtooth
c	model, SR SAWFPPIC, by copying arrays into TRCOM.
 
	do ishell=1,maxshe
	rminsav(ishell)=rminpro(ishell)
	do j=1,maxxsi
	btxsiic(j,ishell)=btxsi(j,ishell)
	enddo
	enddo
 
	return
	end
