C******************** START FILE MOMRZ.FOR ; GROUP TKSERVE *************
	SUBROUTINE MOMRZ (ZXI,ZTHETA,IJAC,ZR99,ZY99,ZJAC,
     &                                           RDUM,ZDUM,R00,Z00)
 
	REAL ZXI, ZTHETA
	INTEGER	IJAC
	REAL ZR99, ZY99, ZJAC(2,2)
 
C
C       J.ONGENA - M.EVRARD : ADAPTED FROM MOMRY FOR THE NEW SPRUCE
C                             WE SUBTRACT THE MAGNETIC AXIS IN ORDER TO
C                             KEEP MAXIMUM POSITION PRECISION FOR
C                             THE SPRUCE ORTHOGONAL GRID CALCULATION
C
C
C       B.BALET  JET MAR 1994 : ROUTINE MODIFIED TO SUPPORT UP-DOWN
C                               ASYMMETRIC CASE
C
C	THE "MOMENTS" GEOMETRY HAS:
C       -> UP-DOWN SYMMETRIC CASE:
C		ZR99 = R0SPL(ZXI) + SUMJ[RMOMJ(ZXI)*COS(J*ZTHETA)]
C		ZY99 = SUMJ[YMOMJ(ZXI)*SIN(J*ZTHETA)]
C			[J=1 -> NMOM]
C
C       -> UP-DOWN ASYMMETRIC CASE:
C              ZR99 = SUMJ[RMCXJ(ZXI,1)*COS(J*ZTHETA) +
C                          RMCXJ(ZXI,2)*SIN(J*ZTHETA) ]
C              ZY99 = SUMJ[YMCXJ(ZXI,1)*COS(J*ZTHETA) +
C                          YMCXJ(ZXI,2)*SIN(J*ZTHETA) ]
C                       [J=1 -> NMOM]
C
C	!! SUBROUTINE <BLOAT> MUST HAVE BEEN CALLED ... IN ORDER
C	!! THAT THE APPROPRIATE "BLOATED & SPLINED" COEFFICIENT
C	!! ARRAYS ARE PROPERLY INITIALIZED.
C
C	INPUT	
C	-----
C	ZXI	MINOR RADIUS IN MOMENTS GEOMETRY
C	ZTHETA	POLOIDAL ANGLE (RADIANS) IN MOMENTS GEOMETRY
C    MOD DMC APR 1990  -- IJAC CONTROLS SPLINE/LINEAR INTERP. AS WELL
C	IJAC:
C          SPLINE:
C               IJAC=0 FOR ZR99 & ZY99 ONLY; 1 FOR JACOBIAN AS WELL
C          LINEAR:
C               IJAC=2 FOR ZR99 & ZY99 ONLY; 3 FOR JACOBIAN AS WELL
C
C	OUTPUT	
C	------
C	ZR99
C	ZY99
C	ZJAC = D(R,Y)/D(XI,THETA) IF REQUESTED CF IJAC
C
C.............................................
C
	INCLUDE 'TRCOM'
 
	INCLUDE 'TRKRB'
C.............................................
 
	REAL ZXISV, ZTHETASV, ZR99SV, ZY99SV, ZJACSV(2,2)
	REAL ZSNTHTK(MIMOM), ZCSTHTK(MIMOM)
	LOGICAL ZNEWXI, ZNEWTH, ZNEWIJAC
	INTEGER IJACSV
 
	SAVE ZXISV, ZTHETASV, IJACSV, ZR99SV, ZY99SV, ZJACSV
	SAVE ZSNTHTK, ZCSTHTK
 
 
	DATA ZXISV /1.77E+22/
	DATA ZTHETASV /1.77E+22/
	DATA IJACSV /1234567/
 
C............................................
C	CHECK FOR INVALID "XI" RANGE
C
	IF (ZXI .LT. 0. .OR. ZXI .GT. ZXIGHO77) THEN
	   WRITE(NONLIN,3333) ZXI,ZXIGHO77
	   WRITE(NOUT,  3333) ZXI,ZXIGHO77
3333	   FORMAT(' ?? "MOMRY" ARGUMENT RANGE ERROR:',
     >		  ' ZXI= ',1PE13.5,'; ZXIGHO77= ',E13.5,/
     >		  ' ?? CALLING TKCRASH')
	   CALL TKCRASH
	END IF
	ZZXI=AMAX1(1.E-6,ZXI)
C............................................
        ZNEWXI=.TRUE.
	ZNEWTH=.TRUE.
	ZNEWIJAC=.TRUE.
C
C	ZNEWMHD is set in BLOAT and resides in COMMON /SCRATCH/
C
C............................................
C	RADIAL DERIVATIVES
C
        IF(LEVGEO.EQ.6) THEN           !UP-DOWN ASYMMETRIC CASE
C
          CALL SPLCRDA (ZZXI,ZNEWXI,IJAC,ZNEWJAC,
     >                RMSPLC,RMSPLS,YMSPLC,YMSPLS,
     >                DRMDROC,DRMDROS,DYMDROC,DYMDROS)
C
 
        ELSE                           !UP-DOWN SYMMETRIC CASE
C
 
          CALL SPLCRD (ZZXI,ZNEWXI,IJAC,ZNEWIJAC,
     >		     R0SPL,RMSPL,YMSPL,DR0DRO,DRMDRO,DYMDRO)
C
        ENDIF
          CALL SINCOS(ZTHETA,NMOM,ZSNTHTK,ZCSTHTK)
C
          IF (LEVGEO .EQ. 6) THEN           !UP-DOWN ASYMMETRIC CASE
C
            RDUM = RMSPLC(0)
            ZDUM = YMSPLC(0)
            ZR99 = RMSPLC(0)-R00
            ZY99 = YMSPLC(0)-Z00
            DO 51 IMUL=1,NMOM
              ZR99 = ZR99 + RMSPLC(IMUL)*ZCSTHTK(IMUL)
     >               + RMSPLS(IMUL)*ZSNTHTK(IMUL)
              ZY99 = ZY99 + YMSPLC(IMUL)*ZCSTHTK(IMUL)
     >               + YMSPLS(IMUL)*ZSNTHTK(IMUL)
51          CONTINUE
C
          ELSE                              !UP-DOWN SYMMETRIC CASE
C
 
            RDUM = R0SPL
            ZDUM = 0.
	    ZR99 = R0SPL-R00
	    ZY99 = -Z00
	    DO 50 IMUL=1,NMOM
		ZR99=ZR99+RMSPL(IMUL)*ZCSTHTK(IMUL)
		ZY99=ZY99+YMSPL(IMUL)*ZSNTHTK(IMUL)
50	    CONTINUE
C
          ENDIF
C
C	GRADIENTS IN THE TRANSFORMATION
C
	IF (IJAC .EQ. 1 .OR. IJAC .EQ. 3)  THEN
C
          IF (LEVGEO .EQ. 6) THEN           !UP-DOWN ASYMMETRIC CASE
C
            ZJAC(1,1)= DRMDROC(0)
            ZJAC(1,2)= 0.0
C
            ZJAC(2,1)= DYMDROC(0)
            ZJAC(2,2)= 0.0
C
            DO 151 IMUL=1,NMOM
C
              ZC = ZCSTHTK(IMUL)
              ZS = ZSNTHTK(IMUL)
C
              ZJAC(1,1) = ZJAC(1,1) + DRMDROC(IMUL)*ZC
     >                    + DRMDROS(IMUL)*ZS
              ZJAC(1,2) = ZJAC(1,2) - RMSPLC(IMUL)*IMUL*ZS
     >                    + RMSPLS(IMUL)*IMUL*ZC
C
              ZJAC(2,1) = ZJAC(2,1) + DYMDROC(IMUL)*ZC
     >                    + DYMDROS(IMUL)*ZS
              ZJAC(2,2) = ZJAC(2,2) - YMSPLC(IMUL)*IMUL*ZS
     >                    + YMSPLS(IMUL)*IMUL*ZC
C
151         CONTINUE
C
          ELSE                              !UP-DOWN SYMMETRIC CASE
C
            ZJAC(1,1)=DR0DRO
            ZJAC(1,2)=0.0
C
            ZJAC(2,1)=0.0
            ZJAC(2,2)=0.0
C
            DO 150 IMUL=1,NMOM
C
              ZJAC(1,1)=ZJAC(1,1)+DRMDRO(IMUL)*ZCSTHTK(IMUL)
	      ZJAC(1,2)=ZJAC(1,2)-RMSPL(IMUL)*IMUL*ZSNTHTK(IMUL)
C
	      ZJAC(2,1)=ZJAC(2,1)+DYMDRO(IMUL)*ZSNTHTK(IMUL)
	      ZJAC(2,2)=ZJAC(2,2)+YMSPL(IMUL)*IMUL*ZCSTHTK(IMUL)
C
150	    CONTINUE
C
          ENDIF
C
C  TEST FAILS ONLY IF DETERMINANT IS 0
C
	    ZDTEST=ZJAC(1,1)*ZJAC(2,2) - ZJAC(1,2)*ZJAC(2,1)
	    IF(ZDTEST.EQ.0.0) THEN
	   	WRITE(NONLIN,3337) ZXI, ZDTEST, ZJAC
	   	WRITE(NOUT,  3337) ZXI, ZDTEST, ZJAC
3337	   	FORMAT(' ?? "MOMRY" SINGULAR JACOBIAN ERROR:',
     >		  ' ZXI= ',1PE13.5,'; D= ',1PE13.5,/
     >            ' ZJAC= ',4E13.5,/
     >		  ' ?? CALLING TKCRASH')
	   	CALL TKCRASH
	    END IF
 
 
 
	END IF
C
C
C	FOR ALIEN USERS, GIVE THEM SOME CAKE
C	UPDATE SNTHTK & CSTHTK ARRAYS IN TRANS.COM
	DO 300 I = 1, NMOM
	   SNTHTK(I) = ZSNTHTK(I)
	   CSTHTK(I) = ZCSTHTK(I)
300	CONTINUE
 
 
	RETURN
	END
C
C******************** END FILE MOMRY.FOR ; GROUP TKSERVE ***************
