c
c=======================================================================
c   .    1    .    2    .    3    .    4    .    5    .    6    .    7
c=======================================================================
c
      subroutine plasma(ichi,jpsi)
c
c     PLASMA provides the plasma parameters and magnetic field on the
c     psi and chi grid points.
c
c NIONS renamed to INUMIONS to avoid name conflict with FPPCOM
c
      include 'FPPCOM'
      include 'SPRINC'
      include 'SPRUCOM'
c
c  jphe 4-apr-1995  tests : put isotropic tensor
c
c      logical lisot /.false./
      logical lisot /.true./
 
      integer inumions   ! number of ion species
      real npar          ! kpar/k0
      real omega         ! twopi* RF_frequency [s-1]
      real bmag          ! local magnetic field
      real dense         ! electron density [m-3]
      real teper         ! perpendicular electron temperature [keV]
      real tepar         ! parallel electron temperature [keV]
      real awi(ionmax)   ! ion atomic mass Ai
      real qi(ionmax)    ! ion charge      Zi
      real densi(ionmax) ! ion density [m-3]
      real tiper(ionmax) ! perpendicular ion temperature [keV]
      real tipar(ionmax) ! parallel ion temperature [keV]
c
      common /plasma_cmn/ npar,omega,bmag,dense,teper,tepar,awi,qi,
     %                    densi,tiper,tipar,inumions
 
c
c   jphe - added 5/9/94  to debug (these arrays are plotted in sprout.for)
c
c      common /cntrplt/ adense(nchi,npsi),atempe(nchi,npsi),
c     %                 adensi(nchi,npsi,ionmax+1),
c     %                 atiper(nchi,npsi,ionmax+1),
c     %                 atipar(nchi,npsi,ionmax+1),nnions
c end 5/9/94 debug
 
c
c npar and omega will be defined in coefts !
c
      bmag=Btor/1.e4*rmaj/100./rmajich(ichi,jpsi)
c
      call ctrans(ichi,jpsi,zr)
c
      dense=1.e6*fpintrp(zr,drelec,rminpro,nshell)
      teper=1.e-3*fpintrp(zr,trelec,rminpro,nshell)
c
c  Electrons are always isotropic
c
      tepar=teper
c
      if(nions .gt. ionmax)then
          call aborter(lsysout,
     1   'ICH3d can not handle this many ion species')
      else
          inumions=nions
      endif
c
      do i=1,nions
      awi(i)=nAions(i)
      qi(i)=nZions(i)
      densi(i)=1.e6*fpintrp(zr,drions(1,i),rminpro,nshell)
      if(i.eq.nfasti) then
      densi(i)=densi(i)*fpintrp(zr,qldamp,rminpro,nshell)
      endif
c
      zttot=1.e-3*fpintrp(zr,trions(1,i),rminpro,nshell)
      ztpar=1.e-3*fpintrp(zr,trionspa(1,i),rminpro,nshell)
      tiper(i)=(3*zttot-ztpar)/2.
      tipar(i)=ztpar
c
c  impose isotropy when lisot is .true.
c
      if(lisot) then
c
c use T_perp or T_parallel, depending on whether this a 2cd harmonic
c ion species:
c
      znharm=freqrf/(1.525e7*bmag*nZions(i)/nAions(i))
      if(znharm .gt. 1.5 .and. znharm .lt. 2.5) then
      tipar(i)=tiper(i)
      else
      tiper(i)=tipar(i)
      endif
      endif
c
      enddo
c
c fill in the "vacuum" density and temperature parameters:
      if (zr .gt. rmin) then
        dense=1.e6*vacden
        teper=1.e-3*vactemp
	tepar=teper
        do i=1,nions
        tiper(i)=1.e-3*vactemp
        tipar(i)=1.e-3*vactemp
        densi(i)=(vacden/drelec(nshell)) *densi(i)
	enddo
      endif
c
c
c
c   jphe - added 5/9/94  to debug
c
c      nnions=nions
c      adense(ichi,jpsi)=dense
c      atempe(ichi,jpsi)=tepar  ! (same as teper jphe 15-nov-94)
c      do 1000 iii=1,nions
c      adensi(ichi,jpsi,iii)=densi(iii)
c      atipar(ichi,jpsi,iii)=tipar(iii)
c      atiper(ichi,jpsi,iii)=tiper(iii)
c1000  continue
c end 5/9/94 debug
 
c
c  jphe -- 4-apr-1995   test outputs
c
c      if (ichi.eq.1.and.jpsi.eq.1) then
c       open (18,file='usr$usrroot:[transpdev.transp.txtr]total.dat',
c     &  status='NEW')
c       write (18,*) 'tepar,dense,bmag at ichi=1,jpsi=1'
c       write (18,'(1x,3e15.7)') tepar,dense,bmag
c       write (18,*) 'ionic species, tipar,tiper,densi'
c       write (18,'(4x,i4,3e15.7)')
c     &     (ij,tipar(ij),tiper(ij),densi(ij),ij=1,nions)
c      endif
      return
      end
