	subroutine plshel(f1rad,fnbsours)
c--Save various quantities calculated by MOMS on this shell versus time
c (such as density, temperature, power, fusion yield).  This subroutine
c also plots some of these quantities if desired.
 
C**********************************************************************
C                                                                     *
C	COMMON BLOCKS						      *
C                                                                     *
C**********************************************************************
 
	include 'FPPCOM'
	include 'F1COM'
 
	character string*80
 
c--plot surface averaged minority density and energy:
	write(string,105)nshe
105	format(' particle conservation on shell # ',i3)
	if(ntplot) call plots(timmy,avbden,loomax+1,'time (secs)',
	1	'aver. den. (per cc)',string)
	write(string,110)nshe
110	format(' Teff = (2/3) <E> on shell #',i3)
	if(ttplot) call plots(timmy,avbtemp,loomax+1,'time (secs)',
	1	'(2/3) Energy (KeV)',string)
!
! Plot the tail power balance
!
	if(.not. ptplot)goto 140
	call initt(240)
	call binitt
	call fpgrlab
	call npts(loomax+1)
	call dlimx(timmy(0),timmy(loomax))
!find y-axis limits for power plots:
	pmin=1.e20
	pmax=-1.e20
	call mnmx(realrf,pmin,pmax)
	call mnmx(pib,pmin,pmax)
	call mnmx(peb,pmin,pmax)
	call mnmx(POrbLoss,pmin,pmax)
	call mnmx(pcxb,pmin,pmax)
	call mnmx(pparts,pmin,pmax)
	call dlimy(pmin,pmax)
!plot the data:
	call steps(loomax/2)
	call symbl(ichar('R'))
	call check(timmy,realrf)
	call dsplay(timmy,realrf)
	call line(7474)
	call symbl(ichar('i'))
	call cplot(timmy,pib)
	call line(5454)
	call symbl(ichar('e'))
	call cplot(timmy,peb)
	call line(3434)
	call symbl(ichar('L'))
	call cplot(timmy,POrbLoss)
	call line(1414)
	call symbl(ichar('C'))
	call cplot(timmy,pcxb)
!	call line(4)
!	call cplot(timmy,pparts)
	write(string,130)nshe
130	format('Prfnb, Pib, Peb, Ploss, Pcx on shell #',i3,'$')
	call AGTcgt(0,string)
	call AGTchs('time (secs)$')
	call AGTcvs('Watts/cc$')
	call upause(0)
 
140	continue
 
c--local fusion Q has only been calculated by fusout if there is RF:
c	data plfusq /0.0/ ! .ne. 0 to plot local fusion Q(t)
c
c140	if(plfusq .eq. 0.0)go to 200
c145	if(nfutyp .le. 0 .or. prftot .le. 0.0)goto 200
c	write(string,150)nshe
c150	format(' local gain Q=Pfusion/Prf on shell #',i3)
c	call plots(timmy,fusq,loomax+1,'time (secs)',
c	1	' ',string)
c
c200	write(string,203)nshe
c203	format('D-He3 proton production from shell # ',i3)
c	if(LPlotPtn)call plots(timmy,PtnShell,loomax+1,
c	1	'time (secs)','per second',string)
 
c calculate beam source rates for particles, momentum, and energy:
c find beam power (W/cc) and particle source (#/cc/sec) radial profiles:
c (All of these in the Lab frame):
 
	rnsbeam(nshe)=0.0
	rmsbeam(nshe)=0.0
	rpsbeam(nshe)=0.0
 
	do 336 ixi=1,maxxsi
	do 336 ien=0,maxen
	rnsbeam(nshe)=rnsbeam(nshe)+fnbsours(ien,ixi,nshe)
	rmsbeam(nshe)=rmsbeam(nshe)+fnbsours(ien,ixi,nshe)*
	1   (rvparav(ixi)*sqrt(enerev(ien)*Ab)*2.3151e-18+
	1   romega(nshe)*Rmaj2av(ixi)*Ab*1.6726e-24)
336	rpsbeam(nshe)=rpsbeam(nshe)+fnbsours(ien,ixi,nshe)*
	1   (enerev(ien)*1.6022e-19 +
	1   romega(nshe)*rvparav(ixi)*sqrt(enerev(ien)*Ab)*2.3151e-18+
	1   0.5*romega(nshe)**2*Rmaj2av(ixi)*Ab*1.6726e-24)
	rnsbeam(nshe)=rnsbeam(nshe)/dVolfp(nshe)
	rmsbeam(nshe)=rmsbeam(nshe)/dVolfp(nshe)
	rpsbeam(nshe)=rpsbeam(nshe)/dVolfp(nshe)
 
! save power flows from last time step for a radial power balance
!	plot:
	rpbrf(nshe)=realrf(loomax)+rpsbeam(nshe)
	rpbi(nshe)=pib(loomax)
	rpbe(nshe)=peb(loomax)
	rpbl(nshe)=POrbLoss(loomax)
	rpbc(nshe)=pcxb(loomax)
	rpbs(nshe)=pparts(loomax)
	rpbdif(nshe)=Pdiff(loomax)
 
c include some prompt beam losses not caught by depo (or the Monte Carlo
c deposition package) because of slight differences in the way
c orbits are calculated:
 
	zbe=0.0
	do j=1,maxxsi
	   do i=0,maxen
	      zbe=zbe+enint(i)*qjaca(j)*fnbsour(i,j)*(1-loss(i,j))
	   enddo
	enddo
	rpbl(nshe)=rpbl(nshe)+zbe/dtreal*1.6022e-19
 
c (The above calculated only the power injected onto loss orbits.  Should
c also calculate the momentum and particles lost via this process...)
 
!save the initial and final density, current, and temperature:
	rbden0(nshe)=avbden(loomin)
	rbden1(nshe)=avbden(loomax)
	rbtemp0(nshe)=avbtemp(loomin)
	rbtemp1(nshe)=avbtemp(loomax)
	rbtpar0(nshe)=avbtpar(loomin)
	rbtpar1(nshe)=avbtpar(loomax)
 
c include factors to get proper area averaged current:
	rbj0(nshe)=xjbeam(loomin)*fpIdlB/fpIdlB0
	rbj1(nshe)=xjbeam(loomax)*fpIdlB/fpIdlB0
c include factors to get TRANSP's <J.B>:
	rbjb(nshe)=xjbeam(loomax)*fpIdlB/fpIdlB0B
c This would be the form to get <J.B> at the middle of the time step:
c	rbjb(nshe)=(xjbeam(loomin)+xjbeam(loomax))/2.0*fpIdlB/fpIdlB0B
 
c save initial and final toroidal momentum and moment of inertia.
c get full toroidal momentum in lab frame, not in the plasma frame:
	rbtmom0(nshe)=avbtmom(loomin)+romega(nshe)*avbtmi(loomin)
	rbtmom1(nshe)=avbtmom(loomax)+romega(nshe)*avbtmi(loomax)
	rbtmi0(nshe)=avbtmi(loomin)
	rbtmi1(nshe)=avbtmi(loomax)
 
c beam rotation frequency (in plasma frame):
	rbtomega(nshe)=avbtomeg(loomax)
 
c beam energy density in the lab frame (J/cm**3)
	zErot=romega(nshe)*rbtmom1(nshe)+romega(nshe)**2*
	1 rbtmi1(nshe)/2.0
	rbwlab(nshe)=1.6022e-19*1.5*1000.0*avbtemp(loomax)*
	1 avbden(loomax)+ 1.e-7*zErot
 
c Calculate Torque from beam to plasma from the momentum balance
c equation:
 
c rate of change of stored beam momentum:
	if(Timmy(loomax) .ne. Timmy(loomin))then
	zdptordt=(rbtmom1(nshe)-rbtmom0(nshe))
	1	/(timmy(loomax)-timmy(loomin))
	else
	zdptordt=0.0
	endif
 
c Torque from beam to CX losses (first the plasma frame and then
c the additional rotating frame contribution to get the final
c result in the lab frame):
	fptorqcx(nshe)=(avbtmocx(loomax)+avbtmocx(loomin))/2.0+
	1   romega(nshe)*(avbtmicx(loomin)+avbtmicx(loomax))/2.0
 
c Torque from beam to electrons via collisions:
	fptorqbe(nshe)=(avbtmom(loomin)+avbtmom(loomax))/
	1   2.0/tause(nshe)
 
c Left over torque goes to ions:
	fptorqbi(nshe)=rmsbeam(nshe)-zdptordt-fptorqbe(nshe)-
	1   fptorqcx(nshe)
 
c save the thermal ion source rate due to slowing down of the beams:
	rpsour(nshe)=Bmtht(loomax)
c and the power due to the residual beam energy as they fall of the
c last grid point:
	rBpth(nshe)=Pbtht(loomax)
 
c dW/dt = rate of change of stored energy:
	if(Timmy(loomax) .ne. Timmy(loomax-1))then
	rpbdw(nshe)=(avbden(loomax)*avbtemp(loomax)
	1	-avbden(loomax-1)*avbtemp(loomax-1))
	1	*3/2*1000.*1.6022e-19
	1	/(timmy(loomax)-timmy(loomax-1))
	else
	    rpbdw(nshe)=0.0
	endif
 
!save the initial RF+beam power (when f was different) for comparison:
	rpbrf0(nshe)=realrf(loomin)+rpsbeam(nshe)
 
c save final fusion reaction rate profile
	do 410 i=1,mxfureac
410	fpfuspro(nshe,i)=fuso(loomax,i)
 
c save the total volume-integrated fusion rate:
	do 420 i=1,mxfureac
	do 420 itime=0,loomax
420	fpfustot(itime,i)=fpfustot(itime,i)+fuso(itime,i)*dvolfp(nshe)
 
	return
	end
