c
c=======================================================================
c   .    1    .    2    .    3    .    4    .    5    .    6    .    7
c=======================================================================
c
      subroutine powers(w,akzt,ichi,jpsi,nperp2,nspec,
     %                                    pwrden,pwrspc,pwrmc,emtoep)
      include 'SPRINC'
      logical lMdCv
      data LMdCv/.false./
      complex hphi(nchi*npsi),echi(nchi*npsi),epsi(nchi*npsi),
     %        nperp2(nchi*npsi),pwrden,pwrmc,pwrspc(ionmax+1),eprpr,
     %        tprpwk,tcrswk,disp,emtoep,eplus,emins,divep(nchi*npsi),
     %        rotrot1,rotrot2,grphi1,grphi2,ezero,eper1,eper2,
     %        root(2),ephi(nchi*npsi),bchi(nchi*npsi),bpsi(nchi*npsi)
      common /spfldcom/ hphi,echi,epsi
      common /spfl2com/ ephi,bchi,bpsi,divep
c
      complex K0s(0:ionmax),K1s(0:ionmax),K2s(0:ionmax),K3s(0:ionmax),
     %        K4s(0:ionmax),K5s(0:ionmax)
      common/tensor_cmn/K0s,K1s,K2s,K3s,K4s,K5s
      complex K0,K1,K2,K3,K4,K5,K4n,K3n
c
c Copy of plasma_cmn common block read by the tensor subroutine:
c
      integer nions      ! number of ion species
      real npar          ! kpar/k0
      real omega         ! twopi* RF_frequency [s-1]
      real bmag          ! local magnetic field
      real dense         ! electron density [m-3]
      real teper         ! perpendicular electron temperature [keV]
      real tepar         ! parallell electron temperature [keV]
      real awi(ionmax)   ! ion atomic mass Ai
      real qi(ionmax)    ! ion charge      Zi
      real densi(ionmax) ! ion density [m-3]
      real tiper(ionmax) ! perpendicular ion temperature [keV]
      real tipar(ionmax) ! parallell ion temperature [keV]
c
      common /plasma_cmn/ npar,omega,bmag,dense,teper,tepar,awi,qi,
     %                    densi,tiper,tipar,nions
 
c
c 1986 Fundamental Constants (R.Cohen, B.Taylor,Physics Today,Aug.1991)
c
      real e,me,mp,mu0,eps0,c
      common /kphysic/e,me,mp,c,mu0,eps0
c
      real pi,piroot,twopi
      common/kmath/pi,piroot,twopi
c
c     POWERS finds the local power absorption on
c     each plasma species.
c
      ntot=nchi*npsi
      norigl=nchi
      nbodyf=nchi+1
c
      i=ichi+(jpsi-1)*nchi
c
      ako =w/c
      ako2=ako**2
      hnorm=(mu0/eps0)**2
c
c originally:
c     disp=cmplx(0.,-5.56325e-11*w)
c equivalently:
      disp=cmplx(0.,-twopi*eps0*w)
c
      npar=akzt/ako
      omega=w
c
      call plasma(ichi,jpsi)
      call tensor(nperp2(i),K0,K1,K2,K3,K4,K5)
 
c GWH: debug cutoff bugs:
c      if(i .eq. 2481) then
c         write(6,*) 'at i=2481, K1-npar**2, K2 ='
c         write(6,'(3(e20.10,1x,e20.10,/))') K1-npar**2,K2
c         K2=(0.0,1.0)*(K1-npar**2)
c      endif
 
c
c  calculate powers: estimate all the necessary field components
c
c NB: this is coded to ease comprehension, not for efficiency.
c     Thus Tcrs is still -I*(K2+... (like in coefts) and a further
c     I=(0.,1.) is introduced latter when using Tcrs.
c
      K4n=K4+npar
	  K3n=K3-nperp2(i)
      denom=1.-K0-(K5**2+K4n**2)/K3n
      tprpwk=(K1-npar**2-nperp2(i)*K4n**2/K3n)/denom
      tcrswk=(0.,-1.)*(K2-nperp2(i)*K4n*K5/K3n)/denom
      emtoep=(tprpwk+(0.,1.)*tcrswk)/(tprpwk-(0.,1.)*tcrswk)
c
c  calculate a few other field components, like RotxRotxEperp,
c  gradper(Ephi),Ephi,Bpsi,Bchi. Those components don't need
c  other derivatives than have already been calculated in
c  subroutine Fields, and are thus purely local.
c  NB. I don't calculate Hpsi and Hchi, because fortran doesn't
c      make the difference between upper and lower case, and
c      hpsi,hchi are already the metric coefficients. So Bpsi and
c      Bchi do include mu0, while Hphi doesn't!! I think this is
c      less confusing than denoting Bpsi for Hpsi, etc.
c
c  To calculate RotperpxRotperpxEperp ==> ako2*Keff*Eperp
c
c
      rotrot1= ako2*( tprpwk*epsi(i)+(0.,1.)*tcrswk*echi(i))
      rotrot2= ako2*((0.,-1.)*tcrswk*epsi(i)+tprpwk*echi(i))
c
c  Calculate now divperp(Ephi)
c
      grphi1=(0.,-1.)*(ako2*nperp2(i)*K4n*epsi(i)
     %                     -K4n*rotrot1+K5*rotrot2)/(ako*K3n)
      grphi2=(0.,-1.)*(ako2*nperp2(i)*K4n*echi(i)
     %                     -K5*rotrot1-K4n*rotrot2)/(ako*K3n)
c
c  ...and now for Ephi, Bchi,Bpsi.
c
      ephi(i)=((0.,1.)*K4n*divep(i)-K5*mu0*w*hphi(i))/(ako*K3n)
      bchi(i)= npar*epsi(i)/c+(0.,1.)*grphi1/w
      bpsi(i)=-npar*echi(i)/c-(0.,1.)*grphi2/w
c
c  Quantities quadratic in the various fields
c
      eplus=echi(i)*conjg(echi(i))+epsi(i)*conjg(epsi(i))
      emins=echi(i)*conjg(epsi(i))-epsi(i)*conjg(echi(i))
      ezero=rotrot1*conjg(epsi(i))+rotrot2*conjg(echi(i))
      eprpr=ephi(i)*conjg(ephi(i))
      eper1=(0.,-1.)*ako*(grphi2*conjg(echi(i))+grphi1*conjg(epsi(i)))
      eper2=(0.,-1.)*ako*(grphi2*conjg(epsi(i))-grphi1*conjg(echi(i)))
      eper1=eper1+(0.,-1.)*divep(i)*conjg(ephi(i))/ako
      eper2=eper2+w*mu0*hphi(i)*conjg(ephi(i))/ako
c
c  calculate the total absorbed power at this location (ichi,jpsi)
c
      pwrden=disp*(K0*ezero+K1*eplus+K2*emins
     %            +K3*eprpr+K4*eper1+K5*eper2)
c
c  Approximate model to take into account mode conversion.
c  when lMdCv is set to .true.. In a pure mode conversion regime,
c  in absence of cyclotron res., the imaginary parts of the two
c  interacting roots compensate each other( absorption on the one
c  branch is emission on the other). In more real cases, the
c  remaining imaginary part of nperp2(FW) is reputed to come
c  from cyclotron resonance and to contribute to absorption by
c  species.
c  NB. We don't allow the slow branch to emit on the fast one!
c
      if(lMdCv) then
      nroot=2
c
c  root(1)=FW ; root(2)=SW
c
      call N_Root(root,nroot)
      if(abs(real(root(1)-root(2))/real(root(1))).lt.0.02) then
         root(1)=root(1)+(0.,1.)*aimag(root(2))
         if(aimag(root(1)).lt.0.) root(1)=cmplx(real(root(1)),0.)
      endif
c
c  Even outside MdCv zone, we must recall tensor to correctly reset
c  the Ki(s) after the call of N_Root.
c
      call tensor(root(1),K0,K1,K2,K3,K4,K5)
      endif
c
c  distribution between species
c
      do 20 ion=1,nspec-1
      pwrspc(ion)=disp*(K0s(ion)*ezero+K1s(ion)*eplus+K2s(ion)*emins
     %                 +K3s(ion)*eprpr+K4s(ion)*eper1+K5s(ion)*eper2)
   20 continue
      pwrspc(nspec)=disp*(K0s(0)*ezero+K1s(0)*eplus+K2s(0)*emins
     %                   +K3s(0)*eprpr+K4s(0)*eper1+K5s(0)*eper2)
c
c  whatever remaining power is given to mode conversion and strictly
c  zero when lMdCv=.f. or outside MdCv zone.
c
      if(lMdCv) then
      pwrmc=pwrden
      do 21 ion=1,nspec
   21 pwrmc=pwrmc-pwrspc(ion)
      else
      pwrmc=0.
      endif
c
      return
      end
c
c
c
