c
c=======================================================================
c   .    1    .    2    .    3    .    4    .    5    .    6    .    7
c=======================================================================
c
      subroutine setup
      include 'SPRINC'
      real rmaj(nchi,npsi),zed(nchi,npsi),hpsi(nchi,npsi),
     %     hchi(nchi,npsi),psi(npsi),chi(nchi),pquad(npsi),pcoef(nchi),
     %     difpsi(npsi,npsi),difchi(nchi,nchi),zr(nchi+2,npsi),
     %     ddfpsi(npsi,npsi),ddfchi(nchi,nchi),zy(nchi+2,npsi),
     %     zf(nchi+2,npsi),origin(nchi)
      real zjac(2,2) ! jphe 23-3-95  for call to momry
      complex cwork1(nchi,npsi),cwork2(nchi,npsi),
     %        cwork3(nchi,npsi),cwork4(nchi,npsi)
      common /metric/ rmaj,zed,hpsi,hchi,psi,chi,pquad,pcoef
     %       /difmtx/ difpsi,difchi,ddfpsi,ddfchi
     %       /cwork / cwork1,cwork2,cwork3,cwork4
c
c     SETUP produces the collocation grid, the metric coefficients
c     for the orthogonal coordinate system, and the pseudospectral
c     derivative matrices, i.e., the contents of the /metric/ and
c     /difmtx/ blocks.
c
      pi=4.*atan(1.)
      npsim1=npsi-1
c
c=====================================================================
c
c start the (PSI,CHI) grid
c
c=====================================================================
c
c     Produce chi vector and derivative matrices
c
c
      dchis=2.*pi/float(nchi)
      do 15 i=1,nchi
      chi(i)=float(i-1)*dchis
   15 continue
      difchi(1,1)=0.
      ddfchi(1,1)=-float((nchi-1)*(nchi-2))/12.
      signk=-1.
      do 17 k=2,nchi
      signk=-signk
c careful: tan(pi/2)->infinity, so use cos and sin instead:
      difchi(1,k)=signk*.5*cos(.5*chi(k))/sin(.5*chi(k))
   17 ddfchi(1,k)=signk*(.5/sin(.5*chi(k))**2-.25*float(nchi))
      do 16 i=2,nchi
      do 16 k=1,nchi
      if (i.le.k) then
      idiff=k+1-i
      else
      idiff=k+1-i+nchi
      endif
      difchi(i,k)=difchi(1,idiff)
   16 ddfchi(i,k)=ddfchi(1,idiff)
c
c     Produce psi vector and derivative matrices
c
      dtp=pi/float(npsim1)
      signk=(-1.)**(1+npsi-2*(npsi/2))
      difpsi(1,1)=-(2.*float(npsim1)**2+1.)/3.
      difpsi(npsi,npsi)=(2.*float(npsim1)**2+1.)/3.
      difpsi(1,npsi)=-signk
      difpsi(npsi,1)=signk
      ddfpsi(1,1)=4.*(float(npsim1)**4-1.)/15.
      ddfpsi(npsi,npsi)=4.*(float(npsim1)**4-1.)/15.
      ddfpsi(1,npsi)=-4.*(float(npsim1)**2-1.)*difpsi(1,npsi)/3.
      ddfpsi(npsi,1)=4.*(float(npsim1)**2-1.)*difpsi(npsi,1)/3.
      psi(1)=0.
      psi(npsi)=1.
      signj=1.
      do 5 j=2,npsim1
      signj=-signj
      xj=cos(float(j-1)*dtp)
      difpsi(j,j)=xj/(1.-xj**2)
      difpsi(1,j)=-4.*signj/(1.-xj)
      difpsi(npsi,j)=4.*signj*signk/(1.+xj)
      difpsi(j,1)=-signj/(xj-1.)
      difpsi(j,npsi)=-signj*signk/(xj+1.)
      ddfpsi(j,j)=-4.*(float(npsim1)**2+2.)/(3.*(1.-xj**2))
     %            -4.*xj**2/(1.-xj**2)**2
      ddfpsi(1,j)=(4./(1.-xj)-(4.*float(npsim1)**2+2.)/3.)*
     %                                                 difpsi(1,j)
      ddfpsi(npsi,j)=(-4./(1.+xj)+(4.*float(npsim1)**2+2.)/3.)*
     %                                                 difpsi(npsi,j)
      ddfpsi(j,1)=-2.*((2.+xj)/(1.-xj**2))*difpsi(j,1)
      ddfpsi(j,npsi)=2.*((2.-xj)/(1.-xj**2))*difpsi(j,npsi)
    5 psi(j)=.5-.5*xj
      signj=-1.
      do 6 j=3,npsim1
      signj=-signj
      signk=1.
      do 6 k=2,j-1
      signk=-signk
      difpsi(j,k)=signj*signk/(psi(j)-psi(k))
      difpsi(k,j)=signj*signk/(psi(k)-psi(j))
      ddfpsi(j,k)=(2./(psi(k)-psi(j))-(psi(j)-.5)/(psi(j)*(1.-psi(j))))*
     %                                                       difpsi(j,k)
    6 ddfpsi(k,j)=(2./(psi(j)-psi(k))-(psi(k)-.5)/(psi(k)*(1.-psi(k))))*
     %                                                       difpsi(k,j)
c
c     Produce psi quadrature weights;
c     as Npsi -> infinity, Pquad(Psi) -> sqrt(Psi*(1.-Psi))
c
      do 7 i=1,npsi
    7 pquad(i)=0.
      istart=-2*((npsi-2)/2)
      istop=2*((npsi-1)/2)
      do 8 j=istart,istop,2
      t=float(j)*dtp
      xwork=1./(1.-float(j**2))/float(npsim1)
      do 8 i=1,npsi
    8 pquad(i)=pquad(i)+xwork*cos(t*float(i-1))
c
c======================================================================
c
c start the (RMAJ,ZED) grid
c
c======================================================================
c
c
c     Produce 2D grid from the MOMRY subroutine. This give an
c     interpolated fine grid similar to the VMEC grid. A call
c     to subroutine ORTHO postprocess the grid to produce the
c     orthogonal grid necessary for Spruce.
c
      ijac=0
      nchip2=nchi+2
      rdum=0.
      zdum=0.
      call momrz(psi(1),chi(1),ijac,zrdum,zydum,zjac,
     &    r00,z00,rdum,zdum)
      do 21 j=1,npsi
      do 20 i=1,nchi
      call momrz(psi(j),chi(i),ijac,zr(i,j),zy(i,j),zjac,
     &    rdum,zdum,r00,z00)
c
c change from cm(in TRANSP) to m(in SPRUCE) 25-jan-95  m.evrard-j.ongena  jphe
c
      zr(i,j)=zr(i,j)/100.
      zy(i,j)=zy(i,j)/100.
   20 continue
      zr(nchi+1,j)=zr(1,j)
      zy(nchi+1,j)=zy(1,j)
      zr(nchi+2,j)=zr(2,j)
      zy(nchi+2,j)=zy(2,j)
   21 continue
      r00=r00/100.
      z00=z00/100.
c  jphe 23-3-95 : test of new setup
c      open (17,file='usr$usrroot:[transpdev.transp.txtr]newsetup2.out')
c      write(17,*) ' zy(i,1) zy(i,2) zr(i,1) zr(i,2) - before ortho '
c      write(17,998)  (zy(i,1), zy(i,2), zr(i,1), zr(i,2),i=1,nchi)
      call ortho(zr,zy,zf,nchip2,npsi)
c      write(17,*) ' zy(i,1) zy(i,2) zr(i,1) zr(i,2) - after ortho '
c      write(17,998)  (zy(i,1), zy(i,2), zr(i,1), zr(i,2),i=1,nchi)
      do 22 i=1,nchi
      origin(i)=atan2((zy(i,2)-zy(i,1)),(zr(i,2)-zr(i,1)))
      do 22 j=1,npsi
      rmaj(i,j)=zr(i,j)
      zed(i,j)=zy(i,j)
22    continue
      do 23 i=1,nchi-1
      if (origin(i+1).lt.origin(i)) origin(i+1)=origin(i+1)+2.d0*pi
23    continue
c
c     Calculate hpsi,hchi and pcoef using the formulas:
c          hpsi**2=[drmaj/dpsi]**2+[dzed/dpsi]**2
c          hchi**2=[drmaj/dchi]**2+[dzed/dchi]**2
c          pcoef=lim(psi->0)[psi*hpsi/hchi]=1./[dorigin/dchi]
c
      do 30 i=1,nchi
      do 30 j=1,npsi
   30 cwork1(i,j)=cmplx(rmaj(i,j),zed(i,j))
      call dchi(cwork1,cwork2)
      call dpsi(cwork1,cwork3)
      do 40 i=1,nchi
      do 40 j=1,npsi
      rmaj(i,j)=rmaj(i,j)+r00
      zed(i,j)=zed(i,j)+z00
      hpsi(i,j)=abs(cwork3(i,j))
   40 hchi(i,j)=abs(cwork2(i,j))
      do 48 i=1,nchi
      pcoef(i)=1.
      do 47 j=1,nchi
   47 pcoef(i)=pcoef(i)+difchi(i,j)*(origin(j)-chi(j))
   48 pcoef(i)=1./pcoef(i)
c      write (17,*) '  i  origin(i)   pcoef(i)'
c      write (17,999) (i,origin(i),pcoef(i),i=1,nchi)
c 998  format (2x,4e17.7)
c 999  format (5x,i5,2e15.5)
c      close (17)
c
c     smooth
c
      do 50 i=1,nchi
      cwork3(i,1)=cmplx(hpsi(i,1),pcoef(i))
      do 50 j=2,npsi
   50 cwork3(i,j)=cmplx(hpsi(i,j),psi(j)*hpsi(i,j)/hchi(i,j))
      call SPRFIL(cwork3,0)
      do 51 i=1,nchi
      pcoef(i)=imag(cwork3(i,1))
      do 51 j=1,npsi
      hpsi(i,j)=real(cwork3(i,j))
   51 hchi(i,j)=psi(j)*hpsi(i,j)/imag(cwork3(i,j))
c
c
c     call sprout(-1)
      return
      end
