 
      subroutine solver(wall)
      include 'SPRINC'
      include 'cpar.com'
      include 'ccomus.com'
c
c This solver replace the MRSOLV subroutine. The possibility of
c iterative reduction of the residual is not available in this version.
c But it has the advantage of using a frontal method, thus reducing
c strongly the need for central memory or, conversely, allowing
c for much finer grid. The frontal solver solve complex block tridia-
c gonal systems and has been developed by Ph. Lamalle at LPP/ERM-KMS.
c
c Inserted into TRANSP by M.Evrard.  Aug. 12, 1994
c
      integer iblock(npsi)
      real rmaj(nchi,npsi),zed(nchi,npsi),pquad(npsi),pcoef(nchi),
     %     hpsi(nchi,npsi),hchi(nchi,npsi),psi(npsi),chi(nchi),
     %     difpsi(npsi,npsi),difchi(nchi,nchi),
     %     ddfpsi(npsi,npsi),ddfchi(nchi,nchi)
      complex acoef(nchi,npsi),bcoef(nchi,npsi),sol(nchi,4),
     %        ccoef(nchi,npsi),dcoef(nchi,npsi),rvec(nchi,npsi),
     %        hvec(nchi,npsi),wall(nchi),scale(nchi),
     %        ctemp,dpsifd,dpsicd,dpsibd
      common /metric/ rmaj,zed,hpsi,hchi,psi,chi,pquad,pcoef
     %       /difmtx/ difpsi,difchi,ddfpsi,ddfchi
     %       /coef/ acoef,bcoef,ccoef,dcoef,ako2
c
      iblock(1)=2
      do 1 i=2,npsi
    1 iblock(i)=nchi
c
c     Solution of finite-difference wave equation
c
      call fbtini(30,31,1,rdum,0,32,1,rdum,0,1)
      call proini(npsi,iblock,1,1,idum)
c
c
c     ... origin boundary condition ...
c
      ibl1=iblock(1)
      dpsifd=cmplx(1./(psi(2)-psi(1)),0.)
      isign=-1
      do 20 i=1,nchi
      isign=-isign
      ctemp=cmplx(1./pcoef(i),0.)
      ael(1,1)=ael(1,1)-ctemp*dpsifd
      ael(2,2)=ael(2,2)-ctemp*dpsifd
      ael(1,2)=ael(1,2)-isign*ctemp*dpsifd
      ael(2,1)=ael(2,1)-isign*ctemp*dpsifd
      ael(1,i+ibl1)=ctemp*dpsifd
      ael(2,i+ibl1)=isign*ctemp*dpsifd
   20 continue
      call fbstep(0,scale,scale)
c
c     ... wave operator ... 0<psi<1
c
      do 30 j=2,npsi-1
      ibl1=iblock(j-1)
      ibl2=iblock(j)
      dpsibd=cmplx(1./(psi(j)-psi(j-1)),0.)
      dpsicd=cmplx(2./(psi(j+1)-psi(j-1)),0.)
      dpsifd=cmplx(1./(psi(j+1)-psi(j)),0.)
      isign=-1
      do 31 i=1,nchi
      isign=-isign
c
c     zero order derivative
c
      ctemp=ako2*hpsi(i,j)*hchi(i,j)/rmaj(i,j)
      ael(i,i+ibl1)=ctemp
c
c     second order psi-derivative
c
      ctemp=acoef(i,j)*hchi(i,j)/(hpsi(i,j)*rmaj(i,j))
      ael(i,i+ibl1     )=ael(i,i+ibl1)-(2.,0.)*ctemp*dpsifd*dpsibd
      ael(i,i+ibl1+ibl2)=ctemp*dpsifd*dpsicd
      if(j.ne.2) then
      ael(i,i          )=ctemp*dpsibd*dpsicd
      else
      ael(i,1)=ctemp*dpsibd*dpsicd
      ael(i,2)=isign*ctemp*dpsibd*dpsicd
      endif
c
c     first order psi-derivative
c
      ctemp=ccoef(i,j)*cmplx(1./hpsi(i,j),0.)
      ael(i,i+ibl1     )=ael(i,i+ibl1     )+ctemp*(dpsibd-dpsifd)
      ael(i,i+ibl1+ibl2)=ael(i,i+ibl1+ibl2)+ctemp*(dpsifd-.5*dpsicd)
      if(j.ne.2) then
      ael(i,i          )=ael(i,i          )-ctemp*(dpsibd-.5*dpsicd)
      else
      ael(i,1)=ael(i,1)-ctemp*(dpsibd-.5*dpsicd)
      ael(i,2)=ael(i,2)-isign*ctemp*(dpsibd-.5*dpsicd)
      endif
c
      ksign=-1
      do 31 k=1,nchi
      ksign=-ksign
c
c    second order chi-derivative
c
      ctemp=acoef(i,j)*hpsi(i,j)/(hchi(i,j)*rmaj(i,j))
      ael(i,k+ibl1)=ael(i,k+ibl1)+ctemp*cmplx(ddfchi(i,k),0.)
c
c    first order chi-derivative
c
      ctemp=dcoef(i,j)*cmplx(1./hchi(i,j),0.)
      ael(i,k+ibl1)=ael(i,k+ibl1)+ctemp*cmplx(difchi(i,k),0.)
c
   31 continue
      call fbstep(0,scale,scale)
   30 continue
c
c     ... wall boundary condition ...
c
      do 40 i=1,nchi
      bel(i,1)=wall(i)
      dpsibd=cmplx(1./(psi(npsi)-psi(npsi-1)),0.)
c
c
      ctemp=-acoef(i,npsi)*hchi(i,npsi)/(hpsi(i,npsi)*rmaj(i,npsi))
      ael(i,i+ibl1)=ctemp*dpsibd
      ael(i,i)=-ctemp*dpsibd
c
c  jphe - me adapt sign of bcoef to TRANSPs conventions (ie. ctemp=-bcoef...)
c
      do 40 k=1,nchi
      ctemp=-bcoef(i,npsi)/rmaj(i,npsi)
      ael(i,k+ibl1)=ael(i,k+ibl1)+ctemp*cmplx(difchi(i,k),0.)
   40 continue
      call fbstep(0,scale,scale)
c
c   read the solution into hvec
c
      j=1
      call rdsol(1,j,sol,nchi,idum1,idum2)
      isign=-1
      do 51 i=1,nchi
      isign=-isign
   51 hvec(i,j)=sol(1,1)+isign*sol(2,1)
      do 50 j=2,npsi
      call rdsol(1,j,sol,nchi,idum1,idum2)
      do 50 i=1,nchi
      hvec(i,j)=sol(i,1)
   50 continue
      call fbtclo('all')
c
c     Calculate the residue... is not necessary since we don't use it!
c
c     call waveop(hvec,rvec)
c     do 60 i=1,nchi
c     rvec(i,1)=(0.,0.)
c  60 rvec(i,npsi)=rvec(i,npsi)-wall(i)
c
c     Calculate fields from solution vector
c
      call fields(hvec)
c
c
      return
      end
