      subroutine SPRFIL(hvec,mode)
      include 'SPRINC'
      complex hvec(nchi,npsi),psisav(npsi),chisav(nchi)
c
c     SPRFIL smooths the vector "hvec" using a formula which produces an
c     Sn<-Sn*(cos(.5*n*pi/N))**2 spectral SPRFIL for either or both the
c     Fourier chi representation and the Tchebyshev psi representation.
c
c GWH 30-Aug-1989: renamed from FILTER to SPRFIL.
c
      if (mode.eq.0.or.mode.eq.1) then
c     chi-smooth
      do 10 j=1,npsi
      do 11 i=1,nchi
   11 chisav(i)=hvec(i,j)
      do 10 i=1,nchi
      im1=i-1+nchi*((nchi+1-i)/nchi)
      ip1=i+1-nchi*(i/nchi)
   10 hvec(i,j)=(.5,0.)*chisav(i)+(.25,0.)*(chisav(im1)+chisav(ip1))
      endif
c
      if (mode.eq.0.or.mode.eq.2) then
c     psi-smooth
      do 20 i=1,nchi
      do 21 j=1,npsi
   21 psisav(j)=hvec(i,j)
      do 20 j=1,npsi
      jm1=j-1+2*((npsi+1-j)/npsi)
      jp1=j+1-2*(j/npsi)
   20 hvec(i,j)=(.5,0.)*psisav(j)+(.25,0.)*(psisav(jm1)+psisav(jp1))
      endif
c
      return
      end
