      subroutine sprout(kode)
c
c     OUTPUT is the consolidated graphical and text output routine.
c     The variable "kode" identifies the particular ouput task which
c     is to be done.
c
c kode>0   Nperp**2 contour plots
c kode=-1  plot of grid, metric coefficients
c kode=-8  plot of all fields
c kode=-7  standard summary plots
c kode=-5  appr.of plots of eplus and cabs(crfpol)  *jphe 4-nov-1993*
c
      include 'SPRINC'
      integer maxbin
      integer maxkz
      integer maxcont
      parameter (maxbin=31,maxkz=50,maxcont=20)
      logical lfields,lratio,lnprp2,lparams,lncoef
      character*72 string
      character*4 name(ionmax+1)
      character *3  kchar    ! jphe 5-sep-1994
      character *11 ktext    ! jphe 5-sep-1994
      real rmaj(nchi,npsi),zed(nchi,npsi),hpsi(nchi,npsi),
     %     hchi(nchi,npsi),psi(npsi),chi(nchi),pquad(npsi),pcoef(nchi),
     %     awio(ionmax),qio(ionmax),densio(ionmax),tempio(ionmax),
     %     expfti(ionmax),explti(ionmax),parfti(ionmax),parlti(ionmax),
     %     pareti(ionmax),akzgrd(maxkz),pofkz(maxkz),apion(ionmax),
     %     akreal(2*npsi-1),akimag(2*npsi-1),akRmaj(2*npsi-1),
     %     ratiom(nchi+1,npsi),chiopi(nchi+1),
     %     raymaj(nchi+npsi),rayzed(nchi+npsi),
     %     ap(nchi,npsi),aprsp(maxbin,ionmax+2),rbin(maxbin),
     %     apofr(maxbin),hzplt(nchi,npsi),plot2d(nchi+1,npsi),
     %     cont(maxcont),transm,dRkmax
      complex acoef(nchi,npsi),bcoef(nchi,npsi),
     %        ccoef(nchi,npsi),dcoef(nchi,npsi),
     %        hphi(nchi,npsi),echi(nchi,npsi),epsi(nchi,npsi),
     %        pwrden,pwrspc(ionmax+1),pwrmc,pwre,pwrh,
     %        cnprp2,emtoep,nperp2(nchi,npsi),
     %        apofkz(maxkz),aiofkz(maxkz)
      common /metric/ rmaj,zed,hpsi,hchi,psi,chi,pquad,pcoef
     %       /spfldcom/ hphi,echi,epsi
     %       /coef/ acoef,bcoef,ccoef,dcoef,ako2
     %       /sproutcm/ ap,aprsp,apion,apelc,apmc,power,resist,drbin,
     %                hzplt,akreal,akimag,akRmaj,nbin,transm,dRkmax
     %       /spctrm/ apofkz,aiofkz,akzgrd,nkz
     %       /plasmacm/ bmago,rmajo,name,denseo,tempeo,
     %                nionso,awio,qio,densio,tempio,
     %                expfde,explde,parfde,parlde,parede,
     %                expfte,explte,parfte,parlte,parete,
     %                expfti,explti,parfti,parlti,pareti
c
c   jphe - added 5/9/94  to debug
c
c (GWH comment this out to save 2 Megabytes for very large grids):
c      common /cntrplt/ adense(nchi,npsi),atempe(nchi,npsi),
c     %                 adensi(nchi,npsi,ionmax+1),
c     %                 atiper(nchi,npsi,ionmax+1),
c     %                 atipar(nchi,npsi,ionmax+1),nnions
 
      common /disper_cmn/ nperp2        ! jphe 3-feb-1995
      real zemag(nchi+1,npsi)
      complex zepol(nchi+1,npsi)
      common /plotbr/ Zemag,zepol   ! jphe 3-nov-1994
      real zxhelp(nchi,2),zyhelp(nchi,2)
c
c     if (lfields) then plot all fields, else plot only Real{Hphi}
      data lfields /.true./
c     if (lratio) then contour plot the metric coeficient ratio
      data lratio /.true./
c     if (lnprp2) then contour plot Nperp**2
      data lnprp2 /.true./
c     if (lparams) then contour plot of different plasma parameters
      data lparams /.false./
c     if (lncoef) then contour plot of acoef, bcoef
      data lncoef /.false./
c
c
      nchip1=nchi+1
      ncatpi=nchi/2+1
      nakplt=2*npsi-1
      pi=abs(acos(-1.0))
c
      rmjmin=1.e38
      rmjmax=-1.e38
      zedmin=1.e38
      zedmax=-1.e38
      do 2 i=1,nchi
      if (rmaj(i,npsi).gt.rmjmax) rmjmax=rmaj(i,npsi)
      if (rmaj(i,npsi).lt.rmjmin) rmjmin=rmaj(i,npsi)
      if (zed(i,npsi).gt.zedmax) zedmax=zed(i,npsi)
      if (zed(i,npsi).lt.zedmin) zedmin=zed(i,npsi)
    2 continue
 
	ileft=150
	iright=725
	idown=125
	iup=700
 
c
c     Kz iteration output (kode=ikz)
      if (kode.gt.0) then
c
      if (lnprp2) then
c     *** Contur Plots of Nperp**2 ***
c  3-feb-1995  M.evrard and J.ongena : transfer actual nperp2 for plotting
c  instead of using 1/acoef
c  jphe
      do 13 j=1,npsi
      do 12 i=1,nchi
   12 plot2d(i,j)=real(nperp2(i,j))
   13 plot2d(nchip1,j)=plot2d(1,j)
      call conturs(plot2d,'Real(Nperp**2)$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
      do 15 j=1,npsi
      do 14 i=1,nchi
   14 plot2d(i,j)=aimag(nperp2(i,j))
   15 plot2d(nchip1,j)=plot2d(1,j)
      call conturs(plot2d,'Imag(Nperp**2)$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
      endif
c
      if (lncoef) then
c     *** Contur Plots of Acoef and Bcoef  ***
c  3-feb-1995  M.evrard and J.ongena : Plot of acoef and bcoef to debug
c  1. plot of acoef    --- jphe
      do  j=1,npsi
      do  i=1,nchi
      plot2d(i,j)=real(acoef(i,j))
      enddo
      plot2d(nchip1,j)=plot2d(1,j)
      enddo
      call conturs(plot2d,'Real(Acoef)$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
      do  j=1,npsi
      do  i=1,nchi
      plot2d(i,j)=aimag(acoef(i,j))
      enddo
      plot2d(nchip1,j)=plot2d(1,j)
      enddo
      call conturs(plot2d,'Imag(Acoef)$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
c
c 2. Plot of bcoef  --- jphe 3-feb-1995
c
      do  j=1,npsi
      do  i=1,nchi
      plot2d(i,j)=real(bcoef(i,j))
      enddo
      plot2d(nchip1,j)=plot2d(1,j)
      enddo
      call conturs(plot2d,'Real(Bcoef)$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
      do  j=1,npsi
      do  i=1,nchi
      plot2d(i,j)=aimag(bcoef(i,j))
      enddo
      plot2d(nchip1,j)=plot2d(1,j)
      enddo
      call conturs(plot2d,'Imag(Bcoef)$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
      endif
c
c     Setup output
      elseif (kode.eq.-1) then
c     *** Grid ***
      call initt(960)
      call binitt
	call fpgrlab
      call xneat(0)
      call yneat(0)
      call slimx(150,725)
      call slimy(125,700)
      zRav=(rmjmax+rmjmin)/2
      zrhw=(rmjmax-rmjmin)/2
      zrhh=(zedmax-zedmin)/2
      zsiz=1.1*max(zrhw,zrhh)
      call dlimx(zRav-zsiz,zRav+zsiz)
      call dlimy(-zsiz,zsiz)
      call xfrm(2)
      call yfrm(2)
 
      call line(0)
      call npts(nchi+1)
      do 20 j=1,npsi
      do 21 i=1,nchi
      raymaj(i)=rmaj(i,j)
   21 rayzed(i)=zed(i,j)
      raymaj(nchip1)=raymaj(1)
      rayzed(nchip1)=rayzed(1)
	if(j .eq. 1)then
	call check(raymaj,rayzed)
	call dsplay(raymaj,rayzed)
	else
      call cplot(raymaj,rayzed)
	endif
 
   20 continue
 
      call frame !@
c@    call dframe
      call agtchs('Rmajor (m)')
      call agtcvs('Y (m)')
 
      call npts(npsi)
      do 22 i=1,nchi
      do 23 j=1,npsi
      raymaj(j)=rmaj(i,j)
   23 rayzed(j)=zed(i,j)
      call cplot(raymaj,rayzed)
   22 continue
	call upause(0)
	call finitt(0,0)
c
c     *** Metric coefficient ratio, psi*hpsi/hchi ***
      if(lratio) then
      do 30 i=1,nchi
   30 ratiom(i,1)=pcoef(i)
      ratiom(nchip1,1)=ratiom(1,1)
      do 31 j=2,npsi
      do 32 i=1,nchi
   32 ratiom(i,j)=psi(j)*hpsi(i,j)/hchi(i,j)
   31 ratiom(nchip1,j)=ratiom(1,j)
      do 33 i=1,nchip1
   33 chiopi(i)=2.*float(i-1)/float(nchi)
      ratmin=1.e38
      ratmax=-1.e38
      call npts(npsi*nchip1)
      call mnmx(ratiom,ratmin,ratmax)
      if ( (ratmax-ratmin) .gt. .25) then
      call initt(960)
      call binitt
	call fpgrlab
      ncont=ifix(4.*ratmax)-ifix(4.*ratmin)
      ncont=min(ncont,maxcont)
      k1=-ncont
      k2=0
      cont(1)=.25*(float(ifix(4.*ratmin))+1.)
      cont(2)=.25*float(ifix(4.*ratmax))
      call agraph(105,975,195,630,0.,2.,0.,1.,'Chi/pi$','Psi$')
      call rcontr(k1,cont,k2,ratiom,nchip1,chiopi,1,nchip1,1,
     %                                                 psi,1,npsi,1)
      call agtcgt(700,'Metric Ratio:  psi*hpsi/hchi$',0)
      write (string,635) ratmin,ratmax
C
C ADAPT FORMAT FOR POSSIBLE NEGATIVE VALUES DURING DEBUG
C             JPHE - 11-APR-1995
  635 format('min=',1pe9.2,', max=',1pe9.2,'$')
      call agtcgt(670,string,0)
      call upause(0)
      call finitt(0,0)
      endif
      endif
c
      elseif (kode.eq.-8) then
c     *** Contour plots of Hphi ***
      do 61 j=1,npsi
      do 60 i=1,nchi
   60 plot2d(i,j)=real(hphi(i,j))
   61 plot2d(nchip1,j)=plot2d(1,j)
      call conturs(plot2d,'Real(Hphi)$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
      if (lfields) then
      do 66 j=1,npsi
      do 65 i=1,nchi
   65 plot2d(i,j)=aimag(hphi(i,j))
   66 plot2d(nchip1,j)=plot2d(1,j)
      call conturs(plot2d,'Imag(Hphi)$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
c
c     *** Contour plots of Echi ***
      do 70 j=1,npsi
      do 71 i=1,nchi
   71 plot2d(i,j)=real(echi(i,j))
   70 plot2d(nchip1,j)=plot2d(1,j)
      call conturs(plot2d,'Real(Echi)$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
      do 76 j=1,npsi
      do 75 i=1,nchi
   75 plot2d(i,j)=aimag(echi(i,j))
   76 plot2d(nchip1,j)=plot2d(1,j)
      call conturs(plot2d,'Imag(Echi)$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
c
c  plot of Re and Im of Echi at wall   jphe  31-mar-1995
c
      do 776 i=1,nchi
      zxhelp(i,1)=(i-1)*6.283185/(nchi-1)
      zxhelp(i,2)=zxhelp(i,1)
      zyhelp(i,1)=real(echi(i,npsi))
  776 zyhelp(i,2)=aimag(echi(i,npsi))
      call initt(0)
      call binitt
      call erase
      call fpgrlab
      call slimx(150,725)
      call slimy(125,700)
      zymin=zyhelp(1,1)
      zymax=zyhelp(1,1)
      do 778 i=1,nchi
      if (zyhelp(i,1).gt.zymax) zymax=zyhelp(i,1)
      if (zyhelp(i,2).gt.zymax) zymax=zyhelp(i,2)
      if (zyhelp(i,1).lt.zymin) zymin=zyhelp(i,1)
      if (zyhelp(i,2).lt.zymin) zymin=zyhelp(i,2)
      if (zxhelp(i,1).gt.zxmax) zxmax=zxhelp(i,1)
      if (zxhelp(i,2).gt.zxmax) zxmax=zxhelp(i,2)
      if (zxhelp(i,1).lt.zxmin) zxmin=zxhelp(i,1)
      if (zxhelp(i,2).lt.zxmin) zxmin=zxhelp(i,2)
 778  continue
      call dlimx(0,6.40)
      call dlimy(zymin,zymax)
      call steps(nchi/10)
      call npts(nchi)
      call check(zxhelp,zyhelp)
      call agdspl(zxhelp,zyhelp)
      call line(0)
      call symbl(ichar('R'))
      call agccurv(1)
      call cplot(zxhelp(1,1),zyhelp(1,1))
      call line(0)
      call symbl(ichar('I'))
      call agccurv(2)
      call cplot(zxhelp(1,2),zyhelp(1,2))
      call agtchs('chi(radians)')
      call agtcvs('Echi(psi=1)')
      call agtcgt(0,'Re and Im of Echi at wall')
      call upause(0)
      call finitt(0,0)
c
c     *** Contour plots of Epsi ***
      do 81 j=1,npsi
      do 80 i=1,nchi
   80 plot2d(i,j)=real(epsi(i,j))
   81 plot2d(nchip1,j)=plot2d(1,j)
      call conturs(plot2d,'Real(Epsi)$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
      do 86 j=1,npsi
      do 85 i=1,nchi
   85 plot2d(i,j)=aimag(epsi(i,j))
   86 plot2d(nchip1,j)=plot2d(1,j)
      call conturs(plot2d,'Imag(Epsi)$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
      endif
 
      if (lparams) then
c
c  jphe 5-sep-1994  plots of different plasma parameters
c
c      do 191 j=1,npsi
c      do 190 i=1,nchi
c  190 plot2d(i,j)=adense(i,j)
c  191 plot2d(nchip1,j)=plot2d(1,j)
c      call conturs(plot2d,'Dense$',
c     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
c      do 196 j=1,npsi
c      do 195 i=1,nchi
c  195 plot2d(i,j)=atempe(i,j)
c  196 plot2d(nchip1,j)=plot2d(1,j)
c      call conturs(plot2d,'Tempe$',
c     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
c      do 2000 k=1,nnions
c      do 201 j=1,npsi
c      do 200 i=1,nchi
c  200 plot2d(i,j)=adensi(i,j,k)
c  201 plot2d(nchip1,j)=plot2d(1,j)
c      write(kchar,'(I3)') k
c      ktext='Densi('//kchar//')$'
c      call conturs(plot2d,ktext,
c     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
c      do 203 j=1,npsi
c      do 202 i=1,nchi
c  202 plot2d(i,j)=atipar(i,j,k)
c  203 plot2d(nchip1,j)=plot2d(1,j)
c      write(kchar,'(I3)') k
c      ktext='Tipar('//kchar//')$'
c      call conturs(plot2d,ktext,
c     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
c      do 205 j=1,npsi
c      do 204 i=1,nchi
c  204 plot2d(i,j)=atiper(i,j,k)
c  205 plot2d(nchip1,j)=plot2d(1,j)
c      write(kchar,'(I3)') k
c      ktext='Tiper('//kchar//')$'
c      call conturs(plot2d,ktext,
c     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
c2000  continue
      endif
 
cccc
c
c   jphe 3-nov-1994  add plots of eplus and crfpol
c
cccc
      elseif (kode.eq.-5) then
c****     plot of eplus and cabs(crfpol)  ****
      do 180 j=1,npsi
      do 180 i=1,nchi+1
  180 plot2d(i,j)=Zemag(i,j)
      call conturs(plot2d,'E+$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
      do 185 j=1,npsi
      do 185 i=1,nchi+1
  185 plot2d(i,j)=cabs(Zepol(i,j))
      call conturs(plot2d,'abs(E+/E-)$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
c
      elseif (kode.eq.-7) then
c     *** Midplane Dispersion relation ***
 
      call initt(960)
      call binitt
	call fpgrlab
      call npts(nakplt)
      akmin=1.e38
      akmax=-1.e38
      call mnmx(akreal,akmin,akmax)
      call mnmx(akimag,akmin,akmax)
      call dlimy(akmin,akmax)
      call check(akRmaj,akreal)
      call line(0)
      call dsplay(akRmaj,akreal)
      call line(3)
      call cplot(akRmaj,akimag)
      call agtchs('Rmajor$',0)
      call agtcvs('Nperp**2$',0)
      call agtcgt(760,
     %	      'Midplane Dispersion Relation:   Nperp**2 vs. R$',0)
      write(string,'(a,1pe8.2,a)')  '( kperp = Nperp * ',
     %	      sqrt(ako2),' /m )$'
      call agtcgt(735,string)
      write(string,'(a,1pe8.2)')
     %	      'non-evanescent Midplane transmission factor =',transm
      call agtcgt(710,string)
 
	call upause(0)
	call finitt(0,0)
 
c DEBUG GWH:
c        write(6,*) ' R, Real and Imag part of kperp**2(R):'
c        do i=1,nakplt
c           write(6,*), akRmaj(i),akreal(i),akimag(i)
c        enddo
c
c     *** Contour plot of hzplt
      do 96 j=1,npsi
      do 95 i=1,nchi
   95 plot2d(i,j)=hzplt(i,j)
   96 plot2d(nchip1,j)=plot2d(1,j)
      call conturs(plot2d,'Real(Hphi)$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
c
c     *** Contour plot of Abs(H_z)**2
c (For an ideal Alfven wave, this is proportional to the Wave Energy
c density).
c
      do j=1,npsi
         do i=1,nchi
            plot2d(i,j)=cabs(hphi(i,j))**2
         enddo
            plot2d(nchip1,j)=plot2d(1,j)
      enddo
      call conturs(plot2d,'Abs(H_phi)**2$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
 
c
c     *** Contour plot of Real(PwrDen) ***
      do 98 j=1,npsi
      do 97 i=1,nchi
   97 plot2d(i,j)=ap(i,j)
   98 plot2d(nchip1,j)=plot2d(1,j)
      call conturs(plot2d,'Real(PwrDen)$',
     %     ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
c
c     *** Graphs of power to radial bins ***
      nspec=nionso+1
      nmc=nspec+1
      do 100 i=1,nbin
      rbin(i)=(i-0.5)*drbin
      apofr(i)=0.
      do 100 j=1,nmc
  100 apofr(i)=apofr(i)+aprsp(i,j)
      apmin=0.
      apmax=0.
      call initt(960)
      call binitt
	call fpgrlab
      call npts(nbin*nmc)
      call mnmx(aprsp,apmin,apmax)
      call npts(nbin)
      call mnmx(apofr,apmin,apmax)
      call dlimy(apmin,apmax)
      call check(rbin,apofr)
      call line(1)
      call dsplay(rbin,apofr)
      call line(0)
      do 110 isp=1,nmc
      do 105 i=1,nbin
  105 apofr(i)=aprsp(i,isp)
      call symbl(isp)
      call cplot(rbin,apofr)
      call movabs(658,705-20*isp)
      call symout(isp,1.)
      if (isp.le.nionso) then
      write (string,710) name(isp),apion(isp)
  710 format('= ',a4,' =',1pe9.2,'$')
      elseif (isp.eq.nspec) then
      write (string,710) name(isp),apelc
      elseif (isp.eq.nmc) then
      write (string,711) apmc
  711 format('= MdCv =',1pe9.2,'$')
      endif
      call agtmhs(680,699-20*isp,string,0)
  110 continue
      write (string,712) power
  712 format('Total =',1pe9.2,'$')
      call agtmhs(694,679-20*nmc,string,0)
      call agtchs('Rminor$',0)
c      call agtcvs('Ohms/m3$',0)
      call agtcvs('W/cm^3$',0)
      call agtcgt(725,'Wave Damping vs Flux Surface$',0)
	call upause(0)
	call finitt(0,0)
c
      if (nkz.gt.1) then
c     *** Graph of Spectral Loading ***
      do 120 i=1,nkz
  120 pofkz(i)=real(apofkz(i))
      call initt(960)
      call binitt
	call fpgrlab
      call npts(nkz)
      call mnmx(pofkz,pmin,pmax)
      if (pmin.gt.0.) pmin=0.
      call dlimx(0.,akzgrd(nkz))
      call dlimy(pmin,pmax)
      call check(akzgrd,pofkz)
      call dsplay(akzgrd,pofkz)
      call agtchs('Kz [1/m]$',0)
      call agtcvs('Ohms*m$',0)
      call agtcgt(745,'Toroidal Loading Spectrum$',0)
      write (string,720) resist
  720 format('Total =',1pe9.2,' Ohms$')
      call agtcgt(715,string,0)
	call upause(0)
	call finitt(0,0)
      endif
c
      endif
      return
      end
