	subroutine symrf
c
c	SYMRF symmetrizes the quasilinear coefficients in the
c	trapped region of velocity space, and renormalizes the
c	quasilinear operator to give the proper amount of power.
C
C     COMMON BLOCKS
C
	include 'FPPCOM'
C
 
	do 100 i=0,maxen
	do 100 j=maxxsi/2+1,maxxsi/2+njTrap
 
	deb(i,j)=.5*(deb(i,j)+deb(i,maxxsi+1-j))
	deb(i,maxxsi+1-j)=deb(i,j)
 
!note that dec and dac are anti-symmetric!!!!:
	dec(i,j)=.5*(dec(i,j)-dec(i,maxxsi+1-j))
	dec(i,maxxsi+1-j)=-dec(i,j)
 
	if(j .lt. maxxsi/2+njTrap)then
	dac(i,j)=.5*(dac(i,j)-dac(i,maxxsi-j))
	dac(i,maxxsi-j)=-dac(i,j)
 
	dab(i,j)=.5*(dab(i,j)+dab(i,maxxsi-j))
	dab(i,maxxsi-j)=dab(i,j)
	endif
100	continue
 
c*********************************************************************
c								     *
c       Calculate the RF power absorbed by the minority species.     *
c       This assumes that DEB and DEC contain only the RF	     *
c       contributions to the fokker-planck diffusion coefficients.   *
c	 See my notes "RF Heating Rate" from Nov. 28, 1983.	     *
c
c (this section is copied out of the MOMS subroutine.		     *
c								     *
c*********************************************************************
	sum=0.0
	call fpcross
 
	do 250 j=1,maxxsi
	do 230 i=2,maxen
230	sum=sum+f1(i,j)*( delxsi(j)*(deb(i,j)-deb(i-1,j)) )
	1 +enint(i)/qjace(i)/2*(fpfluxe(i-1,j)-fpfluxe(i,j))
 
	sum=sum+delxsi(j)*( deb(1,j)*f1(1,j)
	1       -deb(0,j)*(f1(1,j)-f1(0,j))*(enerev(1)-aven0)
	1			       /(enerev(1)-enerev(0)) )
	1   +enint(1)/qjace(1)/2*(fpfluxe(0,j)-fpfluxe(1,j))
	1   +enint(0)/qjace(0)/2*(fpfluxe(-1,j)-fpfluxe(0,j))
 
250	continue
 
c--actual rf power absorbed (Watts per cm**3)
	zprfmin=dVolnorm*25*sum*1.6022e-19
 
	if(zprfmin .gt. 1.e-2*abs(Pichspec(nshe,nfasti))) then
	    zcorr=Pichspec(nshe,nfasti)/zprfmin
	else
	    zcorr=1.e+2
	endif
	if(Pichspec(nshe,nfasti) .le. 0.0) zcorr=1.e-4
	zcorr=max(1.e-4,zcorr)
	if(Pichspec(nshe,nfasti) .eq. 0.0 .and. zprfmin .eq. 0.0)
	1   zcorr=1.0
	
c don't renormalize if lrfmod=3 and we have specified the exact
c Eplus (useful for benchmarking):
	if(LSHOOT .eq. 0 .and. LRFmod .eq. 3) zcorr=1.0
 
	rkpcpro(nshe)=1./zcorr
 
c renormalize the quasilinear Fokker-Planck coefficients
c to give the same RF power as calculated by the Wave propagation
c code, at least for this initial f:
 
	do 300 i=0,maxen
	do 300 j=1,maxxsi
 
	deb(i,j)=deb(i,j)*zcorr
	dec(i,j)=dec(i,j)*zcorr
	dab(i,j)=dab(i,j)*zcorr
	dac(i,j)=dac(i,j)*zcorr
 
300	continue
 
	return
	end
