      subroutine wavead(hvec,result)
      include 'SPRINC'
      real rmaj(nchi*npsi),zed(nchi*npsi),hpsi(nchi*npsi),
     %     hchi(nchi*npsi),psi(npsi),chi(nchi),pquad(npsi),pcoef(nchi)
      complex hvec(nchi*npsi),result(nchi*npsi),
     %        acoef(nchi*npsi),bcoef(nchi*npsi),
     %        ccoef(nchi*npsi),dcoef(nchi*npsi),
     %        cwork1(nchi*npsi),cwork2(nchi*npsi),
     %        cwork3(nchi*npsi),cwork4(nchi*npsi)
      common /metric/ rmaj,zed,hpsi,hchi,psi,chi,pquad,pcoef
     %       /cwork/ cwork1,cwork2,cwork3,cwork4
     %       /coef/ acoef,bcoef,ccoef,dcoef,ako2
c
c     WAVEAD calculates the adjoint wave operator acting on "hvec",
c     including the adjoint boundary operators.  WAVEOP and WAVEAD
c     satisfy:
c
c     conjg(hvec) <dot> WAVEAD{WAVEOP{hvec}}  =  |WAVEOP{hvec}|**2
c
c     where the dot-product includes the origin point only once.
c
      ntot=npsi*nchi
      norigl=nchi
      nbodyf=nchi+1
      nbodyl=ntot-nchi
      nwallf=ntot-nchi+1
      pi=4.*atan(1.)
      delchi=2.*pi/float(nchi)
c
      do 10 i=1,norigl
      result(i)=(0.,0.)
      cwork3(i)=(0.,0.)
   10 cwork4(i)=(0.,0.)
      do 15 i=nbodyf,nbodyl
      result(i)=cmplx(ako2*hpsi(i)*hchi(i)/rmaj(i),0.)*hvec(i)
      cwork3(i)=conjg(acoef(i))*
     %                    cmplx(hchi(i)/(hpsi(i)*rmaj(i)),0.)*hvec(i)
   15 cwork4(i)=conjg(acoef(i))*
     %                    cmplx(hpsi(i)/(hchi(i)*rmaj(i)),0.)*hvec(i)
      do 19 i=nwallf,ntot
      result(i)=(0.,0.)
      cwork3(i)=(0.,0.)
   19 cwork4(i)=(0.,0.)
c
      call filtre(cwork3,2)
      call dpsitr(cwork3,cwork1)
      call dchitr(cwork4,cwork2)
c
      do 20 i=1,norigl
   20 cwork1(i)=cwork1(i)+conjg(acoef(i))*
     %          cmplx(delchi/(2.*pi*rmaj(i)*pcoef(i)),0.)*hvec(norigl)
      do 25 i=nbodyf,nbodyl
      cwork1(i)=cwork1(i)+conjg(ccoef(i))*cmplx(1./hpsi(i),0.)*hvec(i)
   25 cwork2(i)=cwork2(i)+conjg(dcoef(i))*cmplx(1./hchi(i),0.)*hvec(i)
      do 29 i=nwallf,ntot
      cwork1(i)=cwork1(i)+conjg(acoef(i))*
     %                     cmplx(-hchi(i)/(rmaj(i)*hpsi(i)),0.)*hvec(i)
   29 cwork2(i)=cwork2(i)+conjg(bcoef(i))*cmplx(-1./rmaj(i),0.)*hvec(i)
c
      call filtre(cwork1,2)
      call dpsitr(cwork1,cwork3)
      call dchitr(cwork2,cwork4)
c
      do 30 i=1,ntot
   30 result(i)=result(i)+cwork3(i)+cwork4(i)
c
      cwork1(1)=(0.,0.)
      do 40 i=1,norigl
   40 cwork1(1)=cwork1(1)+result(i)
      do 41 i=1,norigl
   41 result(i)=cwork1(1)
c
      return
      end
