      subroutine waveop(hvec,result)
      include 'SPRINC'
      real rmaj(nchi*npsi),zed(nchi*npsi),hpsi(nchi*npsi),
     %     hchi(nchi*npsi),psi(npsi),chi(nchi),pquad(npsi),pcoef(nchi)
      complex hvec(nchi*npsi),result(nchi*npsi),
     %        acoef(nchi*npsi),bcoef(nchi*npsi),
     %        ccoef(nchi*npsi),dcoef(nchi*npsi),
     %        cwork1(nchi*npsi),cwork2(nchi*npsi),
     %        cwork3(nchi*npsi),cwork4(nchi*npsi)
      common /metric/ rmaj,zed,hpsi,hchi,psi,chi,pquad,pcoef
     %       /cwork/ cwork1,cwork2,cwork3,cwork4
     %       /coef/ acoef,bcoef,ccoef,dcoef,ako2
c
c     WAVEOP calculates the wave operator acting on "hvec".  This is:
c     For 0<psi<1,
c      result = (    Dpsi [A*M/hpsi**2] Dpsi    +    Dchi [A*M/hchi**2] Dchi
c               +  Dpsi [B*M/(hpsi*hchi)] Dchi  -  Dchi [B*M/(hpsi*hchi)] Dpsi
c               +  ako2*M   ){hvec} ;
c       the wave equation is:  result = (0.,0.) .
c     For psi=0,
c      result = 0 , for chi<2.*pi ;
c      result = [a/(2.*pi*R] ( Integral(delchi) [1/P] Dpsi ){hvec} ,
c                                                         for chi=2.*pi ;
c       the boundary condition is:  result = (0.,0.) .
c     For psi=1,
c      result = (-hchi/rmaj)*( [A/hpsi] Dpsi  +  [B/hchi] Dchi ){hvec} ;
c       the boundary condition is:  result = hchi*Echi(psi=1) .
c
c     Where:  A = acoef, B = bcoef, M = hpsi*hchi/rmaj, and P = pcoef,
c             hpsi*[Dpsi{A*M/hpsi**2} - Dchi{B*M/(hpsi*hchi)}] = ccoef,
c             hchi*[Dchi{A*M/hchi**2} + Dpsi{B*M/(hpsi*hchi)}] = dcoef
c
c     Note:  A=1/Nperp**2   and   B/A=-iKcross/(Kperp-Nparallel**2)
c
      ntot=npsi*nchi
      norigl=nchi
      nbodyf=nchi+1
      nbodyl=ntot-nchi
      nwallf=ntot-nchi+1
      pi=4.*atan(1.)
      delchi=2.*pi/float(nchi)
c
      call dpsi(hvec,cwork1)
      call SPRFIL(cwork1,2)
      call dpsi(cwork1,cwork3)
      call SPRFIL(cwork3,2)
      call dchi(hvec,cwork2)
      call dchi(cwork2,cwork4)
c
      do 10 i=1,norigl
   10 result(i)=(0.,0.)
      do 11 i=1,norigl
   11 result(norigl)=result(norigl)+acoef(i)*
     %               cmplx(delchi/(2.*pi*rmaj(i)*pcoef(i)),0.)*cwork1(i)
      do 15 i=nbodyf,nbodyl
   15 result(i)=cmplx(ako2*hpsi(i)*hchi(i)/rmaj(i),0.)*hvec(i)+
     %          acoef(i)*(cmplx(hchi(i)/(hpsi(i)*rmaj(i)),0.)*cwork3(i)+
     %                    cmplx(hpsi(i)/(hchi(i)*rmaj(i)),0.)*cwork4(i))
     %         + ccoef(i)*cmplx(1./hpsi(i),0.)*cwork1(i)
     %         + dcoef(i)*cmplx(1./hchi(i),0.)*cwork2(i)
      do 19 i=nwallf,ntot
   19 result(i)=cmplx(-hchi(i)/(rmaj(i)*hpsi(i)),0.)*acoef(i)*cwork1(i)+
     %                         cmplx(-1./rmaj(i),0.)*bcoef(i)*cwork2(i)
c
      return
      end
