CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  ported for TRANSP dmc 23 Feb 1993
C  wired to explode for any value of I other than 4 or 6 !!!
C  I want to know if this routine is being used -- code portability
C  issues.  dmccune@pppl.gov
C
      INTEGER FUNCTION I1MACH(I)
C
C  I/O UNIT NUMBERS.
C
C    I1MACH( 1) = THE STANDARD INPUT UNIT.
C
C    I1MACH( 2) = THE STANDARD OUTPUT UNIT.
C
C    I1MACH( 3) = THE STANDARD PUNCH UNIT.
C
C    I1MACH( 4) = THE STANDARD ERROR MESSAGE UNIT.
C
C  WORDS.
C
C    I1MACH( 5) = THE NUMBER OF BITS PER INTEGER STORAGE UNIT.
C
C    I1MACH( 6) = THE NUMBER OF CHARACTERS PER INTEGER STORAGE UNIT.
C
C  INTEGERS.
C
C    ASSUME INTEGERS ARE REPRESENTED IN THE S-DIGIT, BASE-A FORM
C
C               SIGN ( X(S-1)*A**(S-1) + ... + X(1)*A + X(0) )
C
C               WHERE 0 .LE. X(I) .LT. A FOR I=0,...,S-1.
C
C    I1MACH( 7) = A, THE BASE.
C
C    I1MACH( 8) = S, THE NUMBER OF BASE-A DIGITS.
C
C    I1MACH( 9) = A**S - 1, THE LARGEST MAGNITUDE.
C
C  FLOATING-POINT NUMBERS.
C
C    ASSUME FLOATING-POINT NUMBERS ARE REPRESENTED IN THE T-DIGIT,
C    BASE-B FORM
C
C               SIGN (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C
C               WHERE 0 .LE. X(I) .LT. B FOR I=1,...,T,
C               0 .LT. X(1), AND EMIN .LE. E .LE. EMAX.
C
C    I1MACH(10) = B, THE BASE.
C
C  SINGLE-PRECISION
C
C    I1MACH(11) = T, THE NUMBER OF BASE-B DIGITS.
C
C    I1MACH(12) = EMIN, THE SMALLEST EXPONENT E.
C
C    I1MACH(13) = EMAX, THE LARGEST EXPONENT E.
C
C  DOUBLE-PRECISION
C
C    I1MACH(14) = T, THE NUMBER OF BASE-B DIGITS.
C
C    I1MACH(15) = EMIN, THE SMALLEST EXPONENT E.
C
C    I1MACH(16) = EMAX, THE LARGEST EXPONENT E.
C
C  TO ALTER THIS FUNCTION FOR A PARTICULAR ENVIRONMENT,
C  THE DESIRED SET OF DATA STATEMENTS SHOULD BE ACTIVATED BY
C  REMOVING THE C FROM COLUMN 1.  ALSO, THE VALUES OF
C  I1MACH(1) - I1MACH(4) SHOULD BE CHECKED FOR CONSISTENCY
C  WITH THE LOCAL OPERATING SYSTEM.
C
      INTEGER IMACH(16), OUTPUT
C
      EQUIVALENCE (IMACH(4),OUTPUT)
C
C     MACHINE CONSTANTS FOR THE VAX 11/780
C       mod dmc -- floating point exponent ranges set to not
C       exceed either VAX or IEEE floating point on unix workstations
C       i.e use a restrictive subset of the range available
C          double precision fractional bits = 53 on IEEE workstations
C       23 Feb 1993 -- for portable TRANSP
C
      DATA IMACH(1) /    5 /          !@
      DATA IMACH(2) /    6 /          !@
      DATA IMACH(3) /    5 /          !@
      DATA IMACH(4) /    6 /          !@
      DATA IMACH(5) /   32 /          !@
      DATA IMACH(6) /    4 /          !@
      DATA IMACH(7) /    2 /          !@
      DATA IMACH(8) /   31 /          !@
      DATA IMACH(9) /2147483647 /          !@
      DATA IMACH(10)/    2 /          !@
      DATA IMACH(11)/   24 /          !@
      DATA IMACH(12)/ -125 /          !@
      DATA IMACH(13)/  125 /          !@
      DATA IMACH(14)/   53 /          !@
      DATA IMACH(15)/ -125 /          !@
      DATA IMACH(16)/  125 /          !@
C
C     MACHINE CONSTANTS FOR THE CRAY 1
C
C@     DATA IMACH( 1) /   100 /
C@     DATA IMACH( 2) /   5 /
C@     DATA IMACH( 3) /   102 /
C@     DATA IMACH( 4) /   101 /
C@     DATA IMACH( 5) /    64 /
C@     DATA IMACH( 6) /     8 /
C@     DATA IMACH( 7) /     2 /
C@     DATA IMACH( 8) /    63 /
C@     DATA IMACH( 9) /  777777777777777777777B /
C@     DATA IMACH(10) /     2 /
C@     DATA IMACH(11) /    48 /
C@     DATA IMACH(12) / -8192 /
C@     DATA IMACH(13) /  8191 /
C@     DATA IMACH(14) /    96 /
C@     DATA IMACH(15) / -8192 /
C@     DATA IMACH(16) /  8191 /
C
C  ** something needed here for the JET IBM 3091 **
C
      IF (I.LT.1 .OR. I.GT.16) GO TO 10
C
C  dmc -- spike the code
	if((i.ne.4).and.(i.ne.6)) then
	    write(output,99998) i
99998	    format(' ?transp vsn i1mach(i):  i=',i2,' invalid!')
	    go to 10
	endif
C  end dmc
C
      I1MACH = IMACH(I)
      RETURN
C
   10 WRITE (OUTPUT,99999)
C
c  dmc -- force traceback
	call trdeath
c  end dmc
C
      STOP
C
99999 FORMAT (39H1ERROR    1 IN I1MACH - I OUT OF BOUNDS)
      END
